Require Import Metarouting.Logic.Logic.
Require Import Metarouting.Signatures.Bisemigroup.
Require Import Metarouting.Signatures.BisemigroupPropRecord.
Require Import Metarouting.Signatures.BisemigroupGlue.
Require Import Metarouting.Inference.Common.Common.
Require Import Metarouting.Inference.Semigroups.BoolOr.
Require Import Metarouting.Inference.Semigroups.BoolAnd.
Require Import Metarouting.Constructions.Bisemigroups.BoolOrAnd.

Definition boolOrAndBisemigroup_props : bsProp (boolOrAndBisemigroup).
   apply (Build_bsProp boolOrAndBisemigroup boolOrSemigroup_props boolAndSemigroup_props).

   (* IsLeftDistributive *)
   apply (opInit (@BoolOrAnd.isLeftDistributive)).
   apply None.

   (* IsRightDistributive *)
   apply (opInit (@BoolOrAnd.isRightDistributive)).
   apply None.

(*
   (* IsLeftCoDistributive *)
   apply (opInit (@BoolOrAnd.isLeftCoDistributive)).
   apply None.

   (* IsRightCoDistributive *)
   apply (opInit (@BoolOrAnd.isRightCoDistributive)).
   apply None.
*)

   (* PlusIdentityIsTimesAnnihilator *)
   apply (opInit (@BoolOrAnd.plusIdentityIsTimesAnnihilator)).
   apply None.

   (* PlusAnnihilatorIsTimesIdentity *)
   apply (opInit (@BoolOrAnd.plusAnnihilatorIsTimesIdentity)).
   apply None.

   (* IsRightStrictStable *)
   apply None.
   apply (opInit (@BoolOrAnd.isRightStrictStable_comp)).

   (* IsLeftStrictStable *)
   apply None.
   apply (opInit (@BoolOrAnd.isLeftStrictStable_comp)).

   (* IsRightCompEqCancel *)
   apply (opInit (@BoolOrAnd.isRightCompEqCancel)).
   apply None.

   (* IsLeftCompEqCancel *)
   apply (opInit (@BoolOrAnd.isLeftCompEqCancel)).
   apply None.

   (* IsRightCompCancel *)
   apply (opInit (@BoolOrAnd.isRightCompCancel)).
   apply None.

   (* IsLeftCompCancel *)
   apply (opInit (@BoolOrAnd.isLeftCompCancel)).
   apply None.

   (* LeftDiscrete *)
   apply None.
   apply (opInit (@BoolOrAnd.leftDiscrete_comp)).

   (* RightDiscrete *)
   apply None.
   apply (opInit (@BoolOrAnd.rightDiscrete_comp)).

   (* LeftComparable *)
   apply (opInit (@BoolOrAnd.leftComparable)).
   apply None.

   (* RightComparable *)
   apply (opInit (@BoolOrAnd.rightComparable)).
   apply None.

   (* LeftIncreasing *)
   apply (opInit (@BoolOrAnd.leftIncreasing)).
   apply None.

   (* RightIncreasing *)
   apply (opInit (@BoolOrAnd.rightIncreasing)).
   apply None.

   (* LeftStrictIncreasing *)
   apply None.
   apply (opInit (@BoolOrAnd.leftStrictIncreasing_comp)).

   (* RightStrictIncreasing *)
   apply None.
   apply (opInit (@BoolOrAnd.rightStrictIncreasing_comp)).

   (* IsRightTimesMapToIdConstantPlus *)
   apply None.
   apply (opInit (@BoolOrAnd.isRightTimesMapToIdConstantPlus_comp)).

   (* IsLeftTimesMapToIdConstantPlus *)
   apply None.
   apply (opInit (@BoolOrAnd.isLeftTimesMapToIdConstantPlus_comp)).

   (* PlusIdentityIsTimesLeftAnnihilator *)
   apply (opInit (@BoolOrAnd.plusIdentityIsTimesLeftAnnihilator)).
   apply None.

   (* PlusIdentityIsTimesRightAnnihilator *)
   apply (opInit (@BoolOrAnd.plusIdentityIsTimesRightAnnihilator)).
   apply None.
Defined.
