Require Import Metarouting.Logic.Logic.
Require Import Metarouting.Signatures.Bisemigroup.
Require Import Metarouting.Signatures.BisemigroupPropRecord.
Require Import Metarouting.Signatures.BisemigroupGlue.
Require Import Metarouting.Inference.Common.Common.
Require Import Metarouting.Inference.Semigroups.Unit.
Require Import Metarouting.Inference.Semigroups.NatMax.
Require Import Metarouting.Inference.Semigroups.NatPlus.
Require Import Metarouting.Inference.Semigroups.Union.
Require Import Metarouting.Constructions.Bisemigroups.NatIMaxPlus.

Definition natIMaxPlusBisemigroup_props : bsProp (natIMaxPlusBisemigroup).
   apply (Build_bsProp natIMaxPlusBisemigroup
         (projPlusBSmgIso _ _ _  (unionSemigroup_props unitSemigroup_props natMaxSemigroup_props))
         (projTimesBSmgIso _ _ _ (unionSemigroup_props unitSemigroup_props natPlusSemigroup_props))).

   (* IsLeftDistributive *)
   apply (opInit (@NatIMaxPlus.isLeftDistributive)).
   apply None.

   (* IsRightDistributive *)
   apply (opInit (@NatIMaxPlus.isRightDistributive)).
   apply None.

(*
   (* IsLeftCoDistributive *)
   apply None.
   apply (opInit (@NatIMaxPlus.isLeftCoDistributive_comp)).

   (* IsRightCoDistributive *)
   apply None.
   apply (opInit (@NatIMaxPlus.isRightCoDistributive_comp)).
*)

   (* PlusIdentityIsTimesAnnihilator *)
   apply None.
   apply (opInit (@NatIMaxPlus.plusIdentityIsTimesAnnihilator_comp)).

   (* PlusAnnihilatorIsTimesIdentity *)
   apply None.
   apply (opInit (@NatIMaxPlus.plusAnnihilatorIsTimesIdentity_comp)).

   (* IsRightStrictStable *)
   apply None.
   apply (opInit (@NatIMaxPlus.isRightStrictStable_comp)).

   (* IsLeftStrictStable *)
   apply None.
   apply (opInit (@NatIMaxPlus.isLeftStrictStable_comp)).

   (* IsRightCompEqCancel *)
   apply (opInit (@NatIMaxPlus.isRightCompEqCancel)).
   apply None.

   (* IsLeftCompEqCancel *)
   apply (opInit (@NatIMaxPlus.isLeftCompEqCancel)).
   apply None.

   (* IsRightCompCancel *)
   apply (opInit (@NatIMaxPlus.isRightCompCancel)).
   apply None.

   (* IsLeftCompCancel *)
   apply (opInit (@NatIMaxPlus.isLeftCompCancel)).
   apply None.

   (* LeftDiscrete *)
   apply None.
   apply (opInit (@NatIMaxPlus.leftDiscrete_comp)).

   (* RightDiscrete *)
   apply None.
   apply (opInit (@NatIMaxPlus.rightDiscrete_comp)).

   (* LeftComparable *)
   apply (opInit (@NatIMaxPlus.leftComparable)).
   apply None.

   (* RightComparable *)
   apply (opInit (@NatIMaxPlus.rightComparable)).
   apply None.

   (* LeftIncreasing *)
   apply None. (* UNKNOWN *)
   apply None. (* UNKNOWN *)

   (* RightIncreasing *)
   apply None. (* UNKNOWN *)
   apply None. (* UNKNOWN *)

   (* LeftStrictIncreasing *)
   apply None. (* UNKNOWN *)
   apply None. (* UNKNOWN *)

   (* RightStrictIncreasing *)
   apply None. (* UNKNOWN *)
   apply None. (* UNKNOWN *)

   (* IsRightTimesMapToIdConstantPlus *)
   apply None.
   apply (opInit (@NatIMaxPlus.isRightTimesMapToIdConstantPlus_comp)).

   (* IsLeftTimesMapToIdConstantPlus *)
   apply None.
   apply (opInit (@NatIMaxPlus.isLeftTimesMapToIdConstantPlus_comp)).

   (* PlusIdentityIsTimesLeftAnnihilator *)
   apply None.
   apply (opInit (@NatIMaxPlus.plusIdentityIsTimesLeftAnnihilator_comp)).

   (* PlusIdentityIsTimesRightAnnihilator *)
   apply None.
   apply (opInit (@NatIMaxPlus.plusIdentityIsTimesRightAnnihilator_comp)).
Defined.
