Require Import Metarouting.Logic.Logic.
Require Import Metarouting.Signatures.Bisemigroup.
Require Import Metarouting.Signatures.BisemigroupPropRecord.
Require Import Metarouting.Signatures.BisemigroupGlue.
Require Import Metarouting.Inference.Common.Common.
Require Import Metarouting.Inference.Semigroups.NatMax.
Require Import Metarouting.Inference.Semigroups.NatMin.
Require Import Metarouting.Constructions.Bisemigroups.NatMaxMin.

Definition natMaxMinBisemigroup_props : bsProp (natMaxMinBisemigroup).
   apply (Build_bsProp natMaxMinBisemigroup
         (projPlusBSmgIso _ _ _  natMaxSemigroup_props)
         (projTimesBSmgIso _ _ _ natMinSemigroup_props)).

   (* IsLeftDistributive *)
   apply (opInit (@NatMaxMin.isLeftDistributive)).
   apply None.

   (* IsRightDistributive *)
   apply (opInit (@NatMaxMin.isRightDistributive)).
   apply None.

(*
   (* IsLeftCoDistributive *)
   apply (opInit (@NatMaxMin.isLeftCoDistributive)).
   apply None.

   (* IsRightCoDistributive *)
   apply (opInit (@NatMaxMin.isRightCoDistributive)).
   apply None.
*)

   (* PlusIdentityIsTimesAnnihilator *)
   apply (opInit (@NatMaxMin.plusIdentityIsTimesAnnihilator)).
   apply None.

   (* PlusAnnihilatorIsTimesIdentity *)
   apply None.
   apply (opInit (@NatMaxMin.plusAnnihilatorIsTimesIdentity_comp)).

   (* IsRightStrictStable *)
   apply None.
   apply (opInit (@NatMaxMin.isRightStrictStable_comp)).

   (* IsLeftStrictStable *)
   apply None.
   apply (opInit (@NatMaxMin.isLeftStrictStable_comp)).

   (* IsRightCompEqCancel *)
   apply (opInit (@NatMaxMin.isRightCompEqCancel)).
   apply None.

   (* IsLeftCompEqCancel *)
   apply (opInit (@NatMaxMin.isLeftCompEqCancel)).
   apply None.

   (* IsRightCompCancel *)
   apply (opInit (@NatMaxMin.isRightCompCancel)).
   apply None.

   (* IsLeftCompCancel *)
   apply (opInit (@NatMaxMin.isLeftCompCancel)).
   apply None.

   (* LeftDiscrete *)
   apply None.
   apply (opInit (@NatMaxMin.leftDiscrete_comp)).

   (* RightDiscrete *)
   apply None.
   apply (opInit (@NatMaxMin.rightDiscrete_comp)).

   (* LeftComparable *)
   apply (opInit (@NatMaxMin.leftComparable)).
   apply None.

   (* RightComparable *)
   apply (opInit (@NatMaxMin.rightComparable)).
   apply None.

   (* LeftIncreasing *)
   apply (opInit (@NatMaxMin.leftIncreasing)).
   apply None.

   (* RightIncreasing *)
   apply (opInit (@NatMaxMin.rightIncreasing)).
   apply None.

   (* LeftStrictIncreasing *)
   apply None.
   apply (opInit (@NatMaxMin.leftStrictIncreasing_comp)).

   (* RightStrictIncreasing *)
   apply None.
   apply (opInit (@NatMaxMin.rightStrictIncreasing_comp)).

   (* IsRightTimesMapToIdConstantPlus *)
   apply None.
   apply (opInit (@NatMaxMin.isRightTimesMapToIdConstantPlus_comp)).

   (* IsLeftTimesMapToIdConstantPlus *)
   apply None.
   apply (opInit (@NatMaxMin.isLeftTimesMapToIdConstantPlus_comp)).

   (* PlusIdentityIsTimesLeftAnnihilator *)
   apply (opInit (@NatMaxMin.plusIdentityIsTimesLeftAnnihilator)).
   apply None.

   (* PlusIdentityIsTimesRightAnnihilator *)
   apply (opInit (@NatMaxMin.plusIdentityIsTimesRightAnnihilator)).
   apply None.
Defined.
