Require Import Metarouting.Logic.Logic.
Require Import Metarouting.Signatures.Bisemigroup.
Require Import Metarouting.Signatures.BisemigroupPropRecord.
Require Import Metarouting.Signatures.BisemigroupGlue.
Require Import Metarouting.Inference.Common.Common.
Require Import Metarouting.Inference.Semigroups.NatMax.
Require Import Metarouting.Inference.Semigroups.NatPlus.
Require Import Metarouting.Constructions.Bisemigroups.NatMaxPlus.

Definition natMaxPlusBisemigroup_props : bsProp (natMaxPlusBisemigroup).
   apply (Build_bsProp natMaxPlusBisemigroup
         (projPlusBSmgIso _ _ _  natMaxSemigroup_props)
         (projTimesBSmgIso _ _ _ natPlusSemigroup_props)).

   (* IsLeftDistributive *)
   apply (opInit (@NatMaxPlus.isLeftDistributive)).
   apply None.

   (* IsRightDistributive *)
   apply (opInit (@NatMaxPlus.isRightDistributive)).
   apply None.

(*
   (* IsLeftCoDistributive *)
   apply None.
   apply (opInit (@NatMaxPlus.isLeftCoDistributive_comp)).

   (* IsRightCoDistributive *)
   apply None.
   apply (opInit (@NatMaxPlus.isRightCoDistributive_comp)).
*)

   (* PlusIdentityIsTimesAnnihilator *)
   apply None.
   apply (opInit (@NatMaxPlus.plusIdentityIsTimesAnnihilator_comp)).

   (* PlusAnnihilatorIsTimesIdentity *)
   apply None.
   apply (opInit (@NatMaxPlus.plusAnnihilatorIsTimesIdentity_comp)).

   (* IsRightStrictStable *)
   apply (opInit (@NatMaxPlus.isRightStrictStable)).
   apply None.

   (* IsLeftStrictStable *)
   apply (opInit (@NatMaxPlus.isLeftStrictStable)).
   apply None.

   (* IsRightCompEqCancel *)
   apply (opInit (@NatMaxPlus.isRightCompEqCancel)).
   apply None.

   (* IsLeftCompEqCancel *)
   apply (opInit (@NatMaxPlus.isLeftCompEqCancel)).
   apply None.

   (* IsRightCompCancel *)
   apply (opInit (@NatMaxPlus.isRightCompCancel)).
   apply None.

   (* IsLeftCompCancel *)
   apply (opInit (@NatMaxPlus.isLeftCompCancel)).
   apply None.

   (* LeftDiscrete *)
   apply None.
   apply (opInit (@NatMaxPlus.leftDiscrete_comp)).

   (* RightDiscrete *)
   apply None.
   apply (opInit (@NatMaxPlus.rightDiscrete_comp)).

   (* LeftComparable *)
   apply (opInit (@NatMaxPlus.leftComparable)).
   apply None.

   (* RightComparable *)
   apply (opInit (@NatMaxPlus.rightComparable)).
   apply None.

   (* LeftIncreasing *)
   apply None.
   apply (opInit (@NatMaxPlus.leftIncreasing_comp)).

   (* RightIncreasing *)
   apply None.
   apply (opInit (@NatMaxPlus.rightIncreasing_comp)).

   (* LeftStrictIncreasing *)
   apply None.
   apply (opInit (@NatMaxPlus.leftStrictIncreasing_comp)).

   (* RightStrictIncreasing *)
   apply None.
   apply (opInit (@NatMaxPlus.rightStrictIncreasing_comp)).

   (* IsRightTimesMapToIdConstantPlus *)
   apply None.
   apply (opInit (@NatMaxPlus.isRightTimesMapToIdConstantPlus_comp)).

   (* IsLeftTimesMapToIdConstantPlus *)
   apply None.
   apply (opInit (@NatMaxPlus.isLeftTimesMapToIdConstantPlus_comp)).

   (* PlusIdentityIsTimesLeftAnnihilator *)
   apply None.
   apply (opInit (@NatMaxPlus.plusIdentityIsTimesLeftAnnihilator_comp)).

   (* PlusIdentityIsTimesRightAnnihilator *)
   apply None.
   apply (opInit (@NatMaxPlus.plusIdentityIsTimesRightAnnihilator_comp)).
Defined.
