Require Import Metarouting.Logic.Logic.
Require Import Metarouting.Signatures.Bisemigroup.
Require Import Metarouting.Signatures.BisemigroupPropRecord.
Require Import Metarouting.Signatures.BisemigroupGlue.
Require Import Metarouting.Inference.Common.Common.
Require Import Metarouting.Inference.Semigroups.NatMin.
Require Import Metarouting.Inference.Semigroups.NatPlus.
Require Import Metarouting.Constructions.Bisemigroups.NatMinPlus.

Definition natMinPlusBisemigroup_props : bsProp (natMinPlusBisemigroup).
   apply (Build_bsProp natMinPlusBisemigroup
         (projPlusBSmgIso _ _ _  natMinSemigroup_props)
         (projTimesBSmgIso _ _ _ natPlusSemigroup_props)).

   (* IsLeftDistributive *)
   apply (opInit (@NatMinPlus.isLeftDistributive)).
   apply None.

   (* IsRightDistributive *)
   apply (opInit (@NatMinPlus.isRightDistributive)).
   apply None.

(*
   (* IsLeftCoDistributive *)
   apply None.
   apply (opInit (@NatMinPlus.isLeftCoDistributive_comp)).

   (* IsRightCoDistributive *)
   apply None.
   apply (opInit (@NatMinPlus.isRightCoDistributive_comp)).
*)

   (* PlusIdentityIsTimesAnnihilator *)
   apply None.
   apply (opInit (@NatMinPlus.plusIdentityIsTimesAnnihilator_comp)).

   (* PlusAnnihilatorIsTimesIdentity *)
   apply (opInit (@NatMinPlus.plusAnnihilatorIsTimesIdentity)).
   apply None.

   (* IsRightStrictStable *)
   apply (opInit (@NatMinPlus.isRightStrictStable)).
   apply None.

   (* IsLeftStrictStable *)
   apply (opInit (@NatMinPlus.isLeftStrictStable)).
   apply None.

   (* IsRightCompEqCancel *)
   apply (opInit (@NatMinPlus.isRightCompEqCancel)).
   apply None.

   (* IsLeftCompEqCancel *)
   apply (opInit (@NatMinPlus.isLeftCompEqCancel)).
   apply None.

   (* IsRightCompCancel *)
   apply (opInit (@NatMinPlus.isRightCompCancel)).
   apply None.

   (* IsLeftCompCancel *)
   apply (opInit (@NatMinPlus.isLeftCompCancel)).
   apply None.

   (* LeftDiscrete *)
   apply None.
   apply (opInit (@NatMinPlus.leftDiscrete_comp)).

   (* RightDiscrete *)
   apply None.
   apply (opInit (@NatMinPlus.rightDiscrete_comp)).

   (* LeftComparable *)
   apply (opInit (@NatMinPlus.leftComparable)).
   apply None.

   (* RightComparable *)
   apply (opInit (@NatMinPlus.rightComparable)).
   apply None.

   (* LeftIncreasing *)
   apply (opInit (@NatMinPlus.leftIncreasing)).
   apply None.

   (* RightIncreasing *)
   apply (opInit (@NatMinPlus.rightIncreasing)).
   apply None.

   (* LeftStrictIncreasing *)
   apply None.
   apply (opInit (@NatMinPlus.leftStrictIncreasing_comp)).

   (* RightStrictIncreasing *)
   apply None.
   apply (opInit (@NatMinPlus.rightStrictIncreasing_comp)).

   (* IsRightTimesMapToIdConstantPlus *)
   apply (opInit (@NatMinPlus.isRightTimesMapToIdConstantPlus)).
   apply None.

   (* IsLeftTimesMapToIdConstantPlus *)
   apply (opInit (@NatMinPlus.isLeftTimesMapToIdConstantPlus)).
   apply None.

   (* PlusIdentityIsTimesLeftAnnihilator *)
   apply (opInit (@NatMinPlus.plusIdentityIsTimesLeftAnnihilator)).
   apply None.

   (* PlusIdentityIsTimesRightAnnihilator *)
   apply (opInit (@NatMinPlus.plusIdentityIsTimesRightAnnihilator)).
   apply None.
Defined.
