Require Import Metarouting.Logic.Logic.
Require Import Metarouting.Signatures.Bisemigroup.
Require Import Metarouting.Signatures.BisemigroupPropRecord.
Require Import Metarouting.Signatures.BisemigroupGlue.
Require Import Metarouting.Inference.Common.Common.
Require Import Metarouting.Inference.Semigroups.Unit.
Require Import Metarouting.Constructions.Bisemigroups.Unit.

Definition unitBisemigroup_props : bsProp (unitBisemigroup).
   apply (Build_bsProp unitBisemigroup
         (projPlusBSmgIso _ _ _  unitSemigroup_props)
         (projTimesBSmgIso _ _ _ unitSemigroup_props)).

   (* IsLeftDistributive *)
   apply (opInit (@Unit.isLeftDistributive)).
   apply None.

   (* IsRightDistributive *)
   apply (opInit (@Unit.isRightDistributive)).
   apply None.

(*
   (* IsLeftCoDistributive *)
   apply (opInit (@Unit.isLeftCoDistributive)).
   apply None.

   (* IsRightCoDistributive *)
   apply (opInit (@Unit.isRightCoDistributive)).
   apply None.
*)

   (* PlusIdentityIsTimesAnnihilator *)
   apply (opInit (@Unit.plusIdentityIsTimesAnnihilator)).
   apply None.

   (* PlusAnnihilatorIsTimesIdentity *)
   apply (opInit (@Unit.plusAnnihilatorIsTimesIdentity)).
   apply None.

   (* IsRightStrictStable *)
   apply (opInit (@Unit.isRightStrictStable)).
   apply None.

   (* IsLeftStrictStable *)
   apply (opInit (@Unit.isLeftStrictStable)).
   apply None.

   (* IsRightCompEqCancel *)
   apply (opInit (@Unit.isRightCompEqCancel)).
   apply None.

   (* IsLeftCompEqCancel *)
   apply (opInit (@Unit.isLeftCompEqCancel)).
   apply None.

   (* IsRightCompCancel *)
   apply (opInit (@Unit.isRightCompCancel)).
   apply None.

   (* IsLeftCompCancel *)
   apply (opInit (@Unit.isLeftCompCancel)).
   apply None.

   (* LeftDiscrete *)
   apply (opInit (@Unit.leftDiscrete)).
   apply None.

   (* RightDiscrete *)
   apply (opInit (@Unit.rightDiscrete)).
   apply None.

   (* LeftComparable *)
   apply (opInit (@Unit.leftComparable)).
   apply None.

   (* RightComparable *)
   apply (opInit (@Unit.rightComparable)).
   apply None.

   (* LeftIncreasing *)
   apply (opInit (@Unit.leftIncreasing)).
   apply None.

   (* RightIncreasing *)
   apply (opInit (@Unit.rightIncreasing)).
   apply None.

   (* LeftStrictIncreasing *)
   apply None.
   apply (opInit (@Unit.leftStrictIncreasing_comp)).

   (* RightStrictIncreasing *)
   apply None.
   apply (opInit (@Unit.rightStrictIncreasing_comp)).

   (* IsRightTimesMapToIdConstantPlus *)
   apply (opInit (@Unit.isRightTimesMapToIdConstantPlus)).
   apply None.

   (* IsLeftTimesMapToIdConstantPlus *)
   apply (opInit (@Unit.isLeftTimesMapToIdConstantPlus)).
   apply None.

   (* PlusIdentityIsTimesLeftAnnihilator *)
   apply (opInit (@Unit.plusIdentityIsTimesLeftAnnihilator)).
   apply None.

   (* PlusIdentityIsTimesRightAnnihilator *)
   apply (opInit (@Unit.plusIdentityIsTimesRightAnnihilator)).
   apply None.
Defined.
