Require Import Metarouting.Logic.Logic.
Require Import Metarouting.Signatures.DecSetoid.
Require Import Metarouting.Signatures.Semigroup.
Require Import Metarouting.Signatures.Preorder.
Require Import Metarouting.Signatures.OrderSemigroup.
Require Import Metarouting.Signatures.Bisemigroup.
Require Import Metarouting.Constructions.OrderSemigroups.Glue.
Require Import Metarouting.Constructions.Bisemigroups.GlueSemigroups.
   
   Lemma projSmgOSmg : forall A B e, A = glue A B e.
   Proof. intros A B e.
      destruct A; destruct B; simpl in *.
      destruct setoid; destruct setoid0; simpl in *.
      unfold DsEq in e; simpl in *.
      destruct e; simpl.
      unfold semigroupOS; simpl. 
      auto.
   Qed.

   Lemma projProOSmg : forall A B e, B = glue A B e.
   Proof. intros A B e.
      destruct A; destruct B; simpl in *.
      destruct setoid; destruct setoid0; simpl in *.
      unfold DsEq in e; simpl in *.
      destruct e; simpl.
      unfold preorderOS; simpl. 
      auto.
   Qed.

   Lemma projPlusBSmg : forall A B e, A = plusSmg (glueBSmg A B e).
   Proof. intros A B e.
      destruct A; destruct B; simpl in *.
      destruct setoid; destruct setoid0; simpl in *.
      unfold DsEq in e; simpl in *.
      destruct e; simpl.
      unfold plusSmg; simpl.
      auto.
   Qed.

   Lemma projTimesBSmg : forall A B e, B = timesSmg (glueBSmg A B e).
   Proof. intros A B e.
      destruct A; destruct B; simpl in *.
      destruct setoid; destruct setoid0; simpl in *.
      unfold DsEq in e; simpl in *.
      destruct e; simpl.
      unfold timesSmg; simpl.
      auto.
   Qed.
