open Bisemigroup
open BisemigroupProperties
open LeftNaturalOrder
open OrderSemigroup
open OrderSemigroupGlue
open OrderSemigroupProperties
open SemigroupProperties
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val bsLeftNaturalOrder : coq_Bisemigroup -> coq_OrderSemigroup **)

let bsLeftNaturalOrder b =
  glueOSmg (timesSmg b) (leftNaturalOrder (plusSmg b))

(** val leftOpNonDecreasing_comp :
    coq_Bisemigroup -> coq_RightIncreasing_comp ->
    coq_LeftOpNonDecreasing_comp **)

let leftOpNonDecreasing_comp b x =
  let Coq_existT (x0, s) = x __ __ in
  let Coq_existT (y, _) = s in Coq_existT (x0, (Coq_existT (y, __)))

(** val rightOpNonDecreasing_comp :
    coq_Bisemigroup -> coq_LeftIncreasing_comp ->
    coq_RightOpNonDecreasing_comp **)

let rightOpNonDecreasing_comp b x =
  let Coq_existT (x0, s) = x __ __ in
  let Coq_existT (y, _) = s in Coq_existT (x0, (Coq_existT (y, __)))

(** val leftOpIncreasing_comp :
    coq_Bisemigroup -> coq_RightStrictIncreasing_comp ->
    coq_LeftOpIncreasing_comp **)

let leftOpIncreasing_comp b x =
  let Coq_existT (x0, s) = x __ __ in
  let Coq_existT (y, _) = s in Coq_existT (x0, (Coq_existT (y, __)))

(** val rightOpIncreasing_comp :
    coq_Bisemigroup -> coq_LeftStrictIncreasing_comp ->
    coq_RightOpIncreasing_comp **)

let rightOpIncreasing_comp b x =
  let Coq_existT (x0, s) = x __ __ in
  let Coq_existT (y, _) = s in Coq_existT (x0, (Coq_existT (y, __)))

(** val leftEquivCondensed_comp :
    coq_Bisemigroup -> coq_LeftCondensed_comp -> coq_LeftEquivCondensed_comp **)

let leftEquivCondensed_comp b = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, s0) = s in
      let Coq_existT (z, _) = s0 in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (z, __)))))

(** val rightEquivCondensed_comp :
    coq_Bisemigroup -> coq_RightCondensed_comp ->
    coq_RightEquivCondensed_comp **)

let rightEquivCondensed_comp b = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, s0) = s in
      let Coq_existT (z, _) = s0 in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (z, __)))))

(** val rightTotal_comp :
    coq_Bisemigroup -> coq_RightComparable_comp -> coq_RightTotal_comp **)

let rightTotal_comp b x =
  let Coq_existT (x0, s) = x __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (z, (Coq_existT (x0, (Coq_existT (y, __)))))

(** val leftTotal_comp :
    coq_Bisemigroup -> coq_LeftComparable_comp -> coq_LeftTotal_comp **)

let leftTotal_comp b x =
  let Coq_existT (x0, s) = x __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (z, (Coq_existT (x0, (Coq_existT (y, __)))))

