open DecSetoid
open Semigroup
open Specif

type __ = Obj.t

type coq_Bisemigroup = { setoid : coq_DecSetoid;
                         plus : (carrier -> carrier -> carrier);
                         times : (carrier -> carrier -> carrier) }

val coq_Bisemigroup_rect :
  (coq_DecSetoid -> (carrier -> carrier -> carrier) -> (carrier -> carrier ->
  carrier) -> __ -> __ -> __ -> __ -> 'a1) -> coq_Bisemigroup -> 'a1

val coq_Bisemigroup_rec :
  (coq_DecSetoid -> (carrier -> carrier -> carrier) -> (carrier -> carrier ->
  carrier) -> __ -> __ -> __ -> __ -> 'a1) -> coq_Bisemigroup -> 'a1

val setoid : coq_Bisemigroup -> coq_DecSetoid

val plus : coq_Bisemigroup -> carrier -> carrier -> carrier

val times : coq_Bisemigroup -> carrier -> carrier -> carrier

val plusSmg : coq_Bisemigroup -> coq_Semigroup

val timesSmg : coq_Bisemigroup -> coq_Semigroup

val coq_IsBSmgIso_rect :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_DsIso -> (__ -> __ -> __ -> __ ->
  'a1) -> 'a1

val coq_IsBSmgIso_rec :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_DsIso -> (__ -> __ -> __ -> __ ->
  'a1) -> 'a1

type coq_BSmgIso =
  coq_DsIso
  (* singleton inductive, whose constructor was Build_BSmgIso *)

val coq_BSmgIso_rect :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_DsIso -> __ -> 'a1) ->
  coq_BSmgIso -> 'a1

val coq_BSmgIso_rec :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_DsIso -> __ -> 'a1) ->
  coq_BSmgIso -> 'a1

val dsIso : coq_Bisemigroup -> coq_Bisemigroup -> coq_BSmgIso -> coq_DsIso

val plusSmgBSmgIso :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_BSmgIso -> coq_SmgIso

val timesSmgBSmgIso :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_BSmgIso -> coq_SmgIso

val coq_BSmgIso_refl : coq_Bisemigroup -> coq_BSmgIso

val coq_BSmgIso_sym :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_BSmgIso -> coq_BSmgIso

val coq_BSmgIso_trans :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_Bisemigroup -> coq_BSmgIso ->
  coq_BSmgIso -> coq_BSmgIso

val liftBSmgIso :
  coq_DecSetoid -> coq_Bisemigroup -> coq_DsIso -> (coq_Bisemigroup,
  coq_BSmgIso * __) sigT

