open Bisemigroup
open BisemigroupProperties
open Cayley
open DecSetoid
open SemigroupTransform
open SemigroupTransformGlue
open SemigroupTransformProperties
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val cayleyMapSemigroupTransform :
    coq_Bisemigroup -> coq_SemigroupTransform **)

let cayleyMapSemigroupTransform a =
  glueSTf_DsEq (plusSmg a) (cayleyMapTransform (timesSmg a))

(** val distributive_comp :
    coq_Bisemigroup -> coq_IsLeftDistributive_comp -> coq_Distributive_comp **)

let distributive_comp a = function
  | Coq_existT (a0, s) ->
      let Coq_existT (b, s0) = s in
      let Coq_existT (c, _) = s0 in
      Coq_existT (a0, (Coq_existT (b, (Coq_existT (c, __)))))

(** val inflationary_comp :
    coq_Bisemigroup -> coq_LeftIncreasing_comp -> (carrier, (carrier, __)
    sigT) sigT **)

let inflationary_comp a lc =
  let Coq_existT (a0, s) = lc __ __ in
  let Coq_existT (b, _) = s in Coq_existT (a0, (Coq_existT (b, __)))

(** val strictInflationary_comp :
    coq_Bisemigroup -> coq_LeftStrictIncreasing_comp -> (carrier, (carrier,
    __) sigT) sigT **)

let strictInflationary_comp a lsc =
  let Coq_existT (a0, s) = lsc __ __ in
  let Coq_existT (b, _) = s in Coq_existT (a0, (Coq_existT (b, __)))

(** val strict_comp :
    coq_Bisemigroup -> coq_PlusIdentityIsTimesRightAnnihilator_comp ->
    coq_Strict_comp **)

let strict_comp a p hasId =
  let Coq_existT (f, _) = p hasId in Coq_existT (f, __)

