open DecSetoidPropRecord
open Semigroup
open SemigroupPropRecord
open Specif
open TransformPropRecord

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val cayleyMapTransform_props : coq_Semigroup -> sgProp -> tfProp **)

let cayleyMapTransform_props a ap =
  { tf_dsprop = ap.sg_dsprop; tf_fndsprop = ap.sg_dsprop; cancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match leftCancelative0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); cancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match leftCancelative_comp0 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (b, s0) = s in
           let Coq_existT (c, _) = s0 in
           Coq_existT (a1, (Coq_existT (b, (Coq_existT (c, __))))))
       | None -> None)); condensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match leftCondensed0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); condensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match leftCondensed_comp0 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (b, s0) = s in
           let Coq_existT (c, _) = s0 in
           Coq_existT (b, (Coq_existT (c, (Coq_existT (a1, __))))))
       | None -> None)) }

