open Bisemigroup
open BisemigroupPropRecord
open Cayley
open Cayley3
open DecSetoidPropRecord
open SemigroupPropRecord
open SemigroupTransform
open SemigroupTransformGlue
open SemigroupTransformPropRecord
open Specif
open TransformPropRecord

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val cayleyMapSemigroupTransform_props :
    coq_Bisemigroup -> bsProp -> stProp **)

let cayleyMapSemigroupTransform_props a ap =
  let sgp =
    sgPropIso (plusSmg a)
      (semigroupST
        (glueSTf_DsEq (plusSmg a) (cayleyMapTransform (timesSmg a))))
      (glueSTfSmg_DsEq (plusSmg a) (cayleyMapTransform (timesSmg a)))
      (ap.bs_plus_sgprop)
  in
  let tfp =
    tfPropIso (cayleyMapTransform (timesSmg a))
      (transformST
        (glueSTf_DsEq (plusSmg a) (cayleyMapTransform (timesSmg a))))
      (glueSTfTf_DsEq (plusSmg a) (cayleyMapTransform (timesSmg a)))
      (cayleyMapTransform_props (timesSmg a) (ap.bs_times_sgprop))
  in
  { st_sgprop = sgp; st_tfprop = tfp; distributive =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop = bs_times_sgprop0;
    isLeftDistributive = isLeftDistributive0; isLeftDistributive_comp =
    isLeftDistributive_comp0; isRightDistributive = isRightDistributive0;
    isRightDistributive_comp = isRightDistributive_comp0;
    plusIdentityIsTimesAnnihilator = plusIdentityIsTimesAnnihilator0;
    plusIdentityIsTimesAnnihilator_comp =
    plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
    plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
    plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
    isRightStrictStable0; isRightStrictStable_comp =
    isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
    isLeftStrictStable_comp = isLeftStrictStable_comp0; isRightCompEqCancel =
    isRightCompEqCancel0; isRightCompEqCancel_comp =
    isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
    isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0; isRightCompCancel =
    isRightCompCancel0; isRightCompCancel_comp = isRightCompCancel_comp0;
    isLeftCompCancel = isLeftCompCancel0; isLeftCompCancel_comp =
    isLeftCompCancel_comp0; leftDiscrete = leftDiscrete0; leftDiscrete_comp =
    leftDiscrete_comp0; rightDiscrete = rightDiscrete0; rightDiscrete_comp =
    rightDiscrete_comp0; leftComparable = leftComparable0;
    leftComparable_comp = leftComparable_comp0; rightComparable =
    rightComparable0; rightComparable_comp = rightComparable_comp0;
    leftIncreasing = leftIncreasing0; leftIncreasing_comp =
    leftIncreasing_comp0; rightIncreasing = rightIncreasing0;
    rightIncreasing_comp = rightIncreasing_comp0; leftStrictIncreasing =
    leftStrictIncreasing0; leftStrictIncreasing_comp =
    leftStrictIncreasing_comp0; rightStrictIncreasing =
    rightStrictIncreasing0; rightStrictIncreasing_comp =
    rightStrictIncreasing_comp0; isRightTimesMapToIdConstantPlus =
    isRightTimesMapToIdConstantPlus0; isRightTimesMapToIdConstantPlus_comp =
    isRightTimesMapToIdConstantPlus_comp0; isLeftTimesMapToIdConstantPlus =
    isLeftTimesMapToIdConstantPlus0; isLeftTimesMapToIdConstantPlus_comp =
    isLeftTimesMapToIdConstantPlus_comp0;
    plusIdentityIsTimesLeftAnnihilator = plusIdentityIsTimesLeftAnnihilator0;
    plusIdentityIsTimesLeftAnnihilator_comp =
    plusIdentityIsTimesLeftAnnihilator_comp0;
    plusIdentityIsTimesRightAnnihilator =
    plusIdentityIsTimesRightAnnihilator0;
    plusIdentityIsTimesRightAnnihilator_comp =
    plusIdentityIsTimesRightAnnihilator_comp0 } = ap
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = bs_times_sgprop0
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = bs_plus_sgprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_dsprop0
  in
  (match isLeftDistributive0 with
     | Some a0 -> Some (Obj.magic __ a0)
     | None -> None)); distributive_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop = bs_times_sgprop0;
    isLeftDistributive = isLeftDistributive0; isLeftDistributive_comp =
    isLeftDistributive_comp0; isRightDistributive = isRightDistributive0;
    isRightDistributive_comp = isRightDistributive_comp0;
    plusIdentityIsTimesAnnihilator = plusIdentityIsTimesAnnihilator0;
    plusIdentityIsTimesAnnihilator_comp =
    plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
    plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
    plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
    isRightStrictStable0; isRightStrictStable_comp =
    isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
    isLeftStrictStable_comp = isLeftStrictStable_comp0; isRightCompEqCancel =
    isRightCompEqCancel0; isRightCompEqCancel_comp =
    isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
    isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0; isRightCompCancel =
    isRightCompCancel0; isRightCompCancel_comp = isRightCompCancel_comp0;
    isLeftCompCancel = isLeftCompCancel0; isLeftCompCancel_comp =
    isLeftCompCancel_comp0; leftDiscrete = leftDiscrete0; leftDiscrete_comp =
    leftDiscrete_comp0; rightDiscrete = rightDiscrete0; rightDiscrete_comp =
    rightDiscrete_comp0; leftComparable = leftComparable0;
    leftComparable_comp = leftComparable_comp0; rightComparable =
    rightComparable0; rightComparable_comp = rightComparable_comp0;
    leftIncreasing = leftIncreasing0; leftIncreasing_comp =
    leftIncreasing_comp0; rightIncreasing = rightIncreasing0;
    rightIncreasing_comp = rightIncreasing_comp0; leftStrictIncreasing =
    leftStrictIncreasing0; leftStrictIncreasing_comp =
    leftStrictIncreasing_comp0; rightStrictIncreasing =
    rightStrictIncreasing0; rightStrictIncreasing_comp =
    rightStrictIncreasing_comp0; isRightTimesMapToIdConstantPlus =
    isRightTimesMapToIdConstantPlus0; isRightTimesMapToIdConstantPlus_comp =
    isRightTimesMapToIdConstantPlus_comp0; isLeftTimesMapToIdConstantPlus =
    isLeftTimesMapToIdConstantPlus0; isLeftTimesMapToIdConstantPlus_comp =
    isLeftTimesMapToIdConstantPlus_comp0;
    plusIdentityIsTimesLeftAnnihilator = plusIdentityIsTimesLeftAnnihilator0;
    plusIdentityIsTimesLeftAnnihilator_comp =
    plusIdentityIsTimesLeftAnnihilator_comp0;
    plusIdentityIsTimesRightAnnihilator =
    plusIdentityIsTimesRightAnnihilator0;
    plusIdentityIsTimesRightAnnihilator_comp =
    plusIdentityIsTimesRightAnnihilator_comp0 } = ap
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = bs_times_sgprop0
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = bs_plus_sgprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_dsprop0
  in
  (match isLeftDistributive_comp0 with
     | Some a0 -> Some
         (let Coq_existT (a1, s) = a0 in
         let Coq_existT (b, s0) = s in
         let Coq_existT (c, _) = s0 in
         Coq_existT (a1, (Coq_existT (b, (Coq_existT (c, __))))))
     | None -> None)); inflationary =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop = bs_times_sgprop0;
    isLeftDistributive = isLeftDistributive0; isLeftDistributive_comp =
    isLeftDistributive_comp0; isRightDistributive = isRightDistributive0;
    isRightDistributive_comp = isRightDistributive_comp0;
    plusIdentityIsTimesAnnihilator = plusIdentityIsTimesAnnihilator0;
    plusIdentityIsTimesAnnihilator_comp =
    plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
    plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
    plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
    isRightStrictStable0; isRightStrictStable_comp =
    isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
    isLeftStrictStable_comp = isLeftStrictStable_comp0; isRightCompEqCancel =
    isRightCompEqCancel0; isRightCompEqCancel_comp =
    isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
    isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0; isRightCompCancel =
    isRightCompCancel0; isRightCompCancel_comp = isRightCompCancel_comp0;
    isLeftCompCancel = isLeftCompCancel0; isLeftCompCancel_comp =
    isLeftCompCancel_comp0; leftDiscrete = leftDiscrete0; leftDiscrete_comp =
    leftDiscrete_comp0; rightDiscrete = rightDiscrete0; rightDiscrete_comp =
    rightDiscrete_comp0; leftComparable = leftComparable0;
    leftComparable_comp = leftComparable_comp0; rightComparable =
    rightComparable0; rightComparable_comp = rightComparable_comp0;
    leftIncreasing = leftIncreasing0; leftIncreasing_comp =
    leftIncreasing_comp0; rightIncreasing = rightIncreasing0;
    rightIncreasing_comp = rightIncreasing_comp0; leftStrictIncreasing =
    leftStrictIncreasing0; leftStrictIncreasing_comp =
    leftStrictIncreasing_comp0; rightStrictIncreasing =
    rightStrictIncreasing0; rightStrictIncreasing_comp =
    rightStrictIncreasing_comp0; isRightTimesMapToIdConstantPlus =
    isRightTimesMapToIdConstantPlus0; isRightTimesMapToIdConstantPlus_comp =
    isRightTimesMapToIdConstantPlus_comp0; isLeftTimesMapToIdConstantPlus =
    isLeftTimesMapToIdConstantPlus0; isLeftTimesMapToIdConstantPlus_comp =
    isLeftTimesMapToIdConstantPlus_comp0;
    plusIdentityIsTimesLeftAnnihilator = plusIdentityIsTimesLeftAnnihilator0;
    plusIdentityIsTimesLeftAnnihilator_comp =
    plusIdentityIsTimesLeftAnnihilator_comp0;
    plusIdentityIsTimesRightAnnihilator =
    plusIdentityIsTimesRightAnnihilator0;
    plusIdentityIsTimesRightAnnihilator_comp =
    plusIdentityIsTimesRightAnnihilator_comp0 } = ap
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = bs_times_sgprop0
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = bs_plus_sgprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_dsprop0
  in
  (match leftIncreasing0 with
     | Some a0 -> Some (Obj.magic __ a0)
     | None -> None)); inflationary_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop = bs_times_sgprop0;
    isLeftDistributive = isLeftDistributive0; isLeftDistributive_comp =
    isLeftDistributive_comp0; isRightDistributive = isRightDistributive0;
    isRightDistributive_comp = isRightDistributive_comp0;
    plusIdentityIsTimesAnnihilator = plusIdentityIsTimesAnnihilator0;
    plusIdentityIsTimesAnnihilator_comp =
    plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
    plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
    plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
    isRightStrictStable0; isRightStrictStable_comp =
    isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
    isLeftStrictStable_comp = isLeftStrictStable_comp0; isRightCompEqCancel =
    isRightCompEqCancel0; isRightCompEqCancel_comp =
    isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
    isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0; isRightCompCancel =
    isRightCompCancel0; isRightCompCancel_comp = isRightCompCancel_comp0;
    isLeftCompCancel = isLeftCompCancel0; isLeftCompCancel_comp =
    isLeftCompCancel_comp0; leftDiscrete = leftDiscrete0; leftDiscrete_comp =
    leftDiscrete_comp0; rightDiscrete = rightDiscrete0; rightDiscrete_comp =
    rightDiscrete_comp0; leftComparable = leftComparable0;
    leftComparable_comp = leftComparable_comp0; rightComparable =
    rightComparable0; rightComparable_comp = rightComparable_comp0;
    leftIncreasing = leftIncreasing0; leftIncreasing_comp =
    leftIncreasing_comp0; rightIncreasing = rightIncreasing0;
    rightIncreasing_comp = rightIncreasing_comp0; leftStrictIncreasing =
    leftStrictIncreasing0; leftStrictIncreasing_comp =
    leftStrictIncreasing_comp0; rightStrictIncreasing =
    rightStrictIncreasing0; rightStrictIncreasing_comp =
    rightStrictIncreasing_comp0; isRightTimesMapToIdConstantPlus =
    isRightTimesMapToIdConstantPlus0; isRightTimesMapToIdConstantPlus_comp =
    isRightTimesMapToIdConstantPlus_comp0; isLeftTimesMapToIdConstantPlus =
    isLeftTimesMapToIdConstantPlus0; isLeftTimesMapToIdConstantPlus_comp =
    isLeftTimesMapToIdConstantPlus_comp0;
    plusIdentityIsTimesLeftAnnihilator = plusIdentityIsTimesLeftAnnihilator0;
    plusIdentityIsTimesLeftAnnihilator_comp =
    plusIdentityIsTimesLeftAnnihilator_comp0;
    plusIdentityIsTimesRightAnnihilator =
    plusIdentityIsTimesRightAnnihilator0;
    plusIdentityIsTimesRightAnnihilator_comp =
    plusIdentityIsTimesRightAnnihilator_comp0 } = ap
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = bs_times_sgprop0
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = bs_plus_sgprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_dsprop0
  in
  (match leftIncreasing_comp0 with
     | Some a0 -> Some (fun _ _ ->
         let Coq_existT (a1, s) = a0 __ __ in
         let Coq_existT (b, _) = s in Coq_existT (a1, (Coq_existT (b, __))))
     | None -> None)); strictInflationary =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop = bs_times_sgprop0;
    isLeftDistributive = isLeftDistributive0; isLeftDistributive_comp =
    isLeftDistributive_comp0; isRightDistributive = isRightDistributive0;
    isRightDistributive_comp = isRightDistributive_comp0;
    plusIdentityIsTimesAnnihilator = plusIdentityIsTimesAnnihilator0;
    plusIdentityIsTimesAnnihilator_comp =
    plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
    plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
    plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
    isRightStrictStable0; isRightStrictStable_comp =
    isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
    isLeftStrictStable_comp = isLeftStrictStable_comp0; isRightCompEqCancel =
    isRightCompEqCancel0; isRightCompEqCancel_comp =
    isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
    isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0; isRightCompCancel =
    isRightCompCancel0; isRightCompCancel_comp = isRightCompCancel_comp0;
    isLeftCompCancel = isLeftCompCancel0; isLeftCompCancel_comp =
    isLeftCompCancel_comp0; leftDiscrete = leftDiscrete0; leftDiscrete_comp =
    leftDiscrete_comp0; rightDiscrete = rightDiscrete0; rightDiscrete_comp =
    rightDiscrete_comp0; leftComparable = leftComparable0;
    leftComparable_comp = leftComparable_comp0; rightComparable =
    rightComparable0; rightComparable_comp = rightComparable_comp0;
    leftIncreasing = leftIncreasing0; leftIncreasing_comp =
    leftIncreasing_comp0; rightIncreasing = rightIncreasing0;
    rightIncreasing_comp = rightIncreasing_comp0; leftStrictIncreasing =
    leftStrictIncreasing0; leftStrictIncreasing_comp =
    leftStrictIncreasing_comp0; rightStrictIncreasing =
    rightStrictIncreasing0; rightStrictIncreasing_comp =
    rightStrictIncreasing_comp0; isRightTimesMapToIdConstantPlus =
    isRightTimesMapToIdConstantPlus0; isRightTimesMapToIdConstantPlus_comp =
    isRightTimesMapToIdConstantPlus_comp0; isLeftTimesMapToIdConstantPlus =
    isLeftTimesMapToIdConstantPlus0; isLeftTimesMapToIdConstantPlus_comp =
    isLeftTimesMapToIdConstantPlus_comp0;
    plusIdentityIsTimesLeftAnnihilator = plusIdentityIsTimesLeftAnnihilator0;
    plusIdentityIsTimesLeftAnnihilator_comp =
    plusIdentityIsTimesLeftAnnihilator_comp0;
    plusIdentityIsTimesRightAnnihilator =
    plusIdentityIsTimesRightAnnihilator0;
    plusIdentityIsTimesRightAnnihilator_comp =
    plusIdentityIsTimesRightAnnihilator_comp0 } = ap
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = bs_times_sgprop0
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = bs_plus_sgprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_dsprop0
  in
  (match leftStrictIncreasing0 with
     | Some a0 -> Some (Obj.magic __ a0)
     | None -> None)); strictInflationary_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop = bs_times_sgprop0;
    isLeftDistributive = isLeftDistributive0; isLeftDistributive_comp =
    isLeftDistributive_comp0; isRightDistributive = isRightDistributive0;
    isRightDistributive_comp = isRightDistributive_comp0;
    plusIdentityIsTimesAnnihilator = plusIdentityIsTimesAnnihilator0;
    plusIdentityIsTimesAnnihilator_comp =
    plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
    plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
    plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
    isRightStrictStable0; isRightStrictStable_comp =
    isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
    isLeftStrictStable_comp = isLeftStrictStable_comp0; isRightCompEqCancel =
    isRightCompEqCancel0; isRightCompEqCancel_comp =
    isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
    isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0; isRightCompCancel =
    isRightCompCancel0; isRightCompCancel_comp = isRightCompCancel_comp0;
    isLeftCompCancel = isLeftCompCancel0; isLeftCompCancel_comp =
    isLeftCompCancel_comp0; leftDiscrete = leftDiscrete0; leftDiscrete_comp =
    leftDiscrete_comp0; rightDiscrete = rightDiscrete0; rightDiscrete_comp =
    rightDiscrete_comp0; leftComparable = leftComparable0;
    leftComparable_comp = leftComparable_comp0; rightComparable =
    rightComparable0; rightComparable_comp = rightComparable_comp0;
    leftIncreasing = leftIncreasing0; leftIncreasing_comp =
    leftIncreasing_comp0; rightIncreasing = rightIncreasing0;
    rightIncreasing_comp = rightIncreasing_comp0; leftStrictIncreasing =
    leftStrictIncreasing0; leftStrictIncreasing_comp =
    leftStrictIncreasing_comp0; rightStrictIncreasing =
    rightStrictIncreasing0; rightStrictIncreasing_comp =
    rightStrictIncreasing_comp0; isRightTimesMapToIdConstantPlus =
    isRightTimesMapToIdConstantPlus0; isRightTimesMapToIdConstantPlus_comp =
    isRightTimesMapToIdConstantPlus_comp0; isLeftTimesMapToIdConstantPlus =
    isLeftTimesMapToIdConstantPlus0; isLeftTimesMapToIdConstantPlus_comp =
    isLeftTimesMapToIdConstantPlus_comp0;
    plusIdentityIsTimesLeftAnnihilator = plusIdentityIsTimesLeftAnnihilator0;
    plusIdentityIsTimesLeftAnnihilator_comp =
    plusIdentityIsTimesLeftAnnihilator_comp0;
    plusIdentityIsTimesRightAnnihilator =
    plusIdentityIsTimesRightAnnihilator0;
    plusIdentityIsTimesRightAnnihilator_comp =
    plusIdentityIsTimesRightAnnihilator_comp0 } = ap
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = bs_times_sgprop0
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = bs_plus_sgprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_dsprop0
  in
  (match leftStrictIncreasing_comp0 with
     | Some a0 -> Some (fun _ _ ->
         let Coq_existT (a1, s) = a0 __ __ in
         let Coq_existT (b, _) = s in Coq_existT (a1, (Coq_existT (b, __))))
     | None -> None)); strict =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop = bs_times_sgprop0;
    isLeftDistributive = isLeftDistributive0; isLeftDistributive_comp =
    isLeftDistributive_comp0; isRightDistributive = isRightDistributive0;
    isRightDistributive_comp = isRightDistributive_comp0;
    plusIdentityIsTimesAnnihilator = plusIdentityIsTimesAnnihilator0;
    plusIdentityIsTimesAnnihilator_comp =
    plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
    plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
    plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
    isRightStrictStable0; isRightStrictStable_comp =
    isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
    isLeftStrictStable_comp = isLeftStrictStable_comp0; isRightCompEqCancel =
    isRightCompEqCancel0; isRightCompEqCancel_comp =
    isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
    isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0; isRightCompCancel =
    isRightCompCancel0; isRightCompCancel_comp = isRightCompCancel_comp0;
    isLeftCompCancel = isLeftCompCancel0; isLeftCompCancel_comp =
    isLeftCompCancel_comp0; leftDiscrete = leftDiscrete0; leftDiscrete_comp =
    leftDiscrete_comp0; rightDiscrete = rightDiscrete0; rightDiscrete_comp =
    rightDiscrete_comp0; leftComparable = leftComparable0;
    leftComparable_comp = leftComparable_comp0; rightComparable =
    rightComparable0; rightComparable_comp = rightComparable_comp0;
    leftIncreasing = leftIncreasing0; leftIncreasing_comp =
    leftIncreasing_comp0; rightIncreasing = rightIncreasing0;
    rightIncreasing_comp = rightIncreasing_comp0; leftStrictIncreasing =
    leftStrictIncreasing0; leftStrictIncreasing_comp =
    leftStrictIncreasing_comp0; rightStrictIncreasing =
    rightStrictIncreasing0; rightStrictIncreasing_comp =
    rightStrictIncreasing_comp0; isRightTimesMapToIdConstantPlus =
    isRightTimesMapToIdConstantPlus0; isRightTimesMapToIdConstantPlus_comp =
    isRightTimesMapToIdConstantPlus_comp0; isLeftTimesMapToIdConstantPlus =
    isLeftTimesMapToIdConstantPlus0; isLeftTimesMapToIdConstantPlus_comp =
    isLeftTimesMapToIdConstantPlus_comp0;
    plusIdentityIsTimesLeftAnnihilator = plusIdentityIsTimesLeftAnnihilator0;
    plusIdentityIsTimesLeftAnnihilator_comp =
    plusIdentityIsTimesLeftAnnihilator_comp0;
    plusIdentityIsTimesRightAnnihilator =
    plusIdentityIsTimesRightAnnihilator0;
    plusIdentityIsTimesRightAnnihilator_comp =
    plusIdentityIsTimesRightAnnihilator_comp0 } = ap
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = bs_times_sgprop0
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = bs_plus_sgprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_dsprop0
  in
  (match plusIdentityIsTimesRightAnnihilator0 with
     | Some a0 -> Some (Obj.magic __ a0)
     | None -> None)); strict_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop = bs_times_sgprop0;
    isLeftDistributive = isLeftDistributive0; isLeftDistributive_comp =
    isLeftDistributive_comp0; isRightDistributive = isRightDistributive0;
    isRightDistributive_comp = isRightDistributive_comp0;
    plusIdentityIsTimesAnnihilator = plusIdentityIsTimesAnnihilator0;
    plusIdentityIsTimesAnnihilator_comp =
    plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
    plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
    plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
    isRightStrictStable0; isRightStrictStable_comp =
    isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
    isLeftStrictStable_comp = isLeftStrictStable_comp0; isRightCompEqCancel =
    isRightCompEqCancel0; isRightCompEqCancel_comp =
    isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
    isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0; isRightCompCancel =
    isRightCompCancel0; isRightCompCancel_comp = isRightCompCancel_comp0;
    isLeftCompCancel = isLeftCompCancel0; isLeftCompCancel_comp =
    isLeftCompCancel_comp0; leftDiscrete = leftDiscrete0; leftDiscrete_comp =
    leftDiscrete_comp0; rightDiscrete = rightDiscrete0; rightDiscrete_comp =
    rightDiscrete_comp0; leftComparable = leftComparable0;
    leftComparable_comp = leftComparable_comp0; rightComparable =
    rightComparable0; rightComparable_comp = rightComparable_comp0;
    leftIncreasing = leftIncreasing0; leftIncreasing_comp =
    leftIncreasing_comp0; rightIncreasing = rightIncreasing0;
    rightIncreasing_comp = rightIncreasing_comp0; leftStrictIncreasing =
    leftStrictIncreasing0; leftStrictIncreasing_comp =
    leftStrictIncreasing_comp0; rightStrictIncreasing =
    rightStrictIncreasing0; rightStrictIncreasing_comp =
    rightStrictIncreasing_comp0; isRightTimesMapToIdConstantPlus =
    isRightTimesMapToIdConstantPlus0; isRightTimesMapToIdConstantPlus_comp =
    isRightTimesMapToIdConstantPlus_comp0; isLeftTimesMapToIdConstantPlus =
    isLeftTimesMapToIdConstantPlus0; isLeftTimesMapToIdConstantPlus_comp =
    isLeftTimesMapToIdConstantPlus_comp0;
    plusIdentityIsTimesLeftAnnihilator = plusIdentityIsTimesLeftAnnihilator0;
    plusIdentityIsTimesLeftAnnihilator_comp =
    plusIdentityIsTimesLeftAnnihilator_comp0;
    plusIdentityIsTimesRightAnnihilator =
    plusIdentityIsTimesRightAnnihilator0;
    plusIdentityIsTimesRightAnnihilator_comp =
    plusIdentityIsTimesRightAnnihilator_comp0 } = ap
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = bs_times_sgprop0
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = bs_plus_sgprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_dsprop0
  in
  (match plusIdentityIsTimesRightAnnihilator_comp0 with
     | Some a0 -> Some (fun hasId ->
         let Coq_existT (f, _) = a0 hasId in Coq_existT (f, __))
     | None -> None)) }

