open DecSetoidPropRecord
open Preorder
open PreorderPropRecord
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val dualPreorder_props : coq_Preorder -> poProp -> poProp **)

let dualPreorder_props a ap =
  { pp_dsprop = ap.pp_dsprop; hasTop =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = pp_dsprop0
    in
    (match hasBottom0 with
       | Some a0 -> Some (let Coq_existT (b, _) = a0 in Coq_existT (b, __))
       | None -> None)); hasTop_comp =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = pp_dsprop0
    in
    (match hasBottom_comp0 with
       | Some a0 -> Some (fun x ->
           let Coq_existT (a1, _) = a0 x in Coq_existT (a1, __))
       | None -> None)); hasBottom =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = pp_dsprop0
    in
    (match hasTop0 with
       | Some a0 -> Some (let Coq_existT (t, _) = a0 in Coq_existT (t, __))
       | None -> None)); hasBottom_comp =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = pp_dsprop0
    in
    (match hasTop_comp0 with
       | Some a0 -> Some (fun x ->
           let Coq_existT (a1, _) = a0 x in Coq_existT (a1, __))
       | None -> None)); total =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = pp_dsprop0
    in
    (match total0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); total_comp =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = pp_dsprop0
    in
    (match total_comp0 with
       | Some a0 -> Some
           (let Coq_existT (x, s) = a0 in
           let Coq_existT (y, _) = s in Coq_existT (y, (Coq_existT (x, __))))
       | None -> None)); antisym =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = pp_dsprop0
    in
    (match antisym0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); antisym_comp =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = pp_dsprop0
    in
    (match antisym_comp0 with
       | Some a0 -> Some
           (let Coq_existT (x, s) = a0 in
           let Coq_existT (y, _) = s in Coq_existT (x, (Coq_existT (y, __))))
       | None -> None)) }

