open DecSetoidPropRecord
open Dual
open Dual3
open OrderSemigroup
open OrderSemigroupGlue
open OrderSemigroupPropRecord
open PreorderPropRecord
open SemigroupPropRecord
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val dualOrderSemigroup_props : coq_OrderSemigroup -> osProp -> osProp **)

let dualOrderSemigroup_props a ap =
  { os_sgprop =
    (projSmgOSmgIso (semigroupOS a) (dualPreorder (preorderOS a))
      ap.os_sgprop); os_poprop =
    (projProOSmgIso (semigroupOS a) (dualPreorder (preorderOS a))
      (dualPreorder_props (preorderOS a) ap.os_poprop)); leftMonotonic =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match leftMonotonic0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); leftMonotonic_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match leftMonotonic_comp0 with
       | Some a0 -> Some
           (let Coq_existT (x, s) = a0 in
           let Coq_existT (y, s0) = s in
           let Coq_existT (z, _) = s0 in
           Coq_existT (x, (Coq_existT (z, (Coq_existT (y, __))))))
       | None -> None)); rightMonotonic =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match rightMonotonic0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); rightMonotonic_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match rightMonotonic_comp0 with
       | Some a0 -> Some
           (let Coq_existT (x, s) = a0 in
           let Coq_existT (y, s0) = s in
           let Coq_existT (z, _) = s0 in
           Coq_existT (y, (Coq_existT (x, (Coq_existT (z, __))))))
       | None -> None)); topIsAnnihilator =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); topIsAnnihilator_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); topIsIdentity =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); topIsIdentity_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); bottomIsAnnihilator =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); bottomIsAnnihilator_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); bottomIsIdentity =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); bottomIsIdentity_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); leftOpNonDecreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); leftOpNonDecreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); rightOpNonDecreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); rightOpNonDecreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); selectiveOpNonDecreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); selectiveOpNonDecreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); leftOpIncreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); leftOpIncreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); rightOpIncreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); rightOpIncreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); leftEquivCancelative =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match leftEquivCancelative0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); leftEquivCancelative_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match leftEquivCancelative_comp0 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (b, s0) = s in
           let Coq_existT (c, _) = s0 in
           Coq_existT (b, (Coq_existT (a1, (Coq_existT (c, __))))))
       | None -> None)); rightEquivCancelative =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match rightEquivCancelative0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); rightEquivCancelative_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match rightEquivCancelative_comp0 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (b, s0) = s in
           let Coq_existT (c, _) = s0 in
           Coq_existT (b, (Coq_existT (a1, (Coq_existT (c, __))))))
       | None -> None)); leftEquivCondensed =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match leftEquivCondensed0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); leftEquivCondensed_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match leftEquivCondensed_comp0 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (b, s0) = s in
           let Coq_existT (c, _) = s0 in
           Coq_existT (a1, (Coq_existT (c, (Coq_existT (b, __))))))
       | None -> None)); rightEquivCondensed =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match rightEquivCondensed0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); rightEquivCondensed_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match rightEquivCondensed_comp0 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (b, s0) = s in
           let Coq_existT (c, _) = s0 in
           Coq_existT (a1, (Coq_existT (c, (Coq_existT (b, __))))))
       | None -> None)); incompArrowUniqueSrc =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); incompArrowUniqueSrc_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); incompArrowFactor =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); incompArrowFactor_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None) }

