open AstBS
open AstDS
open AstOS
open AstPO
open AstSG
open AstST
open AstTF
open Bisemigroup
open BisemigroupPropRecord
open Datatypes
open DecSetoid
open DecSetoidPropRecord
open OcamlTypes
open OrderSemigroup
open OrderSemigroupPropRecord
open Preorder
open PreorderPropRecord
open Semantics
open Semigroup
open SemigroupPropRecord
open SemigroupTransform
open SemigroupTransformPropRecord
open Specif
open Syntax
open Transform
open TransformPropRecord

val semF :
  ((((((coq_DS -> ((coq_DecSetoid, dsProp * coq_DsSemRel) sigT, coq_NotWF)
  sum) * (coq_SG -> ((coq_Semigroup, sgProp * coq_SgSemRel) sigT, coq_NotWF)
  sum)) * (coq_PO -> ((coq_Preorder, poProp * coq_PoSemRel) sigT, coq_NotWF)
  sum)) * (coq_OS -> ((coq_OrderSemigroup, osProp * coq_OsSemRel) sigT,
  coq_NotWF) sum)) * (coq_BS -> ((coq_Bisemigroup, bsProp * coq_BsSemRel)
  sigT, coq_NotWF) sum)) * (coq_TF -> ((coq_Transform, tfProp * coq_TfSemRel)
  sigT, coq_NotWF) sum)) * (coq_ST -> ((coq_SemigroupTransform, stProp *
  coq_StSemRel) sigT, coq_NotWF) sum)

val dsSemF : coq_DS -> (coq_DecSetoidSem, coq_NotWF) sum

val sgSemF : coq_SG -> (coq_SemigroupSem, coq_NotWF) sum

val poSemF : coq_PO -> (coq_PreorderSem, coq_NotWF) sum

val osSemF : coq_OS -> (coq_OrderSemigroupSem, coq_NotWF) sum

val bsSemF : coq_BS -> (coq_BisemigroupSem, coq_NotWF) sum

val tfSemF : coq_TF -> (coq_TransformSem, coq_NotWF) sum

val stSemF : coq_ST -> (coq_SemigroupTransformSem, coq_NotWF) sum

val otDS : coq_DS -> ocamlTypes

val otSG : coq_SG -> ocamlTypes

val otPO : coq_PO -> ocamlTypes

val otOS : coq_OS -> ocamlTypes

val otBS : coq_BS -> ocamlTypes

val otLang : coq_Lang -> ocamlTypes

type wfAst = OcamlTypes.wfAst

val toAst : ocamlTypes -> ocmType -> OcamlTypes.wfAst

val fromAst : ocamlTypes -> OcamlTypes.wfAst -> ocmType

val ast_forget : ocamlTypes -> OcamlTypes.wfAst -> ast

val astDS : coq_DecSetoid -> ocamlTypes -> (coq_DecSetoid, coq_DsIso) sigT

val astSG : coq_Semigroup -> ocamlTypes -> (coq_Semigroup, coq_SmgIso) sigT

val astPO : coq_Preorder -> ocamlTypes -> (coq_Preorder, coq_ProIso) sigT

val astOS :
  coq_OrderSemigroup -> ocamlTypes -> (coq_OrderSemigroup, coq_OSmgIso) sigT

val astBS :
  coq_Bisemigroup -> ocamlTypes -> (coq_Bisemigroup, coq_BSmgIso) sigT

val astTF :
  coq_Transform -> ocamlTypes -> ocamlTypes -> (coq_Transform, coq_TfIso)
  sigT

val astST :
  coq_SemigroupTransform -> ocamlTypes -> ocamlTypes ->
  (coq_SemigroupTransform, coq_STfIso) sigT

