open Datatypes
open DecSetoid
open FMinSets
open FSetOp
open FSets
open List0
open Logic0
open OrderSemigroup
open OrderSemigroupProperties
open Preorder
open Semigroup
open SemigroupProperties
open Specif

type __ = Obj.t

val mset_op : coq_OrderSemigroup -> carrier -> carrier -> carrier

val upper_op_elim :
  coq_OrderSemigroup -> carrier -> carrier -> carrier -> (carrier, (carrier,
  __) sigT) sigT

val msetOpSemigroup : coq_OrderSemigroup -> coq_Semigroup

val isIdempotent_comp :
  coq_OrderSemigroup -> (coq_IsIdempotent_comp, __ *
  coq_SelectiveOpNonDecreasing_comp) sum -> coq_IsIdempotent_comp

val isCommutative_comp :
  coq_OrderSemigroup -> coq_IsCommutative_comp -> coq_IsCommutative_comp

val hasIdentity : coq_OrderSemigroup -> coq_HasIdentity -> coq_HasIdentity

val hasAnnihilator : coq_OrderSemigroup -> coq_HasAnnihilator

val isLeft_comp : coq_OrderSemigroup -> coq_IsLeft_comp

val isRight_comp : coq_OrderSemigroup -> coq_IsRight_comp

val leftCondensed_comp : coq_OrderSemigroup -> coq_LeftCondensed_comp

val rightCondensed_comp : coq_OrderSemigroup -> coq_RightCondensed_comp

val leftCancelative_comp : coq_OrderSemigroup -> coq_LeftCancelative_comp

val rightCancelative_comp : coq_OrderSemigroup -> coq_RightCancelative_comp

val antiRight_comp : coq_OrderSemigroup -> coq_AntiRight_comp

val antiLeft_comp : coq_OrderSemigroup -> coq_AntiLeft_comp

val sel_dec : coq_OrderSemigroup -> carrier -> carrier -> (__, __) sum

val coq_Lrel_dec : coq_OrderSemigroup -> carrier -> carrier -> (__, __) sum

val coq_Rrel_dec : coq_OrderSemigroup -> carrier -> carrier -> (__, __) sum

val coq_Arel_dec : coq_OrderSemigroup -> carrier -> carrier -> (__, __) sum

val rel_dec :
  coq_OrderSemigroup -> carrier -> carrier -> (((__, __) sum, __) sum, __)
  sum

val coq_LR_comp_eq :
  coq_OrderSemigroup -> carrier -> carrier -> carrier -> (__, __) sum

val coq_RL_comp_eq :
  coq_OrderSemigroup -> carrier -> carrier -> carrier -> (__, __) sum

type coq_AntichainChoiceComparable_comp =
  (carrier, (carrier, __ * (carrier, __) sigT) sigT) sigT

type coq_AntichainArrowUniqueSrc_comp =
  (carrier, (carrier, __ * (carrier, __) sigT) sigT) sigT

type coq_AntichainChoiceMidleOrder_comp =
  (carrier, (carrier, __ * (carrier, __) sigT) sigT) sigT

type coq_AntichainMiddleElm_comp =
  (carrier, (carrier, __ * (carrier, __) sigT) sigT) sigT

type coq_CE = coq_IsSelective_comp

val acc_CE_1 : coq_OrderSemigroup -> carrier -> carrier -> carrier -> coq_CE

val acc_CE_2 : coq_OrderSemigroup -> carrier -> carrier -> carrier -> coq_CE

val acc_CE_3 : coq_OrderSemigroup -> carrier -> carrier -> carrier -> coq_CE

val acc_CE_4 : coq_OrderSemigroup -> carrier -> carrier -> carrier -> coq_CE

val acc_CE_5 : coq_OrderSemigroup -> carrier -> carrier -> carrier -> coq_CE

val acc_CE :
  coq_OrderSemigroup -> coq_AntichainChoiceComparable_comp -> coq_CE

val aaus_CE_1 :
  coq_OrderSemigroup -> carrier -> carrier -> carrier -> (__, __) sum ->
  coq_CE

val aaus_CE_2 :
  coq_OrderSemigroup -> carrier -> carrier -> carrier -> (__, __) sum ->
  coq_CE

val aaus_CE_3 :
  coq_OrderSemigroup -> carrier -> carrier -> carrier -> (__, __) sum ->
  coq_CE

val aaus_CE :
  coq_OrderSemigroup -> coq_AntichainArrowUniqueSrc_comp -> coq_CE

val acmo_CE :
  coq_OrderSemigroup -> coq_AntichainChoiceMidleOrder_comp -> coq_CE

val ame_CE : coq_OrderSemigroup -> coq_AntichainMiddleElm_comp -> coq_CE

val mset_L_single_dec :
  coq_OrderSemigroup -> carrier -> carrier -> (__, (carrier, __) sigT) sum

val mset_L_dec :
  coq_OrderSemigroup -> carrier -> carrier -> (__, (carrier, (carrier, __)
  sigT) sigT) sum

val mset_R_single_dec :
  coq_OrderSemigroup -> carrier -> carrier -> (__, (carrier, __) sigT) sum

val mset_R_dec :
  coq_OrderSemigroup -> carrier -> carrier -> (__, (carrier, (carrier, __)
  sigT) sigT) sum

val coq_LR_Arel :
  coq_OrderSemigroup -> carrier -> carrier -> carrier -> carrier -> (__, __)
  sum

val mset_dec_1 :
  coq_OrderSemigroup -> carrier -> carrier -> carrier -> (carrier, (carrier,
  __) sigT) sigT

val coq_Emset : coq_OrderSemigroup -> carrier -> bool

type coq_Smset = (carrier, __) sigT

type coq_Tmset = (carrier, (carrier, __) sigT) sigT

type coq_Amset = (carrier, (carrier, __) sigT) sigT

val coq_Amset_rev :
  coq_OrderSemigroup -> carrier -> carrier -> coq_Amset -> coq_Amset

val coq_Amset_rev_2 :
  coq_OrderSemigroup -> carrier -> carrier -> coq_Amset -> coq_Amset

val mset_dec : coq_OrderSemigroup -> carrier -> ((__, __) sum, coq_Amset) sum

val mset_empty_dec :
  coq_OrderSemigroup -> carrier -> (__, (carrier, __) sigT) sum

val mset_red : coq_OrderSemigroup -> carrier -> (carrier, __) sigT

val mset_red_2 : coq_OrderSemigroup -> carrier -> (carrier, __) sigT

val coq_LR_mset_order :
  coq_OrderSemigroup -> carrier -> carrier -> coq_Tmset -> coq_Tmset -> (__,
  __) sum

val mset_size_dec :
  coq_OrderSemigroup -> carrier -> ((__, coq_Smset) sum, coq_Tmset) sum

val coq_Tmset_neq :
  coq_OrderSemigroup -> carrier -> carrier -> coq_Tmset -> (carrier, __) sigT

val isSelective_comp :
  coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
  (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
  coq_IsSelective_comp

