open Datatypes
open DecSetoidPropRecord
open FMinSets3
open FMinSetsOp
open Logic0
open OrderSemigroup
open OrderSemigroupPropRecord
open PreorderPropRecord
open SemigroupPropRecord
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val msetOpSemigroup_props : coq_OrderSemigroup -> osProp -> sgProp **)

let msetOpSemigroup_props a ap =
  { sg_dsprop = (msetDecSetoid_props (preorderOS a) ap.os_poprop);
    hasIdentity =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match hasIdentity0 with
       | Some a0 -> Some
           (let Coq_existT (a1, _) = a0 in
           Coq_existT ((Obj.magic (a1 :: [])), __))
       | None -> None)); hasIdentity_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); hasAnnihilator =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    opInit (Coq_existT ((Obj.magic []), __))); hasAnnihilator_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); isSelective =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match isSelective0 with
       | Some a0 ->
           (match isSelective_comp0 with
              | Some a1 -> Some (Obj.magic __ (a0 , (Coq_inl a1)))
              | None ->
                  (match incompArrowUniqueSrc0 with
                     | Some a1 ->
                         (match incompArrowFactor0 with
                            | Some b -> Some
                                (Obj.magic __ (a0 , (Coq_inr (a1 , b))))
                            | None -> None)
                     | None -> None))
       | None -> None)); isSelective_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match isSelective_comp0 with
       | Some a0 -> Some (FMinSetsOp.isSelective_comp a (Coq_inl a0))
       | None ->
           (match isSelective0 with
              | Some a0 ->
                  (match incompArrowUniqueSrc_comp0 with
                     | Some a1 -> Some
                         (FMinSetsOp.isSelective_comp a (Coq_inr (a0 ,
                           (Coq_inl a1))))
                     | None ->
                         (match incompArrowFactor_comp0 with
                            | Some b -> Some
                                (FMinSetsOp.isSelective_comp a (Coq_inr (a0 ,
                                  (Coq_inr b))))
                            | None -> None))
              | None -> None))); isCommutative =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match isCommutative0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isCommutative_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match isCommutative_comp0 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (b, _) = s in
           Coq_existT ((Obj.magic (a1 :: [])), (Coq_existT
           ((Obj.magic (b :: [])), __))))
       | None -> None)); isIdempotent =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match isIdempotent0 with
       | Some a0 ->
           (match isIdempotent_comp0 with
              | Some a1 -> Some (Obj.magic __ (a0 , (Coq_inl a1)))
              | None ->
                  (match selectiveOpNonDecreasing0 with
                     | Some b -> Some (Obj.magic __ (a0 , (Coq_inr b)))
                     | None -> None))
       | None -> None)); isIdempotent_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    (match isIdempotent_comp0 with
       | Some a0 -> Some
           (let Coq_existT (x, _) = a0 in
           Coq_existT ((Obj.magic (x :: [])), __))
       | None ->
           (match isIdempotent0 with
              | Some a0 ->
                  (match selectiveOpNonDecreasing_comp0 with
                     | Some b -> Some
                         (let Coq_existT (x, s) = b __ __ in
                         let Coq_existT (y, _) = s in
                         Coq_existT ((Obj.magic (x :: (y :: []))), __))
                     | None -> None)
              | None -> None))); isLeft =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); isLeft_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    opInit (FMinSetsOp.isLeft_comp a)); isRight =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); isRight_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    opInit (FMinSetsOp.isRight_comp a)); leftCondensed =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); leftCondensed_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    opInit (FMinSetsOp.leftCondensed_comp a)); rightCondensed =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); rightCondensed_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    opInit (FMinSetsOp.rightCondensed_comp a)); leftCancelative =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); leftCancelative_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    opInit (FMinSetsOp.leftCancelative_comp a)); rightCancelative =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); rightCancelative_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    opInit (FMinSetsOp.rightCancelative_comp a)); antiLeft =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); antiLeft_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    opInit (Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))));
    antiRight =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); antiRight_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    opInit (Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))));
    treeGlb =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None); treeGlb_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      os_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
      hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp = hasBottom_comp0;
      total = total0; total_comp = total_comp0; antisym = antisym0;
      antisym_comp = antisym_comp0 } = os_poprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = pp_dsprop0
    in
    None) }

