open Bisemigroup
open BisemigroupGlue
open BisemigroupProperties
open Datatypes
open DecSetoid
open FMinSets
open FMinSetsOp
open FMinSetsUnion
open OrderSemigroup
open OrderSemigroupProperties
open SemigroupProperties
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val minsetOpUnionBisemigroup : coq_OrderSemigroup -> coq_Bisemigroup **)

let minsetOpUnionBisemigroup a =
  glueBSmg (msetOpSemigroup a) (msetUnionSemigroup (preorderOS a))

(** val isLeftDistributive_comp :
    coq_OrderSemigroup -> ((coq_IsIdempotent_comp,
    coq_LeftOpNonDecreasing_comp) sum, coq_RightOpNonDecreasing_comp) sum ->
    coq_IsLeftDistributive_comp **)

let isLeftDistributive_comp a = function
  | Coq_inl s ->
      (match s with
         | Coq_inl i ->
             let Coq_existT (x0, _) = i in
             Coq_existT ((Obj.magic []), (Coq_existT (
             (Obj.magic []), (Coq_existT ((Obj.magic (x0 :: [])), __)))))
         | Coq_inr l ->
             let Coq_existT (x0, s0) = l in
             let Coq_existT (y, _) = s0 in
             Coq_existT ((Obj.magic []), (Coq_existT (
             (Obj.magic (y :: [])), (Coq_existT ((Obj.magic (x0 :: [])),
             __))))))
  | Coq_inr r ->
      let Coq_existT (x0, s) = r in
      let Coq_existT (y, _) = s in
      Coq_existT ((Obj.magic (y :: [])), (Coq_existT (
      (Obj.magic []), (Coq_existT ((Obj.magic (x0 :: [])), __)))))

(** val isRightDistributive_comp :
    coq_OrderSemigroup -> ((coq_IsIdempotent_comp,
    coq_LeftOpNonDecreasing_comp) sum, coq_RightOpNonDecreasing_comp) sum ->
    coq_IsRightDistributive_comp **)

let isRightDistributive_comp a = function
  | Coq_inl s ->
      (match s with
         | Coq_inl i ->
             let Coq_existT (x0, _) = i in
             Coq_existT ((Obj.magic []), (Coq_existT (
             (Obj.magic []), (Coq_existT ((Obj.magic (x0 :: [])), __)))))
         | Coq_inr l ->
             let Coq_existT (x0, s0) = l in
             let Coq_existT (y, _) = s0 in
             Coq_existT ((Obj.magic []), (Coq_existT (
             (Obj.magic (y :: [])), (Coq_existT ((Obj.magic (x0 :: [])),
             __))))))
  | Coq_inr r ->
      let Coq_existT (x0, s) = r in
      let Coq_existT (y, _) = s in
      Coq_existT ((Obj.magic (y :: [])), (Coq_existT (
      (Obj.magic []), (Coq_existT ((Obj.magic (x0 :: [])), __)))))

(** val isRightStrictStable_comp :
    coq_OrderSemigroup -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let isRightStrictStable_comp a =
  let a0 = a.setoid.choose in
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic (a0 :: [])),
  (Coq_existT ((Obj.magic (a0 :: [])), __)))))

(** val isLeftStrictStable_comp :
    coq_OrderSemigroup -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let isLeftStrictStable_comp a =
  let a0 = a.setoid.choose in
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic (a0 :: [])),
  (Coq_existT ((Obj.magic (a0 :: [])), __)))))

(** val total_singleton :
    coq_OrderSemigroup -> carrier -> (__, (carrier, __) sigT) sum **)

let total_singleton a x =
  match Obj.magic x with
    | [] -> Coq_inl __
    | x0 :: xs -> Coq_inr
        (let Coq_existT (a0, _) = min_exists_mem (preorderOS a) (x0 :: xs) x0
         in
        Coq_existT (a0, __))

(** val isSelective_comp__isRightCompEqCancel_comp :
    coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isSelective_comp__isRightCompEqCancel_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT
      ((mset_union (preorderOS a) x0 y), __)))))

(** val isRightCompEqCancel_comp :
    coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
    (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
    (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let isRightCompEqCancel_comp a x =
  isSelective_comp__isRightCompEqCancel_comp a
    (FMinSetsOp.isSelective_comp a x)

(** val isSelective_comp__isLeftCompEqCancel_comp :
    coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isSelective_comp__isLeftCompEqCancel_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT
      ((mset_union (preorderOS a) x0 y), __)))))

(** val isLeftCompEqCancel_comp :
    coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
    (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
    (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let isLeftCompEqCancel_comp a x =
  isSelective_comp__isLeftCompEqCancel_comp a
    (FMinSetsOp.isSelective_comp a x)

(** val isSelective_comp__isRightCompCancel_comp :
    coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isSelective_comp__isRightCompCancel_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT ((Obj.magic []), __)))))

(** val isRightCompCancel_comp :
    coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
    (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
    (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let isRightCompCancel_comp a x =
  let Coq_existT (x0, s) = FMinSetsOp.isSelective_comp a x in
  let Coq_existT (y, _) = s in
  Coq_existT (x0, (Coq_existT (y, (Coq_existT ((Obj.magic []), __)))))

(** val isSelective_comp__isLeftCompCancel_comp :
    coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isSelective_comp__isLeftCompCancel_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT ((Obj.magic []), __)))))

(** val isLeftCompCancel_comp :
    coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
    (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
    (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let isLeftCompCancel_comp a x =
  let Coq_existT (x0, s) = FMinSetsOp.isSelective_comp a x in
  let Coq_existT (y, _) = s in
  Coq_existT (x0, (Coq_existT (y, (Coq_existT ((Obj.magic []), __)))))

(** val leftDiscrete_comp :
    coq_OrderSemigroup -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let leftDiscrete_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT
    ((Obj.magic (a.setoid.choose :: [])), (Coq_existT (
    (Obj.magic []), __)))))

(** val rightDiscrete_comp :
    coq_OrderSemigroup -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let rightDiscrete_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT
    ((Obj.magic (a.setoid.choose :: [])), (Coq_existT (
    (Obj.magic []), __)))))

(** val isSelective_comp__leftComparable_comp :
    coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isSelective_comp__leftComparable_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT ((Obj.magic []), __)))))

(** val leftComparable_comp :
    coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
    (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
    (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let leftComparable_comp a x =
  let Coq_existT (x0, s) = FMinSetsOp.isSelective_comp a x in
  let Coq_existT (y, _) = s in
  Coq_existT (x0, (Coq_existT (y, (Coq_existT ((Obj.magic []), __)))))

(** val isSelective_comp__rightComparable_comp :
    coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isSelective_comp__rightComparable_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT ((Obj.magic []), __)))))

(** val rightComparable_comp :
    coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
    (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
    (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let rightComparable_comp a x =
  let Coq_existT (x0, s) = FMinSetsOp.isSelective_comp a x in
  let Coq_existT (y, _) = s in
  Coq_existT (x0, (Coq_existT (y, (Coq_existT ((Obj.magic []), __)))))

(** val leftIncreasing_comp :
    coq_OrderSemigroup -> coq_RightOpNonDecreasing_comp -> (carrier,
    (carrier, __) sigT) sigT **)

let leftIncreasing_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT ((Obj.magic (x0 :: [])), (Coq_existT (
      (Obj.magic (y :: [])), __)))

(** val rightIncreasing_comp :
    coq_OrderSemigroup -> coq_RightOpNonDecreasing_comp -> (carrier,
    (carrier, __) sigT) sigT **)

let rightIncreasing_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT ((Obj.magic (x0 :: [])), (Coq_existT (
      (Obj.magic (y :: [])), __)))

(** val leftStrictIncreasing_comp :
    coq_OrderSemigroup -> (carrier, (carrier, __) sigT) sigT **)

let leftStrictIncreasing_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

(** val rightStrictIncreasing_comp :
    coq_OrderSemigroup -> (carrier, (carrier, __) sigT) sigT **)

let rightStrictIncreasing_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

(** val nilOrElement :
    coq_OrderSemigroup -> carrier -> (__, (carrier, __) sigT) sum **)

let nilOrElement a x =
  match Obj.magic x with
    | [] -> Coq_inl __
    | a0 :: x0 -> Coq_inr
        (let Coq_existT (y, _) = min_exists_mem (preorderOS a) (a0 :: x0) a0
         in
        Coq_existT (y, __))

(** val isRightTimesMapToIdConstantPlus_comp :
    coq_OrderSemigroup -> coq_IsRightTimesMapToIdConstantPlus_comp **)

let isRightTimesMapToIdConstantPlus_comp a id =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), (Coq_existT
    ((Obj.magic []), __)))))

(** val isLeftTimesMapToIdConstantPlus_comp :
    coq_OrderSemigroup -> coq_IsLeftTimesMapToIdConstantPlus_comp **)

let isLeftTimesMapToIdConstantPlus_comp a id =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), (Coq_existT
    ((Obj.magic []), __)))))

