open Bisemigroup
open BisemigroupGlue
open BisemigroupProperties
open Datatypes
open DecSetoid
open FMinSets
open FMinSetsOp
open FMinSetsUnion
open OrderSemigroup
open OrderSemigroupProperties
open SemigroupProperties
open Specif

type __ = Obj.t

val minsetOpUnionBisemigroup : coq_OrderSemigroup -> coq_Bisemigroup

val isLeftDistributive_comp :
  coq_OrderSemigroup -> ((coq_IsIdempotent_comp,
  coq_LeftOpNonDecreasing_comp) sum, coq_RightOpNonDecreasing_comp) sum ->
  coq_IsLeftDistributive_comp

val isRightDistributive_comp :
  coq_OrderSemigroup -> ((coq_IsIdempotent_comp,
  coq_LeftOpNonDecreasing_comp) sum, coq_RightOpNonDecreasing_comp) sum ->
  coq_IsRightDistributive_comp

val isRightStrictStable_comp :
  coq_OrderSemigroup -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val isLeftStrictStable_comp :
  coq_OrderSemigroup -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val total_singleton :
  coq_OrderSemigroup -> carrier -> (__, (carrier, __) sigT) sum

val isSelective_comp__isRightCompEqCancel_comp :
  coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT

val isRightCompEqCancel_comp :
  coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
  (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val isSelective_comp__isLeftCompEqCancel_comp :
  coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT

val isLeftCompEqCancel_comp :
  coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
  (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val isSelective_comp__isRightCompCancel_comp :
  coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT

val isRightCompCancel_comp :
  coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
  (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val isSelective_comp__isLeftCompCancel_comp :
  coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT

val isLeftCompCancel_comp :
  coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
  (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val leftDiscrete_comp :
  coq_OrderSemigroup -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val rightDiscrete_comp :
  coq_OrderSemigroup -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val isSelective_comp__leftComparable_comp :
  coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT

val leftComparable_comp :
  coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
  (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val isSelective_comp__rightComparable_comp :
  coq_OrderSemigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT

val rightComparable_comp :
  coq_OrderSemigroup -> (coq_IsSelective_comp, __ *
  (coq_IncompArrowUniqueSrc_comp, coq_IncompArrowFactor_comp) sum) sum ->
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val leftIncreasing_comp :
  coq_OrderSemigroup -> coq_RightOpNonDecreasing_comp -> (carrier, (carrier,
  __) sigT) sigT

val rightIncreasing_comp :
  coq_OrderSemigroup -> coq_RightOpNonDecreasing_comp -> (carrier, (carrier,
  __) sigT) sigT

val leftStrictIncreasing_comp :
  coq_OrderSemigroup -> (carrier, (carrier, __) sigT) sigT

val rightStrictIncreasing_comp :
  coq_OrderSemigroup -> (carrier, (carrier, __) sigT) sigT

val nilOrElement :
  coq_OrderSemigroup -> carrier -> (__, (carrier, __) sigT) sum

val isRightTimesMapToIdConstantPlus_comp :
  coq_OrderSemigroup -> coq_IsRightTimesMapToIdConstantPlus_comp

val isLeftTimesMapToIdConstantPlus_comp :
  coq_OrderSemigroup -> coq_IsLeftTimesMapToIdConstantPlus_comp

