open Datatypes
open DecSetoid
open DecSetoidPropRecord
open FSetOp
open FSets3
open Logic0
open Semigroup
open SemigroupPropRecord
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val fsetOpSemigroup_props : coq_Semigroup -> sgProp -> sgProp **)

let fsetOpSemigroup_props a ap =
  { sg_dsprop = (fsetDecSetoid_props a.setoid ap.sg_dsprop); hasIdentity =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match hasIdentity0 with
       | Some a0 -> Some
           (let Coq_existT (a1, _) = a0 in
           Coq_existT ((Obj.magic (a1 :: [])), __))
       | None -> None)); hasIdentity_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match hasIdentity_comp0 with
       | Some a0 -> Some (fun i ->
           match Obj.magic i with
             | [] -> Coq_existT ((Obj.magic (a.setoid.choose :: [])), __)
             | x :: xs ->
                 let Coq_existT (c, _) = a0 x in
                 Coq_existT ((Obj.magic (c :: [])), __))
       | None -> None)); hasAnnihilator =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    opInit (Coq_existT ((Obj.magic []), __))); hasAnnihilator_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); isSelective =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match isLeft0 with
       | Some a0 -> Some (Obj.magic __ (Coq_inl (Coq_inl a0)))
       | None ->
           (match isRight0 with
              | Some b -> Some (Obj.magic __ (Coq_inl (Coq_inr b)))
              | None ->
                  (match twoElements0 with
                     | Some a0 ->
                         (match isIdempotent0 with
                            | Some b -> Some
                                (Obj.magic __ (Coq_inr (a0 , b)))
                            | None -> None)
                     | None -> None)))); isSelective_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match isLeft_comp0 with
       | Some a0 ->
           (match isRight_comp0 with
              | Some b ->
                  (match twoElements_comp0 with
                     | Some a1 -> Some
                         (FSetOp.isSelective_comp a ((a0 , b) , (Coq_inl
                           a1)))
                     | None ->
                         (match isIdempotent_comp0 with
                            | Some b0 -> Some
                                (FSetOp.isSelective_comp a ((a0 , b) ,
                                  (Coq_inr b0)))
                            | None -> None))
              | None -> None)
       | None -> None)); isCommutative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match isCommutative0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isCommutative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match isCommutative_comp0 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (b, _) = s in
           Coq_existT ((Obj.magic (a1 :: [])), (Coq_existT
           ((Obj.magic (b :: [])), __))))
       | None -> None)); isIdempotent =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match isSelective0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isIdempotent_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    (match isSelective_comp0 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (b, _) = s in
           Coq_existT ((Obj.magic (a1 :: (b :: []))), __))
       | None -> None)); isLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); isLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    opInit (FSetOp.isLeft_comp a)); isRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); isRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    opInit (FSetOp.isRight_comp a)); leftCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); leftCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    opInit (FSetOp.leftCondensed_comp a)); rightCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); rightCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    opInit (FSetOp.rightCondensed_comp a)); leftCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); leftCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    opInit (FSetOp.leftCancelative_comp a)); rightCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); rightCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    opInit (FSetOp.rightCancelative_comp a)); antiLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); antiLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    opInit (Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))));
    antiRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); antiRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    opInit (Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))));
    treeGlb =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None); treeGlb_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = ap
     in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    None) }

