open Bisemigroup
open BisemigroupGlue
open BisemigroupProperties
open DecSetoid
open DecSetoidProperties
open FSetsIntersect
open FSetsUnion
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val fsetBisemigroup : coq_DecSetoid -> coq_Bisemigroup **)

let fsetBisemigroup a =
  glueBSmg (fsetsUnionSemigroup a) (fsetsIntersectionSemigroup a)

(** val isRightStrictStable_comp :
    coq_DecSetoid -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let isRightStrictStable_comp a =
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT (
    (Obj.magic []), (Coq_existT ((Obj.magic []), __)))))

(** val isLeftStrictStable_comp :
    coq_DecSetoid -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let isLeftStrictStable_comp a =
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT (
    (Obj.magic []), (Coq_existT ((Obj.magic []), __)))))

(** val isRightCompEqCancel_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isRightCompEqCancel_comp a sg =
  let Coq_existT (b, _) = sg a.choose in
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
  ((Obj.magic (b :: [])), (Coq_existT ((Obj.magic []), __)))))

(** val isLeftCompEqCancel_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isLeftCompEqCancel_comp a sg =
  let Coq_existT (b, _) = sg a.choose in
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
  ((Obj.magic (b :: [])), (Coq_existT ((Obj.magic []), __)))))

(** val isRightCompCancel_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isRightCompCancel_comp a sg =
  let Coq_existT (b, _) = sg a.choose in
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
  ((Obj.magic (b :: [])), (Coq_existT ((Obj.magic (a.choose :: (b :: []))),
  __)))))

(** val isLeftCompCancel_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isLeftCompCancel_comp a sg =
  let Coq_existT (b, _) = sg a.choose in
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
  ((Obj.magic (b :: [])), (Coq_existT ((Obj.magic (a.choose :: (b :: []))),
  __)))))

(** val leftDiscrete_comp :
    coq_DecSetoid -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let leftDiscrete_comp a =
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT (
    (Obj.magic []), (Coq_existT ((Obj.magic (a.choose :: [])), __)))))

(** val rightDiscrete_comp :
    coq_DecSetoid -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let rightDiscrete_comp a =
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT (
    (Obj.magic []), (Coq_existT ((Obj.magic (a.choose :: [])), __)))))

(** val leftComparable_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let leftComparable_comp a sg =
  let Coq_existT (b, _) = sg a.choose in
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
  ((Obj.magic (b :: [])), (Coq_existT ((Obj.magic (a.choose :: (b :: []))),
  __)))))

(** val rightComparable_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let rightComparable_comp a sg =
  let Coq_existT (b, _) = sg a.choose in
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
  ((Obj.magic (b :: [])), (Coq_existT ((Obj.magic (a.choose :: (b :: []))),
  __)))))

(** val leftStrictIncreasing_comp :
    coq_DecSetoid -> (carrier, (carrier, __) sigT) sigT **)

let leftStrictIncreasing_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

(** val rightStrictIncreasing_comp :
    coq_DecSetoid -> (carrier, (carrier, __) sigT) sigT **)

let rightStrictIncreasing_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

(** val isRightTimesMapToIdConstantPlus_comp :
    coq_DecSetoid -> coq_IsRightTimesMapToIdConstantPlus_comp **)

let isRightTimesMapToIdConstantPlus_comp a hasId =
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
    ((Obj.magic (a.choose :: [])), (Coq_existT ((Obj.magic (a.choose :: [])),
    __)))))

(** val isLeftTimesMapToIdConstantPlus_comp :
    coq_DecSetoid -> coq_IsLeftTimesMapToIdConstantPlus_comp **)

let isLeftTimesMapToIdConstantPlus_comp a hasId =
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
    ((Obj.magic (a.choose :: [])), (Coq_existT ((Obj.magic (a.choose :: [])),
    __)))))

