open BisemigroupGlue
open BisemigroupPropRecord
open DecSetoid
open DecSetoidPropRecord
open FSets0
open FSetsIntersect
open FSetsIntersect1
open FSetsUnion
open FSetsUnion1
open Logic0
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val fsetBisemigroup_props : coq_DecSetoid -> dsProp -> bsProp **)

let fsetBisemigroup_props a ap =
  { bs_plus_sgprop =
    (projPlusBSmgIso (fsetsUnionSemigroup a) (fsetsIntersectionSemigroup a)
      (fsetsUnionSemigroup_props a ap)); bs_times_sgprop =
    (projTimesBSmgIso (fsetsUnionSemigroup a) (fsetsIntersectionSemigroup a)
      (fsetsIntersectionSemigroup_props a ap)); isLeftDistributive =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isLeftDistributive_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isRightDistributive =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isRightDistributive_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); plusIdentityIsTimesAnnihilator =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); plusIdentityIsTimesAnnihilator_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); plusAnnihilatorIsTimesIdentity =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); plusAnnihilatorIsTimesIdentity_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isRightStrictStable =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); BisemigroupPropRecord.isRightStrictStable_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (fun _ _ -> isRightStrictStable_comp a)); isLeftStrictStable =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); BisemigroupPropRecord.isLeftStrictStable_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (fun _ _ -> isLeftStrictStable_comp a)); isRightCompEqCancel =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); BisemigroupPropRecord.isRightCompEqCancel_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun _ _ -> isRightCompEqCancel_comp a a0)
       | None -> None)); isLeftCompEqCancel =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); BisemigroupPropRecord.isLeftCompEqCancel_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun _ _ -> isLeftCompEqCancel_comp a a0)
       | None -> None)); isRightCompCancel =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); BisemigroupPropRecord.isRightCompCancel_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun _ _ -> isRightCompCancel_comp a a0)
       | None -> None)); isLeftCompCancel =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); BisemigroupPropRecord.isLeftCompCancel_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun _ _ -> isLeftCompCancel_comp a a0)
       | None -> None)); leftDiscrete =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); BisemigroupPropRecord.leftDiscrete_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (fun _ _ -> leftDiscrete_comp a)); rightDiscrete =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); BisemigroupPropRecord.rightDiscrete_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (fun _ _ -> rightDiscrete_comp a)); leftComparable =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); BisemigroupPropRecord.leftComparable_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun _ _ -> leftComparable_comp a a0)
       | None -> None)); rightComparable =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); BisemigroupPropRecord.rightComparable_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun _ _ -> rightComparable_comp a a0)
       | None -> None)); leftIncreasing =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); leftIncreasing_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); rightIncreasing =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); rightIncreasing_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); leftStrictIncreasing =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); BisemigroupPropRecord.leftStrictIncreasing_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (fun _ _ -> Coq_existT ((Obj.magic []), (Coq_existT
      ((Obj.magic []), __))))); rightStrictIncreasing =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); BisemigroupPropRecord.rightStrictIncreasing_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (fun _ _ -> Coq_existT ((Obj.magic []), (Coq_existT
      ((Obj.magic []), __))))); isRightTimesMapToIdConstantPlus =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); BisemigroupPropRecord.isRightTimesMapToIdConstantPlus_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (fun hasId -> Coq_existT ((Obj.magic (a.choose :: [])),
      (Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
      ((Obj.magic (a.choose :: [])), __)))))));
    isLeftTimesMapToIdConstantPlus =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); BisemigroupPropRecord.isLeftTimesMapToIdConstantPlus_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (fun hasId -> Coq_existT ((Obj.magic (a.choose :: [])),
      (Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
      ((Obj.magic (a.choose :: [])), __)))))));
    plusIdentityIsTimesLeftAnnihilator =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); plusIdentityIsTimesLeftAnnihilator_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); plusIdentityIsTimesRightAnnihilator =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); plusIdentityIsTimesRightAnnihilator_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None) }

