open DecSetoid
open DecSetoidPropRecord
open FSets3
open FSetsIntersect
open Logic0
open SemigroupPropRecord
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val fsetsIntersectionSemigroup_props :
    coq_DecSetoid -> dsProp -> sgProp **)

let fsetsIntersectionSemigroup_props a ap =
  { sg_dsprop = (fsetDecSetoid_props a ap); hasIdentity =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match finite0 with
       | Some a0 -> Some
           (let Coq_existT (l, _) = a0 in Coq_existT ((Obj.magic l), __))
       | None -> None)); hasIdentity_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match finite_comp0 with
       | Some a0 -> Some (fun x ->
           let Coq_existT (y, _) = Obj.magic a0 x in
           Coq_existT ((Obj.magic (y :: [])), __))
       | None -> None)); hasAnnihilator =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (Coq_existT ((Obj.magic []), __))); hasAnnihilator_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isSelective =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isSelective_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (FSetsIntersect.isSelective_comp a a0)
       | None -> None)); isCommutative =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isCommutative_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isIdempotent =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isIdempotent_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isLeft =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isLeft_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (FSetsIntersect.isLeft_comp a)); isRight =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isRight_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (FSetsIntersect.isRight_comp a)); leftCondensed =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); leftCondensed_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (FSetsIntersect.leftCondensed_comp a)); rightCondensed =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); rightCondensed_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (FSetsIntersect.rightCondensed_comp a)); leftCancelative =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); leftCancelative_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (FSetsIntersect.leftCancelative_comp a)); rightCancelative =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); rightCancelative_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (FSetsIntersect.rightCancelative_comp a)); antiLeft =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); antiLeft_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))));
    antiRight =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); antiRight_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))));
    treeGlb =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); treeGlb_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None) }

