open DecSetoid
open DecSetoidProperties
open FSets
open Semigroup
open SemigroupProperties
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val fsetsUnionSemigroup : coq_DecSetoid -> coq_Semigroup **)

let fsetsUnionSemigroup a =
  { setoid = (fsetDecSetoid a); op = (Obj.magic (union a)) }

(** val isSelective_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> coq_IsSelective_comp **)

let isSelective_comp a sa =
  let Coq_existT (b, _) = sa a.choose in
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT
  ((Obj.magic (b :: [])), __)))

(** val hasIdentity : coq_DecSetoid -> coq_HasIdentity **)

let hasIdentity a =
  Coq_existT ((Obj.magic []), __)

(** val hasAnnihilator :
    coq_DecSetoid -> coq_Finite -> coq_HasAnnihilator **)

let hasAnnihilator a = function
  | Coq_existT (l, _) -> Coq_existT ((Obj.magic l), __)

(** val hasAnnihilator_comp :
    coq_DecSetoid -> coq_Finite_comp -> coq_HasAnnihilator_comp **)

let hasAnnihilator_comp a fl x =
  let Coq_existT (y, _) = Obj.magic fl x in
  Coq_existT ((Obj.magic (y :: [])), __)

(** val isLeft_comp : coq_DecSetoid -> coq_IsLeft_comp **)

let isLeft_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic (a.choose :: [])),
    __)))

(** val isRight_comp : coq_DecSetoid -> coq_IsRight_comp **)

let isRight_comp a =
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT (
    (Obj.magic []), __)))

(** val leftCondensed_comp : coq_DecSetoid -> coq_LeftCondensed_comp **)

let leftCondensed_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), (Coq_existT
    ((Obj.magic (a.choose :: [])), __)))))

(** val rightCondensed_comp : coq_DecSetoid -> coq_RightCondensed_comp **)

let rightCondensed_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), (Coq_existT
    ((Obj.magic (a.choose :: [])), __)))))

(** val leftCancelative_comp : coq_DecSetoid -> coq_LeftCancelative_comp **)

let leftCancelative_comp a =
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT (
    (Obj.magic []), (Coq_existT ((Obj.magic (a.choose :: [])), __)))))

(** val rightCancelative_comp :
    coq_DecSetoid -> coq_RightCancelative_comp **)

let rightCancelative_comp a =
  Coq_existT ((Obj.magic (a.choose :: [])), (Coq_existT (
    (Obj.magic []), (Coq_existT ((Obj.magic (a.choose :: [])), __)))))

(** val antiRight_comp : coq_DecSetoid -> coq_AntiRight_comp **)

let antiRight_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

(** val antiLeft_comp : coq_DecSetoid -> coq_AntiLeft_comp **)

let antiLeft_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

(** val treeGlb_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let treeGlb_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic []), __)))))

