open DecSetoid
open Semigroup
open SemigroupTransform
open Transform

type __ = Obj.t

(** val isoPres_helper :
    coq_Semigroup -> coq_Semigroup -> coq_Transform -> coq_Transform ->
    coq_SmgIso -> coq_TfIso -> coq_DsIso **)

let isoPres_helper x x' y y' i i' =
  let { Semigroup.setoid = setoid0; Semigroup.op = op0 } = x in
  let { Semigroup.setoid = setoid1; Semigroup.op = op1 } = x' in
  let { setoid = setoid2; fn = fn0; app = app0 } = y in
  let { setoid = setoid3; fn = fn1; app = app1 } = y' in i

type coq_GlueSTfIsoEq = __

type coq_GlueSTfIso = { gstSmgIso : coq_SmgIso; gstFnDsIso : 
                        coq_DsIso; gstSTfIso : coq_GlueSTfIsoEq }

(** val coq_GlueSTfIso_rect :
    coq_Semigroup -> coq_Semigroup -> coq_Transform -> coq_Transform ->
    (coq_SmgIso -> coq_DsIso -> coq_GlueSTfIsoEq -> 'a1) -> coq_GlueSTfIso ->
    'a1 **)

let coq_GlueSTfIso_rect x x' y y' f g =
  let { gstSmgIso = x0; gstFnDsIso = x1; gstSTfIso = x2 } = g in f x0 x1 x2

(** val coq_GlueSTfIso_rec :
    coq_Semigroup -> coq_Semigroup -> coq_Transform -> coq_Transform ->
    (coq_SmgIso -> coq_DsIso -> coq_GlueSTfIsoEq -> 'a1) -> coq_GlueSTfIso ->
    'a1 **)

let coq_GlueSTfIso_rec x x' y y' f g =
  let { gstSmgIso = x0; gstFnDsIso = x1; gstSTfIso = x2 } = g in f x0 x1 x2

(** val gstSmgIso :
    coq_Semigroup -> coq_Semigroup -> coq_Transform -> coq_Transform ->
    coq_GlueSTfIso -> coq_SmgIso **)

let gstSmgIso _ _ _ _ x = x.gstSmgIso

(** val gstFnDsIso :
    coq_Semigroup -> coq_Semigroup -> coq_Transform -> coq_Transform ->
    coq_GlueSTfIso -> coq_DsIso **)

let gstFnDsIso _ _ _ _ x = x.gstFnDsIso

(** val gstSTfIso :
    coq_Semigroup -> coq_Semigroup -> coq_Transform -> coq_Transform ->
    coq_GlueSTfIso -> coq_GlueSTfIsoEq **)

let gstSTfIso _ _ _ _ x = x.gstSTfIso

(** val isoPres :
    coq_Semigroup -> coq_Semigroup -> coq_Transform -> coq_Transform ->
    coq_GlueSTfIso -> coq_STfIso **)

let isoPres x x' y y' gbs =
  let { Semigroup.setoid = setoid0; Semigroup.op = op0 } = x in
  let { Semigroup.setoid = setoid1; Semigroup.op = op1 } = x' in
  let { setoid = setoid2; fn = fn0; app = app0 } = y in
  let { setoid = setoid3; fn = fn1; app = app1 } = y' in
  let { gstSmgIso = i1; gstFnDsIso = i2; gstSTfIso = x0 } = gbs in
  Obj.magic (fun _ -> { SemigroupTransform.dsIso = i1;
    SemigroupTransform.fnIso = i2 }) x0

