open Bisemigroup
open DecSetoid
open OrderSemigroup
open Preorder
open Semigroup
open SemigroupTransform
open Transform

type __ = Obj.t

val id : 'a1 -> 'a1

val eqFunRev : ('a1 -> 'a2) -> 'a1 -> 'a1

type coq_IsIdIso =
  | Build_IsIdIso

val coq_IsIdIso_rect :
  coq_DecSetoid -> coq_DecSetoid -> coq_DsIso -> (__ -> __ -> 'a1) -> 'a1

val coq_IsIdIso_rec :
  coq_DecSetoid -> coq_DecSetoid -> coq_DsIso -> (__ -> __ -> 'a1) -> 'a1

type coq_IdDsIso =
  coq_DsIso
  (* singleton inductive, whose constructor was Build_IdDsIso *)

val coq_IdDsIso_rect :
  coq_DecSetoid -> coq_DecSetoid -> (coq_DsIso -> __ -> 'a1) -> coq_IdDsIso
  -> 'a1

val coq_IdDsIso_rec :
  coq_DecSetoid -> coq_DecSetoid -> (coq_DsIso -> __ -> 'a1) -> coq_IdDsIso
  -> 'a1

val dsIso : coq_DecSetoid -> coq_DecSetoid -> coq_IdDsIso -> coq_DsIso

type coq_IdSmgIso =
  coq_SmgIso
  (* singleton inductive, whose constructor was Build_IdSmgIso *)

val coq_IdSmgIso_rect :
  coq_Semigroup -> coq_Semigroup -> (coq_SmgIso -> __ -> 'a1) -> coq_IdSmgIso
  -> 'a1

val coq_IdSmgIso_rec :
  coq_Semigroup -> coq_Semigroup -> (coq_SmgIso -> __ -> 'a1) -> coq_IdSmgIso
  -> 'a1

val sgIso : coq_Semigroup -> coq_Semigroup -> coq_IdSmgIso -> coq_SmgIso

type coq_IdProIso =
  coq_ProIso
  (* singleton inductive, whose constructor was Build_IdProIso *)

val coq_IdProIso_rect :
  coq_Preorder -> coq_Preorder -> (coq_ProIso -> __ -> 'a1) -> coq_IdProIso
  -> 'a1

val coq_IdProIso_rec :
  coq_Preorder -> coq_Preorder -> (coq_ProIso -> __ -> 'a1) -> coq_IdProIso
  -> 'a1

val poIso : coq_Preorder -> coq_Preorder -> coq_IdProIso -> coq_ProIso

type coq_IdOSmgIso =
  coq_OSmgIso
  (* singleton inductive, whose constructor was Build_IdOSmgIso *)

val coq_IdOSmgIso_rect :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_OSmgIso -> __ -> 'a1) ->
  coq_IdOSmgIso -> 'a1

val coq_IdOSmgIso_rec :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_OSmgIso -> __ -> 'a1) ->
  coq_IdOSmgIso -> 'a1

val osIso :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IdOSmgIso -> coq_OSmgIso

type coq_IdBSmgIso =
  coq_BSmgIso
  (* singleton inductive, whose constructor was Build_IdBSmgIso *)

val coq_IdBSmgIso_rect :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_BSmgIso -> __ -> 'a1) ->
  coq_IdBSmgIso -> 'a1

val coq_IdBSmgIso_rec :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_BSmgIso -> __ -> 'a1) ->
  coq_IdBSmgIso -> 'a1

val bsIso :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_IdBSmgIso -> coq_BSmgIso

type coq_IdTfIso =
  coq_TfIso
  (* singleton inductive, whose constructor was Build_IdTfIso *)

val coq_IdTfIso_rect :
  coq_Transform -> coq_Transform -> (coq_TfIso -> __ -> __ -> 'a1) ->
  coq_IdTfIso -> 'a1

val coq_IdTfIso_rec :
  coq_Transform -> coq_Transform -> (coq_TfIso -> __ -> __ -> 'a1) ->
  coq_IdTfIso -> 'a1

val tfIso : coq_Transform -> coq_Transform -> coq_IdTfIso -> coq_TfIso

type coq_IdSTfIso =
  coq_STfIso
  (* singleton inductive, whose constructor was Build_IdSTfIso *)

val coq_IdSTfIso_rect :
  coq_SemigroupTransform -> coq_SemigroupTransform -> (coq_STfIso -> __ -> __
  -> 'a1) -> coq_IdSTfIso -> 'a1

val coq_IdSTfIso_rec :
  coq_SemigroupTransform -> coq_SemigroupTransform -> (coq_STfIso -> __ -> __
  -> 'a1) -> coq_IdSTfIso -> 'a1

val stIso :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_IdSTfIso ->
  coq_STfIso

val coq_IdDsIso_refl : coq_DecSetoid -> coq_IdDsIso

val coq_IdSmgIso_refl : coq_Semigroup -> coq_IdSmgIso

val coq_IdProIso_refl : coq_Preorder -> coq_IdProIso

val coq_IdOSmgIso_refl : coq_OrderSemigroup -> coq_IdOSmgIso

val coq_IdBSmgIso_refl : coq_Bisemigroup -> coq_IdBSmgIso

val coq_IdTfIso_refl : coq_Transform -> coq_IdTfIso

val coq_IdSTfIso_refl : coq_SemigroupTransform -> coq_IdSTfIso

val coq_IdDsIso_sym :
  coq_DecSetoid -> coq_DecSetoid -> coq_IdDsIso -> coq_IdDsIso

val coq_IdSmgIso_sym :
  coq_Semigroup -> coq_Semigroup -> coq_IdSmgIso -> coq_IdSmgIso

val coq_IdProIso_sym :
  coq_Preorder -> coq_Preorder -> coq_IdProIso -> coq_IdProIso

val coq_IdOSmgIso_sym :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IdOSmgIso -> coq_IdOSmgIso

val coq_IdBSmgIso_sym :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_IdBSmgIso -> coq_IdBSmgIso

val coq_IdTfIso_sym :
  coq_Transform -> coq_Transform -> coq_IdTfIso -> coq_IdTfIso

val coq_IdSTfIso_sym :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_IdSTfIso ->
  coq_IdSTfIso

val coq_IdDsIso_trans :
  coq_DecSetoid -> coq_DecSetoid -> coq_DecSetoid -> coq_IdDsIso ->
  coq_IdDsIso -> coq_IdDsIso

val coq_IdSmgIso_trans :
  coq_Semigroup -> coq_Semigroup -> coq_Semigroup -> coq_IdSmgIso ->
  coq_IdSmgIso -> coq_IdSmgIso

val coq_IdProIso_trans :
  coq_Preorder -> coq_Preorder -> coq_Preorder -> coq_IdProIso ->
  coq_IdProIso -> coq_IdProIso

val coq_IdOSmgIso_trans :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_OrderSemigroup ->
  coq_IdOSmgIso -> coq_IdOSmgIso -> coq_IdOSmgIso

val coq_IdBSmgIso_trans :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_Bisemigroup -> coq_IdBSmgIso ->
  coq_IdBSmgIso -> coq_IdBSmgIso

val coq_IdTfIso_trans :
  coq_Transform -> coq_Transform -> coq_Transform -> coq_IdTfIso ->
  coq_IdTfIso -> coq_IdTfIso

val coq_IdSTfIso_trans :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_SemigroupTransform
  -> coq_IdSTfIso -> coq_IdSTfIso -> coq_IdSTfIso

val coq_IdSmgIso__IdDsIso :
  coq_Semigroup -> coq_Semigroup -> coq_IdSmgIso -> coq_IdDsIso

val coq_IdProIso__IdDsIso :
  coq_Preorder -> coq_Preorder -> coq_IdProIso -> coq_IdDsIso

val coq_IdOSmgIso__IdSmgIso :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IdOSmgIso -> coq_IdSmgIso

val coq_IdOSmgIso__IdProIso :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IdOSmgIso -> coq_IdProIso

val plus_IdBSmgIso__IdSmgIso :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_IdBSmgIso -> coq_IdSmgIso

val times_IdBSmgIso__IdSmgIso :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_IdBSmgIso -> coq_IdSmgIso

val coq_IdTfIso__IdDsIso :
  coq_Transform -> coq_Transform -> coq_IdTfIso -> coq_IdDsIso

val fn_IdTfIso__IdDsIso :
  coq_Transform -> coq_Transform -> coq_IdTfIso -> coq_IdDsIso

val coq_IdSTfIso__IdSmgIso :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_IdSTfIso ->
  coq_IdSmgIso

val coq_IdSTfIso__IdTfIso :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_IdSTfIso ->
  coq_IdTfIso

