open Bisemigroup
open BisemigroupGlue
open BisemigroupProperties
open DecSetoid
open DecSetoidProperties
open Left
open Logic0
open Semigroup
open SemigroupProperties
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val leftBisemigroup : coq_Semigroup -> coq_Bisemigroup **)

let leftBisemigroup a =
  glueBSmg a (leftSemigroup a.setoid)

(** val isLeftDistributive_comp :
    coq_Semigroup -> coq_IsIdempotent_comp -> coq_IsLeftDistributive_comp **)

let isLeftDistributive_comp a = function
  | Coq_existT (x0, _) -> Coq_existT (x0, (Coq_existT (x0, (Coq_existT (x0,
      __)))))

(** val isLeftStrictStable_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isLeftStrictStable_comp a sg =
  let Coq_existT (b, _) = sg a.setoid.choose in
  let Coq_existT (w, _) =
    copy_var (a.setoid.equal (a.op b a.setoid.choose) b)
  in
  if w
  then Coq_existT (b, (Coq_existT (a.setoid.choose, (Coq_existT (b, __)))))
  else Coq_existT ((a.op a.setoid.choose b), (Coq_existT (b, (Coq_existT (b,
         __)))))

(** val rightDiscrete_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let rightDiscrete_comp a sg =
  let Coq_existT (b, _) = sg a.setoid.choose in
  let Coq_existT (w, _) =
    copy_var (a.setoid.equal (a.op b a.setoid.choose) b)
  in
  if w
  then Coq_existT (b, (Coq_existT (a.setoid.choose, (Coq_existT (b, __)))))
  else Coq_existT ((a.op a.setoid.choose b), (Coq_existT (b, (Coq_existT (b,
         __)))))

(** val rightComparable_comp :
    coq_Semigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let rightComparable_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (x0, __)))))

(** val isLeftCompEqCancel_comp :
    coq_Semigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isLeftCompEqCancel_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (x0, __)))))

(** val isRightCompCancel_comp :
    coq_Semigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isRightCompCancel_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, _) = s in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (x0, __)))))

(** val leftIncreasing_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> (carrier, (carrier, __) sigT)
    sigT **)

let leftIncreasing_comp a sg =
  let Coq_existT (b, _) = sg a.setoid.choose in
  let Coq_existT (w, _) =
    copy_var (a.setoid.equal (a.op b a.setoid.choose) b)
  in
  if w
  then Coq_existT (a.setoid.choose, (Coq_existT (b, __)))
  else Coq_existT (b, (Coq_existT (a.setoid.choose, __)))

(** val leftStrictIncreasing_comp :
    coq_Semigroup -> (carrier, (carrier, __) sigT) sigT **)

let leftStrictIncreasing_comp a =
  Coq_existT (a.setoid.choose, (Coq_existT (a.setoid.choose, __)))

(** val rightStrictIncreasing_comp :
    coq_Semigroup -> (carrier, (carrier, __) sigT) sigT **)

let rightStrictIncreasing_comp a =
  Coq_existT (a.setoid.choose, (Coq_existT (a.setoid.choose, __)))

(** val leftWStrictIncreasing_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> coq_HasAnnihilator -> (carrier,
    (carrier, __) sigT) sigT **)

let leftWStrictIncreasing_comp a sg = function
  | Coq_existT (id, _) ->
      let Coq_existT (a0, _) = sg id in
      Coq_existT (a0, (Coq_existT (a0, __)))

(** val rightWStrictIncreasing_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> coq_HasAnnihilator -> (carrier,
    (carrier, __) sigT) sigT **)

let rightWStrictIncreasing_comp a sg = function
  | Coq_existT (id, _) ->
      let Coq_existT (a0, _) = sg id in
      Coq_existT (a0, (Coq_existT (a0, __)))

(** val hasId_back : coq_Semigroup -> coq_HasIdentity -> coq_HasIdentity **)

let hasId_back a = function
  | Coq_existT (x, _) -> Coq_existT
      (((let i = plusBSmgIso a (leftSemigroup a.setoid) in
        { phi = i.phi'; phi' = i.phi }).phi x), __)

(** val isLeftTimesMapToIdConstantPlus_comp :
    coq_Semigroup -> coq_IsIdempotent_comp ->
    coq_IsLeftTimesMapToIdConstantPlus_comp **)

let isLeftTimesMapToIdConstantPlus_comp a x hasId =
  let Coq_existT (x0, _) = x in
  Coq_existT (x0, (Coq_existT (x0, (Coq_existT (x0, __)))))

(** val isRightTimesMapToIdConstantPlus_comp :
    coq_Semigroup -> coq_IsSingleton_comp ->
    coq_IsRightTimesMapToIdConstantPlus_comp **)

let isRightTimesMapToIdConstantPlus_comp a sg = function
  | Coq_existT (id, _) ->
      let Coq_existT (b, _) = sg id in
      Coq_existT (id, (Coq_existT (b, (Coq_existT (b, __)))))

(** val plusIdentityIsTimesRightAnnihilator_comp :
    coq_Semigroup -> coq_IsSingleton_comp ->
    coq_PlusIdentityIsTimesRightAnnihilator_comp **)

let plusIdentityIsTimesRightAnnihilator_comp a sg = function
  | Coq_existT (id, _) -> let Coq_existT (b, _) = sg id in Coq_existT (b, __)

