open DecSetoid
open DecSetoidProperties
open Logic0
open Replace
open Semigroup
open SemigroupProperties
open SemigroupTransform
open SemigroupTransformGlue
open SemigroupTransformProperties
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val leftSemigroupTransform : coq_Semigroup -> coq_SemigroupTransform **)

let leftSemigroupTransform a =
  glueSTf_DsEq a (replaceTransform a.Semigroup.setoid)

(** val distributive_comp :
    coq_Semigroup -> coq_IsIdempotent_comp -> coq_Distributive_comp **)

let distributive_comp a = function
  | Coq_existT (f, _) -> Coq_existT (f, (Coq_existT (f, (Coq_existT (f,
      __)))))

(** val inflationary_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> (carrier, (carrier, __) sigT)
    sigT **)

let inflationary_comp a sg =
  let Coq_existT (b, _) = sg a.Semigroup.setoid.choose in
  let Coq_existT (w, _) =
    copy_var
      (a.Semigroup.setoid.equal (a.Semigroup.op a.Semigroup.setoid.choose b)
        a.Semigroup.setoid.choose)
  in
  if w
  then Coq_existT (b, (Coq_existT (a.Semigroup.setoid.choose, __)))
  else Coq_existT (a.Semigroup.setoid.choose, (Coq_existT (b, __)))

(** val deflationary_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> (carrier, (carrier, __) sigT)
    sigT **)

let deflationary_comp a sg =
  let a0 = a.Semigroup.setoid.choose in
  let Coq_existT (b, _) = sg a0 in
  let Coq_existT (w, _) =
    copy_var (a.Semigroup.setoid.equal (a.Semigroup.op b a0) b)
  in
  if w
  then Coq_existT (b, (Coq_existT (a0, __)))
  else Coq_existT (a0, (Coq_existT (b, __)))

(** val strictInflationary_comp :
    coq_Semigroup -> (carrier, (carrier, __) sigT) sigT **)

let strictInflationary_comp a =
  Coq_existT (a.Semigroup.setoid.choose, (Coq_existT
    (a.Semigroup.setoid.choose, __)))

(** val strictDeflationary_comp :
    coq_Semigroup -> (carrier, (carrier, __) sigT) sigT **)

let strictDeflationary_comp a =
  Coq_existT (a.Semigroup.setoid.choose, (Coq_existT
    (a.Semigroup.setoid.choose, __)))

(** val strict_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> coq_Strict_comp **)

let strict_comp a sg = function
  | Coq_existT (id, _) -> let Coq_existT (b, _) = sg id in Coq_existT (b, __)

