open DecSetoid
open DecSetoidPropRecord
open Left
open Logic0
open SemigroupPropRecord
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val leftSemigroup_props : coq_DecSetoid -> dsProp -> sgProp **)

let leftSemigroup_props a ap =
  { sg_dsprop = ap; hasIdentity =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (let Coq_existT (a1, _) = a0 in Coq_existT (a1, __))
       | None -> None)); hasIdentity_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun x ->
           let Coq_existT (b, _) = a0 x in Coq_existT (b, __))
       | None -> None)); hasAnnihilator =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (let Coq_existT (a1, _) = a0 in Coq_existT (a1, __))
       | None -> None)); hasAnnihilator_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun x ->
           let Coq_existT (b, _) = a0 x in Coq_existT (b, __))
       | None -> None)); isSelective =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isSelective_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isCommutative =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isCommutative_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (Left.isCommutative_comp a a0)
       | None -> None)); isIdempotent =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isIdempotent_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isLeft =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isLeft_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isRight =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isRight_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (Left.isRight_comp a a0)
       | None -> None)); leftCondensed =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); leftCondensed_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); rightCondensed =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); rightCondensed_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (Left.rightCondensed_comp a a0)
       | None -> None)); leftCancelative =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); leftCancelative_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (Left.leftCancelative_comp a a0)
       | None -> None)); rightCancelative =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); rightCancelative_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); antiLeft =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); antiLeft_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (Left.antiLeft_comp a)); antiRight =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); antiRight_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (Left.antiRight_comp a)); treeGlb =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); treeGlb_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None) }

