open Datatypes
open DecSetoid
open DecSetoidProperties
open Lex0
open Logic0
open OrderSemigroup
open OrderSemigroupGlue
open OrderSemigroupProperties
open PreorderProperties
open Product0
open SemigroupProperties
open Specif

type __ = Obj.t

val lexOrderSemigroup :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_OrderSemigroup

val singA_OSmgIso :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IsSingleton -> coq_OSmgIso

val singB_OSmgIso :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IsSingleton -> coq_OSmgIso

val leftMonotonic_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_LeftMonotonic_comp,
  coq_LeftMonotonic_comp) sum, coq_LeftEquivCancelative_comp *
  coq_LeftEquivCondensed_comp) sum -> coq_LeftMonotonic_comp

val rightMonotonic_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_RightMonotonic_comp,
  coq_RightMonotonic_comp) sum, coq_RightEquivCancelative_comp *
  coq_RightEquivCondensed_comp) sum -> coq_RightMonotonic_comp

val hasIdentity_back_a :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_HasIdentity ->
  coq_HasIdentity

val hasIdentity_back_b :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_HasIdentity ->
  coq_HasIdentity

val hasAnnihilator_back_a :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_HasAnnihilator ->
  coq_HasAnnihilator

val hasAnnihilator_back_b :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_HasAnnihilator ->
  coq_HasAnnihilator

val hasTop_back_a :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_HasTop -> coq_HasTop

val hasTop_back_b :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_HasTop -> coq_HasTop

val hasBottom_back_a :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_HasBottom -> coq_HasBottom

val hasBottom_back_b :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_HasBottom -> coq_HasBottom

val leftOpNonDecreasing_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftOpIncreasing_comp *
  (coq_LeftOpNonDecreasing_comp, coq_LeftOpNonDecreasing_comp) sum) ->
  coq_LeftOpNonDecreasing_comp

val rightOpNonDecreasing_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_RightOpIncreasing_comp *
  (coq_RightOpNonDecreasing_comp, coq_RightOpNonDecreasing_comp) sum) ->
  coq_RightOpNonDecreasing_comp

val rightChoiceIncrease_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_RightChoiceIncrease_comp,
  coq_RightChoiceIncrease_comp) sum -> (carrier, (carrier, __) sigT) sigT

val leftChoiceIncrease_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftChoiceIncrease_comp,
  coq_LeftChoiceIncrease_comp) sum -> (carrier, (carrier, __) sigT) sigT

val sond_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup ->
  coq_SelectiveOpNonDecreasing_comp -> (carrier, (carrier, __) sigT) sigT

val sond_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup ->
  coq_SelectiveOpNonDecreasing_comp -> (carrier, (carrier, __) sigT) sigT

val sond_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightChoiceIncrease_comp ->
  coq_RightOpNonDecreasing_comp -> (carrier, (carrier, __) sigT) sigT

val sond_CE_4 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftChoiceIncrease_comp ->
  coq_LeftOpNonDecreasing_comp -> (carrier, (carrier, __) sigT) sigT

val selectiveOpNonDecreasing_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup ->
  ((coq_SelectiveOpNonDecreasing_comp, coq_SelectiveOpNonDecreasing_comp)
  sum, __ * (coq_RightChoiceIncrease_comp * coq_RightOpNonDecreasing_comp,
  coq_LeftChoiceIncrease_comp * coq_LeftOpNonDecreasing_comp) sum) sum ->
  (carrier, (carrier, __) sigT) sigT

val leftOpIncreasing_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftOpNonDecreasing_comp,
  coq_LeftOpIncreasing_comp * coq_LeftOpIncreasing_comp) sum ->
  coq_LeftOpIncreasing_comp

val rightOpIncreasing_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_RightOpNonDecreasing_comp,
  coq_RightOpIncreasing_comp * coq_RightOpIncreasing_comp) sum ->
  coq_RightOpIncreasing_comp

val leftEquivCancelative_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftEquivCancelative_comp,
  coq_LeftEquivCancelative_comp) sum -> coq_LeftEquivCancelative_comp

val rightEquivCancelative_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup ->
  (coq_RightEquivCancelative_comp, coq_RightEquivCancelative_comp) sum ->
  coq_RightEquivCancelative_comp

val leftEquivCondensed_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftEquivCondensed_comp,
  coq_LeftEquivCondensed_comp) sum -> coq_LeftEquivCondensed_comp

val rightEquivCondensed_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_RightEquivCondensed_comp,
  coq_RightEquivCondensed_comp) sum -> coq_RightEquivCondensed_comp

val sel_back :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (__, coq_IsLeft_comp) sum ->
  (__, coq_IsRight_comp) sum -> (__, coq_IsSelective_comp) sum ->
  (coq_IsSingleton, coq_IsSingleton_comp) sum -> (__, coq_IsLeft_comp) sum ->
  (__, coq_IsRight_comp) sum -> (__, coq_IsSelective_comp) sum ->
  (coq_IsSingleton, coq_IsSingleton_comp) sum -> (((__, __) sum, __ *
  coq_IsSingleton) sum, coq_IsSingleton * __) sum

val iaus_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IncompArrowUniqueSrc_comp
  -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val iaus_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IncompArrowUniqueSrc_comp
  -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val incompArrowUniqueSrc_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup ->
  (((((((((coq_IncompArrowUniqueSrc_comp, coq_IncompArrowUniqueSrc_comp) sum,
  coq_IsLeft_comp * __) sum, coq_IsRight_comp * __) sum, coq_IsSelective_comp
  * __) sum, coq_IsSingleton_comp * coq_IsSingleton) sum, coq_IsLeft_comp *
  __) sum, coq_IsRight_comp * __) sum, coq_IsSelective_comp * __) sum,
  coq_IsSingleton_comp * coq_IsSingleton) sum -> (carrier, (carrier,
  (carrier, __) sigT) sigT) sigT

val iaf_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IncompArrowFactor_comp ->
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val iaf_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_IncompArrowFactor_comp ->
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

val incompArrowFactor_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup ->
  (((((((((coq_IncompArrowFactor_comp, coq_IncompArrowFactor_comp) sum,
  coq_IsLeft_comp * __) sum, coq_IsRight_comp * __) sum, coq_IsSelective_comp
  * __) sum, coq_IsSingleton_comp * coq_IsSingleton) sum, coq_IsLeft_comp *
  __) sum, coq_IsRight_comp * __) sum, coq_IsSelective_comp * __) sum,
  coq_IsSingleton_comp * coq_IsSingleton) sum -> (carrier, (carrier,
  (carrier, __) sigT) sigT) sigT

val rightTotal_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_RightTotal_comp,
  coq_RightTotal_comp) sum -> coq_RightTotal_comp

val leftTotal_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftTotal_comp,
  coq_LeftTotal_comp) sum -> coq_LeftTotal_comp

val rmcc_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightMultChoiseComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rmcc_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightMultChoiseComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rmcc_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtSwapEquiv_comp ->
  coq_RightMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val rmcc_CE_4 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightMultSplitComp_comp ->
  coq_RightEquivCondensed_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rmcc_CE_5 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtLeSwapEquiv_comp ->
  coq_RightLtMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rmcc_CE_6 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLeSwapEquiv_comp ->
  coq_RightMultPresLtLe_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rightMultChoiseComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_RightMultChoiseComp_comp,
  coq_RightMultChoiseComp_comp) sum, __ * (((coq_RightLtSwapEquiv_comp *
  coq_RightMultComp_comp, coq_RightMultSplitComp_comp *
  coq_RightEquivCondensed_comp) sum, coq_RightLtLeSwapEquiv_comp *
  coq_RightLtMultComp_comp) sum, coq_RightLeSwapEquiv_comp *
  coq_RightMultPresLtLe_comp) sum) sum -> (carrier, (carrier, (carrier,
  (carrier, __) sigT) sigT) sigT) sigT

val lmcc_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftMultChoiseComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val lmcc_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftMultChoiseComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val lmcc_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtSwapEquiv_comp ->
  coq_LeftMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val lmcc_CE_4 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftMultSplitComp_comp ->
  coq_LeftEquivCondensed_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val lmcc_CE_5 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtLeSwapEquiv_comp ->
  coq_LeftLtMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val lmcc_CE_6 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLeSwapEquiv_comp ->
  coq_LeftMultPresLtLe_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val leftMultChoiseComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_LeftMultChoiseComp_comp,
  coq_LeftMultChoiseComp_comp) sum, __ * (((coq_LeftLtSwapEquiv_comp *
  coq_LeftMultComp_comp, coq_LeftMultSplitComp_comp *
  coq_LeftEquivCondensed_comp) sum, coq_LeftLtLeSwapEquiv_comp *
  coq_LeftLtMultComp_comp) sum, coq_LeftLeSwapEquiv_comp *
  coq_LeftMultPresLtLe_comp) sum) sum -> (carrier, (carrier, (carrier,
  (carrier, __) sigT) sigT) sigT) sigT

val rlse_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtSwapEquiv_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rlse_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtSwapEquiv_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rlse_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtLeSwapEquiv_comp ->
  coq_RightStrictEquiv_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rightLtSwapEquiv_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_RightLtSwapEquiv_comp,
  coq_RightLtSwapEquiv_comp) sum, coq_RightLtLeSwapEquiv_comp *
  coq_RightStrictEquiv_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val rightMultComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_RightMultComp_comp,
  coq_RightMultComp_comp) sum -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rmsc_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightMultSplitComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rmsc_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightMultSplitComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rmsc_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtSwapEquiv_comp ->
  coq_RightMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val rmsc_CE_4 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtLeSwapEquiv_comp ->
  coq_RightLeMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rmsc_CE_5 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLeSwapEquiv_comp ->
  coq_RightLtLeMulpCoh_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rightMultSplitComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup ->
  ((((coq_RightMultSplitComp_comp, coq_RightMultSplitComp_comp) sum,
  coq_RightLtSwapEquiv_comp * coq_RightMultComp_comp) sum,
  coq_RightLtLeSwapEquiv_comp * coq_RightLeMultComp_comp) sum,
  coq_RightLeSwapEquiv_comp * coq_RightLtLeMulpCoh_comp) sum -> (carrier,
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rightLtLeSwapEquiv_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_RightLtLeSwapEquiv_comp,
  coq_RightLtLeSwapEquiv_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val rlmc_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtMultComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rlmc_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtMultComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rlmc_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightStrictEquiv_comp ->
  coq_RightMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val rlmc_CE_4 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLeMultComp_comp ->
  coq_RightEquivCondensed_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rightLtMultComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (((coq_RightLtMultComp_comp,
  coq_RightLtMultComp_comp) sum, coq_RightStrictEquiv_comp *
  coq_RightMultComp_comp) sum, coq_RightLeMultComp_comp *
  coq_RightEquivCondensed_comp) sum -> (carrier, (carrier, (carrier,
  (carrier, __) sigT) sigT) sigT) sigT

val rlese_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLeSwapEquiv_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rlese_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLeSwapEquiv_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rlese_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtLeSwapEquiv_comp ->
  coq_RightLeMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rlese_CE_4 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtSwapEquiv_comp ->
  coq_RightMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val rightLeSwapEquiv_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (((coq_RightLeSwapEquiv_comp,
  coq_RightLeSwapEquiv_comp) sum, coq_RightLtLeSwapEquiv_comp *
  coq_RightLeMultComp_comp) sum, coq_RightLtSwapEquiv_comp *
  coq_RightMultComp_comp) sum -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rmpll_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightMultPresLtLe_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rmpll_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightMultPresLtLe_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rmpll_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLtLeMulpCoh_comp ->
  coq_RightEquivCondensed_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rightMultPresLtLe_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_RightMultPresLtLe_comp,
  coq_RightMultPresLtLe_comp) sum, coq_RightLtLeMulpCoh_comp *
  coq_RightEquivCondensed_comp) sum -> (carrier, (carrier, (carrier,
  (carrier, __) sigT) sigT) sigT) sigT

val rightStrictEquiv_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_RightStrictEquiv_comp,
  coq_RightStrictEquiv_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val rlemc_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLeMultComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rlemc_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightLeMultComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val rlemc_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_RightStrictEquiv_comp ->
  coq_RightMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val rightLeMultComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_RightLeMultComp_comp,
  coq_RightLeMultComp_comp) sum, coq_RightStrictEquiv_comp *
  coq_RightMultComp_comp) sum -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val rightLtLeMulpCoh_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_RightLtLeMulpCoh_comp,
  coq_RightLtLeMulpCoh_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val llse_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtSwapEquiv_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val llse_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtSwapEquiv_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val llse_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtLeSwapEquiv_comp ->
  coq_LeftStrictEquiv_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val leftLtSwapEquiv_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_LeftLtSwapEquiv_comp,
  coq_LeftLtSwapEquiv_comp) sum, coq_LeftLtLeSwapEquiv_comp *
  coq_LeftStrictEquiv_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val leftMultComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftMultComp_comp,
  coq_LeftMultComp_comp) sum -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val lmsc_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftMultSplitComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val lmsc_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftMultSplitComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val lmsc_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtSwapEquiv_comp ->
  coq_LeftMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val lmsc_CE_4 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtLeSwapEquiv_comp ->
  coq_LeftLeMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val lmsc_CE_5 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLeSwapEquiv_comp ->
  coq_LeftLtLeMulpCoh_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val leftMultSplitComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((((coq_LeftMultSplitComp_comp,
  coq_LeftMultSplitComp_comp) sum, coq_LeftLtSwapEquiv_comp *
  coq_LeftMultComp_comp) sum, coq_LeftLtLeSwapEquiv_comp *
  coq_LeftLeMultComp_comp) sum, coq_LeftLeSwapEquiv_comp *
  coq_LeftLtLeMulpCoh_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val leftLtLeSwapEquiv_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftLtLeSwapEquiv_comp,
  coq_LeftLtLeSwapEquiv_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val llmc_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtMultComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val llmc_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtMultComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val llmc_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftStrictEquiv_comp ->
  coq_LeftMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val llmc_CE_4 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLeMultComp_comp ->
  coq_LeftEquivCondensed_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val leftLtMultComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (((coq_LeftLtMultComp_comp,
  coq_LeftLtMultComp_comp) sum, coq_LeftStrictEquiv_comp *
  coq_LeftMultComp_comp) sum, coq_LeftLeMultComp_comp *
  coq_LeftEquivCondensed_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val llese_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLeSwapEquiv_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val llese_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLeSwapEquiv_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val llese_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtLeSwapEquiv_comp ->
  coq_LeftLeMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val llese_CE_4 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtSwapEquiv_comp ->
  coq_LeftMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val leftLeSwapEquiv_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (((coq_LeftLeSwapEquiv_comp,
  coq_LeftLeSwapEquiv_comp) sum, coq_LeftLtLeSwapEquiv_comp *
  coq_LeftLeMultComp_comp) sum, coq_LeftLtSwapEquiv_comp *
  coq_LeftMultComp_comp) sum -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val lmpll_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftMultPresLtLe_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val lmpll_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftMultPresLtLe_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val lmpll_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLtLeMulpCoh_comp ->
  coq_LeftEquivCondensed_comp -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val leftMultPresLtLe_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_LeftMultPresLtLe_comp,
  coq_LeftMultPresLtLe_comp) sum, coq_LeftLtLeMulpCoh_comp *
  coq_LeftEquivCondensed_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val leftStrictEquiv_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftStrictEquiv_comp,
  coq_LeftStrictEquiv_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

val llemc_CE_1 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLeMultComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val llemc_CE_2 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftLeMultComp_comp ->
  (carrier, (carrier, (carrier, (carrier, __) sigT) sigT) sigT) sigT

val llemc_CE_3 :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_LeftStrictEquiv_comp ->
  coq_LeftMultComp_comp -> (carrier, (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT) sigT

val leftLeMultComp_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> ((coq_LeftLeMultComp_comp,
  coq_LeftLeMultComp_comp) sum, coq_LeftStrictEquiv_comp *
  coq_LeftMultComp_comp) sum -> (carrier, (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT) sigT

val leftLtLeMulpCoh_comp :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_LeftLtLeMulpCoh_comp,
  coq_LeftLtLeMulpCoh_comp) sum -> (carrier, (carrier, (carrier, (carrier,
  __) sigT) sigT) sigT) sigT

