open Datatypes
open DecSetoid
open DecSetoidPropRecord
open Lex
open Product7
open Semigroup
open SemigroupPropRecord
open SemigroupProperties
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val lexSemigroup_props :
    coq_Semigroup -> coq_Semigroup -> coq_HasIdentity -> sgProp -> sgProp ->
    sgProp **)

let lexSemigroup_props a b hid ap bp =
  { sg_dsprop =
    (prodDecSetoid_props a.setoid b.setoid ap.sg_dsprop bp.sg_dsprop);
    hasIdentity =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match hasIdentity1 with
       | Some a0 -> Some
           (let Coq_existT (a1, _) = a0 in
           let Coq_existT (b0, _) = hid in
           Coq_existT ((Obj.magic (a1 , b0)), __))
       | None -> None)); hasIdentity_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match hasIdentity_comp1 with
       | Some a0 -> Some (fun x ->
           let x1 , x2 = Obj.magic x in
           let Coq_existT (a1, _) = a0 x1 in
           Coq_existT ((Obj.magic (a1 , b.setoid.choose)), __))
       | None -> None)); hasAnnihilator =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match hasAnnihilator1 with
       | Some a0 ->
           (match hasAnnihilator0 with
              | Some b0 -> Some
                  (let Coq_existT (na, _) = a0 in
                  let Coq_existT (nb, _) = b0 in
                  Coq_existT ((Obj.magic (na , nb)), __))
              | None -> None)
       | None -> None)); hasAnnihilator_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match hasAnnihilator_comp1 with
       | Some a0 -> Some (fun x ->
           Lex.hasAnnihilator_comp a b hid (Coq_inl a0) x)
       | None ->
           (match hasAnnihilator_comp0 with
              | Some b0 -> Some (fun x ->
                  Lex.hasAnnihilator_comp a b hid (Coq_inr b0) x)
              | None -> None))); isSelective =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSelective1 with
       | Some a0 ->
           (match isSelective0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); isSelective_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSelective_comp1 with
       | Some a0 -> Some (Lex.isSelective_comp a b hid (Coq_inl a0))
       | None ->
           (match isSelective_comp0 with
              | Some b0 -> Some (Lex.isSelective_comp a b hid (Coq_inr b0))
              | None -> None))); isCommutative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isCommutative0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isCommutative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isCommutative_comp0 with
       | Some a0 -> Some
           (let Coq_existT (x, s) = a0 in
           let Coq_existT (y, _) = s in
           Coq_existT ((Obj.magic (a.setoid.choose , x)), (Coq_existT
           ((Obj.magic (a.setoid.choose , y)), __))))
       | None -> None)); isIdempotent =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isIdempotent0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isIdempotent_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isIdempotent_comp0 with
       | Some a0 -> Some
           (let Coq_existT (b0, _) = a0 in
           Coq_existT ((Obj.magic (a.setoid.choose , b0)), __))
       | None -> None)); isLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton1 with
       | Some a0 ->
           (match isLeft0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); isLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton_comp1 with
       | Some a0 -> Some (Lex.isLeft_comp a b hid (Coq_inl a0))
       | None ->
           (match isLeft_comp0 with
              | Some b0 -> Some (Lex.isLeft_comp a b hid (Coq_inr b0))
              | None -> None))); isRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton1 with
       | Some a0 ->
           (match isRight0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); isRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton_comp1 with
       | Some a0 -> Some (Lex.isRight_comp a b hid (Coq_inl a0))
       | None ->
           (match isRight_comp0 with
              | Some b0 -> Some (Lex.isRight_comp a b hid (Coq_inr b0))
              | None -> None))); leftCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton1 with
       | Some a0 ->
           (match isSingleton0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); leftCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton_comp1 with
       | Some a0 -> Some (Lex.leftCondensed_comp a b hid (Coq_inl a0))
       | None ->
           (match isSingleton_comp0 with
              | Some b0 -> Some (Lex.leftCondensed_comp a b hid (Coq_inr b0))
              | None -> None))); rightCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton1 with
       | Some a0 ->
           (match isSingleton0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); rightCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton_comp1 with
       | Some a0 -> Some (Lex.rightCondensed_comp a b hid (Coq_inl a0))
       | None ->
           (match isSingleton_comp0 with
              | Some b0 -> Some
                  (Lex.rightCondensed_comp a b hid (Coq_inr b0))
              | None -> None))); leftCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton1 with
       | Some a0 ->
           (match leftCancelative0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); leftCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton_comp1 with
       | Some a0 -> Some (Lex.leftCancelative_comp a b hid (Coq_inl a0))
       | None ->
           (match leftCancelative_comp0 with
              | Some b0 -> Some
                  (Lex.leftCancelative_comp a b hid (Coq_inr b0))
              | None -> None))); rightCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton1 with
       | Some a0 ->
           (match rightCancelative0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); rightCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton_comp1 with
       | Some a0 -> Some (Lex.rightCancelative_comp a b hid (Coq_inl a0))
       | None ->
           (match rightCancelative_comp0 with
              | Some b0 -> Some
                  (Lex.rightCancelative_comp a b hid (Coq_inr b0))
              | None -> None))); antiLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton1 with
       | Some a0 ->
           (match antiLeft0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); antiLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton_comp1 with
       | Some a0 -> Some (Lex.antiLeft_comp a b hid (Coq_inl a0))
       | None ->
           (match antiLeft_comp0 with
              | Some b0 -> Some (Lex.antiLeft_comp a b hid (Coq_inr b0))
              | None -> None))); antiRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton1 with
       | Some a0 ->
           (match antiRight0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); antiRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isSingleton_comp1 with
       | Some a0 -> Some (Lex.antiRight_comp a b hid (Coq_inl a0))
       | None ->
           (match antiRight_comp0 with
              | Some b0 -> Some (Lex.antiRight_comp a b hid (Coq_inr b0))
              | None -> None))); treeGlb =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); treeGlb_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None) }

