open Bisemigroup
open BisemigroupGlue
open DecSetoid
open DecSetoidProperties
open MultiSets
open MultiSetsIntersection
open MultiSetsUnion
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val multisetBisemigroup : coq_DecSetoid -> coq_Bisemigroup **)

let multisetBisemigroup a =
  glueBSmg (multisetIntersectionSemigroup a) (multisetUnionSemigroup a)

(** val sg_multiset_nat_min_plus_bsmgIso :
    coq_DecSetoid -> coq_IsSingleton -> coq_BSmgIso **)

let sg_multiset_nat_min_plus_bsmgIso a sg =
  sg_multiset_nat_dsIso a sg

(** val leftDiscrete_comp :
    coq_DecSetoid -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let leftDiscrete_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic (a.choose :: [])),
    (Coq_existT ((Obj.magic []), __)))))

(** val rightDiscrete_comp :
    coq_DecSetoid -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let rightDiscrete_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic (a.choose :: [])),
    (Coq_existT ((Obj.magic []), __)))))

(** val leftComparable_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let leftComparable_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic (a0 :: (b :: []))), __)))))

(** val rightComparable_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let rightComparable_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic (a0 :: (b :: []))), __)))))

(** val isLeftCompCancel_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isLeftCompCancel_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic []), __)))))

(** val isRightCompCancel_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isRightCompCancel_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic []), __)))))

(** val leftStrictIncreasing_comp :
    coq_DecSetoid -> (carrier, (carrier, __) sigT) sigT **)

let leftStrictIncreasing_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

(** val rightStrictIncreasing_comp :
    coq_DecSetoid -> (carrier, (carrier, __) sigT) sigT **)

let rightStrictIncreasing_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

