open DecSetoid
open Preorder
open Semigroup
open Specif

type __ = Obj.t

type coq_OrderSemigroup = { setoid : coq_DecSetoid;
                            le : (carrier -> carrier -> bool);
                            op : (carrier -> carrier -> carrier) }

val coq_OrderSemigroup_rect :
  (coq_DecSetoid -> (carrier -> carrier -> bool) -> __ -> __ -> __ ->
  (carrier -> carrier -> carrier) -> __ -> __ -> 'a1) -> coq_OrderSemigroup
  -> 'a1

val coq_OrderSemigroup_rec :
  (coq_DecSetoid -> (carrier -> carrier -> bool) -> __ -> __ -> __ ->
  (carrier -> carrier -> carrier) -> __ -> __ -> 'a1) -> coq_OrderSemigroup
  -> 'a1

val setoid : coq_OrderSemigroup -> coq_DecSetoid

val le : coq_OrderSemigroup -> carrier -> carrier -> bool

val op : coq_OrderSemigroup -> carrier -> carrier -> carrier

val preorderOS : coq_OrderSemigroup -> coq_Preorder

val semigroupOS : coq_OrderSemigroup -> coq_Semigroup

val coq_IsOSmgIso_rect :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_DsIso -> (__ -> __ -> __ ->
  __ -> 'a1) -> 'a1

val coq_IsOSmgIso_rec :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_DsIso -> (__ -> __ -> __ ->
  __ -> 'a1) -> 'a1

type coq_OSmgIso =
  coq_DsIso
  (* singleton inductive, whose constructor was Build_OSmgIso *)

val coq_OSmgIso_rect :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_DsIso -> __ -> 'a1) ->
  coq_OSmgIso -> 'a1

val coq_OSmgIso_rec :
  coq_OrderSemigroup -> coq_OrderSemigroup -> (coq_DsIso -> __ -> 'a1) ->
  coq_OSmgIso -> 'a1

val dsIso :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_OSmgIso -> coq_DsIso

val coq_SmgOSmgIso :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_OSmgIso -> coq_SmgIso

val coq_ProOSmgIso :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_OSmgIso -> coq_ProIso

val coq_OSmgIso_refl : coq_OrderSemigroup -> coq_OSmgIso

val coq_OSmgIso_sym :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_OSmgIso -> coq_OSmgIso

val coq_OSmgIso_trans :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_OrderSemigroup ->
  coq_OSmgIso -> coq_OSmgIso -> coq_OSmgIso

val liftOSmgIso :
  coq_DecSetoid -> coq_OrderSemigroup -> coq_DsIso -> (coq_OrderSemigroup,
  coq_OSmgIso * __) sigT

