open DecSetoid
open IdArrow
open OrderSemigroup
open Preorder
open PreorderPropRecord
open Semigroup
open SemigroupPropRecord

(** val glueOSmg : coq_Semigroup -> coq_Preorder -> coq_OrderSemigroup **)

let glueOSmg a b =
  { OrderSemigroup.setoid = b.Preorder.setoid; OrderSemigroup.le = b.le;
    OrderSemigroup.op = a.op }

(** val glueOSmg_IdSmgIso : coq_Semigroup -> coq_Preorder -> coq_IdSmgIso **)

let glueOSmg_IdSmgIso a b =
  let { setoid = setoid0; op = op0 } = a in
  let { Preorder.setoid = setoid1; le = le0 } = b in
  { phi = (fun x -> x); phi' = (fun x -> x) }

(** val glueOSmg_IdProIso : coq_Semigroup -> coq_Preorder -> coq_IdProIso **)

let glueOSmg_IdProIso a b =
  let { setoid = setoid0; op = op0 } = a in
  let { Preorder.setoid = setoid1; le = le0 } = b in
  { phi = (fun x -> x); phi' = (fun x -> x) }

(** val projSmgOSmgIso :
    coq_Semigroup -> coq_Preorder -> sgProp -> sgProp **)

let projSmgOSmgIso a b h =
  let { setoid = setoid0; op = op0 } = a in
  let { Preorder.setoid = setoid1; le = le0 } = b in h

(** val projProOSmgIso :
    coq_Semigroup -> coq_Preorder -> poProp -> poProp **)

let projProOSmgIso a b h =
  let { setoid = setoid0; op = op0 } = a in
  let { Preorder.setoid = setoid1; le = le0 } = b in h

