open OrderSemigroup
open OrderSemigroupProperties
open PreorderPropRecord
open SemigroupPropRecord

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type osProp = { os_sgprop : sgProp; os_poprop : poProp;
                leftMonotonic : __ option;
                leftMonotonic_comp : coq_LeftMonotonic_comp option;
                rightMonotonic : __ option;
                rightMonotonic_comp : coq_RightMonotonic_comp option;
                topIsAnnihilator : __ option;
                topIsAnnihilator_comp : __ option; topIsIdentity : 
                __ option; topIsIdentity_comp : __ option;
                bottomIsAnnihilator : __ option;
                bottomIsAnnihilator_comp : __ option;
                bottomIsIdentity : __ option;
                bottomIsIdentity_comp : __ option;
                leftOpNonDecreasing : __ option;
                leftOpNonDecreasing_comp : coq_LeftOpNonDecreasing_comp
                                           option;
                rightOpNonDecreasing : __ option;
                rightOpNonDecreasing_comp : coq_RightOpNonDecreasing_comp
                                            option;
                selectiveOpNonDecreasing : __ option;
                selectiveOpNonDecreasing_comp : coq_SelectiveOpNonDecreasing_comp
                                                option;
                leftOpIncreasing : __ option;
                leftOpIncreasing_comp : coq_LeftOpIncreasing_comp option;
                rightOpIncreasing : __ option;
                rightOpIncreasing_comp : coq_RightOpIncreasing_comp option;
                leftEquivCancelative : __ option;
                leftEquivCancelative_comp : coq_LeftEquivCancelative_comp
                                            option;
                rightEquivCancelative : __ option;
                rightEquivCancelative_comp : coq_RightEquivCancelative_comp
                                             option;
                leftEquivCondensed : __ option;
                leftEquivCondensed_comp : coq_LeftEquivCondensed_comp option;
                rightEquivCondensed : __ option;
                rightEquivCondensed_comp : coq_RightEquivCondensed_comp
                                           option;
                incompArrowUniqueSrc : __ option;
                incompArrowUniqueSrc_comp : coq_IncompArrowUniqueSrc_comp
                                            option;
                incompArrowFactor : __ option;
                incompArrowFactor_comp : coq_IncompArrowFactor_comp option }

(** val osProp_rect :
    coq_OrderSemigroup -> (sgProp -> poProp -> __ option ->
    coq_LeftMonotonic_comp option -> __ option -> coq_RightMonotonic_comp
    option -> __ option -> __ option -> __ option -> __ option -> __ option
    -> __ option -> __ option -> __ option -> __ option ->
    coq_LeftOpNonDecreasing_comp option -> __ option ->
    coq_RightOpNonDecreasing_comp option -> __ option ->
    coq_SelectiveOpNonDecreasing_comp option -> __ option ->
    coq_LeftOpIncreasing_comp option -> __ option ->
    coq_RightOpIncreasing_comp option -> __ option ->
    coq_LeftEquivCancelative_comp option -> __ option ->
    coq_RightEquivCancelative_comp option -> __ option ->
    coq_LeftEquivCondensed_comp option -> __ option ->
    coq_RightEquivCondensed_comp option -> __ option ->
    coq_IncompArrowUniqueSrc_comp option -> __ option ->
    coq_IncompArrowFactor_comp option -> 'a1) -> osProp -> 'a1 **)

let osProp_rect oS f o =
  let { os_sgprop = x; os_poprop = x0; leftMonotonic = x1;
    leftMonotonic_comp = x2; rightMonotonic = x3; rightMonotonic_comp = x4;
    topIsAnnihilator = x5; topIsAnnihilator_comp = x6; topIsIdentity = x7;
    topIsIdentity_comp = x8; bottomIsAnnihilator = x9;
    bottomIsAnnihilator_comp = x10; bottomIsIdentity = x11;
    bottomIsIdentity_comp = x12; leftOpNonDecreasing = x13;
    leftOpNonDecreasing_comp = x14; rightOpNonDecreasing = x15;
    rightOpNonDecreasing_comp = x16; selectiveOpNonDecreasing = x17;
    selectiveOpNonDecreasing_comp = x18; leftOpIncreasing = x19;
    leftOpIncreasing_comp = x20; rightOpIncreasing = x21;
    rightOpIncreasing_comp = x22; leftEquivCancelative = x23;
    leftEquivCancelative_comp = x24; rightEquivCancelative = x25;
    rightEquivCancelative_comp = x26; leftEquivCondensed = x27;
    leftEquivCondensed_comp = x28; rightEquivCondensed = x29;
    rightEquivCondensed_comp = x30; incompArrowUniqueSrc = x31;
    incompArrowUniqueSrc_comp = x32; incompArrowFactor = x33;
    incompArrowFactor_comp = x34 } = o
  in
  f x x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 x19
    x20 x21 x22 x23 x24 x25 x26 x27 x28 x29 x30 x31 x32 x33 x34

(** val osProp_rec :
    coq_OrderSemigroup -> (sgProp -> poProp -> __ option ->
    coq_LeftMonotonic_comp option -> __ option -> coq_RightMonotonic_comp
    option -> __ option -> __ option -> __ option -> __ option -> __ option
    -> __ option -> __ option -> __ option -> __ option ->
    coq_LeftOpNonDecreasing_comp option -> __ option ->
    coq_RightOpNonDecreasing_comp option -> __ option ->
    coq_SelectiveOpNonDecreasing_comp option -> __ option ->
    coq_LeftOpIncreasing_comp option -> __ option ->
    coq_RightOpIncreasing_comp option -> __ option ->
    coq_LeftEquivCancelative_comp option -> __ option ->
    coq_RightEquivCancelative_comp option -> __ option ->
    coq_LeftEquivCondensed_comp option -> __ option ->
    coq_RightEquivCondensed_comp option -> __ option ->
    coq_IncompArrowUniqueSrc_comp option -> __ option ->
    coq_IncompArrowFactor_comp option -> 'a1) -> osProp -> 'a1 **)

let osProp_rec oS f o =
  let { os_sgprop = x; os_poprop = x0; leftMonotonic = x1;
    leftMonotonic_comp = x2; rightMonotonic = x3; rightMonotonic_comp = x4;
    topIsAnnihilator = x5; topIsAnnihilator_comp = x6; topIsIdentity = x7;
    topIsIdentity_comp = x8; bottomIsAnnihilator = x9;
    bottomIsAnnihilator_comp = x10; bottomIsIdentity = x11;
    bottomIsIdentity_comp = x12; leftOpNonDecreasing = x13;
    leftOpNonDecreasing_comp = x14; rightOpNonDecreasing = x15;
    rightOpNonDecreasing_comp = x16; selectiveOpNonDecreasing = x17;
    selectiveOpNonDecreasing_comp = x18; leftOpIncreasing = x19;
    leftOpIncreasing_comp = x20; rightOpIncreasing = x21;
    rightOpIncreasing_comp = x22; leftEquivCancelative = x23;
    leftEquivCancelative_comp = x24; rightEquivCancelative = x25;
    rightEquivCancelative_comp = x26; leftEquivCondensed = x27;
    leftEquivCondensed_comp = x28; rightEquivCondensed = x29;
    rightEquivCondensed_comp = x30; incompArrowUniqueSrc = x31;
    incompArrowUniqueSrc_comp = x32; incompArrowFactor = x33;
    incompArrowFactor_comp = x34 } = o
  in
  f x x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 x19
    x20 x21 x22 x23 x24 x25 x26 x27 x28 x29 x30 x31 x32 x33 x34

(** val os_sgprop : coq_OrderSemigroup -> osProp -> sgProp **)

let os_sgprop _ x = x.os_sgprop

(** val os_poprop : coq_OrderSemigroup -> osProp -> poProp **)

let os_poprop _ x = x.os_poprop

(** val leftMonotonic : coq_OrderSemigroup -> osProp -> __ option **)

let leftMonotonic _ x = x.leftMonotonic

(** val leftMonotonic_comp :
    coq_OrderSemigroup -> osProp -> coq_LeftMonotonic_comp option **)

let leftMonotonic_comp _ x = x.leftMonotonic_comp

(** val rightMonotonic : coq_OrderSemigroup -> osProp -> __ option **)

let rightMonotonic _ x = x.rightMonotonic

(** val rightMonotonic_comp :
    coq_OrderSemigroup -> osProp -> coq_RightMonotonic_comp option **)

let rightMonotonic_comp _ x = x.rightMonotonic_comp

(** val topIsAnnihilator : coq_OrderSemigroup -> osProp -> __ option **)

let topIsAnnihilator _ x = x.topIsAnnihilator

(** val topIsAnnihilator_comp : coq_OrderSemigroup -> osProp -> __ option **)

let topIsAnnihilator_comp _ x = x.topIsAnnihilator_comp

(** val topIsIdentity : coq_OrderSemigroup -> osProp -> __ option **)

let topIsIdentity _ x = x.topIsIdentity

(** val topIsIdentity_comp : coq_OrderSemigroup -> osProp -> __ option **)

let topIsIdentity_comp _ x = x.topIsIdentity_comp

(** val bottomIsAnnihilator : coq_OrderSemigroup -> osProp -> __ option **)

let bottomIsAnnihilator _ x = x.bottomIsAnnihilator

(** val bottomIsAnnihilator_comp :
    coq_OrderSemigroup -> osProp -> __ option **)

let bottomIsAnnihilator_comp _ x = x.bottomIsAnnihilator_comp

(** val bottomIsIdentity : coq_OrderSemigroup -> osProp -> __ option **)

let bottomIsIdentity _ x = x.bottomIsIdentity

(** val bottomIsIdentity_comp : coq_OrderSemigroup -> osProp -> __ option **)

let bottomIsIdentity_comp _ x = x.bottomIsIdentity_comp

(** val leftOpNonDecreasing : coq_OrderSemigroup -> osProp -> __ option **)

let leftOpNonDecreasing _ x = x.leftOpNonDecreasing

(** val leftOpNonDecreasing_comp :
    coq_OrderSemigroup -> osProp -> coq_LeftOpNonDecreasing_comp option **)

let leftOpNonDecreasing_comp _ x = x.leftOpNonDecreasing_comp

(** val rightOpNonDecreasing : coq_OrderSemigroup -> osProp -> __ option **)

let rightOpNonDecreasing _ x = x.rightOpNonDecreasing

(** val rightOpNonDecreasing_comp :
    coq_OrderSemigroup -> osProp -> coq_RightOpNonDecreasing_comp option **)

let rightOpNonDecreasing_comp _ x = x.rightOpNonDecreasing_comp

(** val selectiveOpNonDecreasing :
    coq_OrderSemigroup -> osProp -> __ option **)

let selectiveOpNonDecreasing _ x = x.selectiveOpNonDecreasing

(** val selectiveOpNonDecreasing_comp :
    coq_OrderSemigroup -> osProp -> coq_SelectiveOpNonDecreasing_comp option **)

let selectiveOpNonDecreasing_comp _ x = x.selectiveOpNonDecreasing_comp

(** val leftOpIncreasing : coq_OrderSemigroup -> osProp -> __ option **)

let leftOpIncreasing _ x = x.leftOpIncreasing

(** val leftOpIncreasing_comp :
    coq_OrderSemigroup -> osProp -> coq_LeftOpIncreasing_comp option **)

let leftOpIncreasing_comp _ x = x.leftOpIncreasing_comp

(** val rightOpIncreasing : coq_OrderSemigroup -> osProp -> __ option **)

let rightOpIncreasing _ x = x.rightOpIncreasing

(** val rightOpIncreasing_comp :
    coq_OrderSemigroup -> osProp -> coq_RightOpIncreasing_comp option **)

let rightOpIncreasing_comp _ x = x.rightOpIncreasing_comp

(** val leftEquivCancelative : coq_OrderSemigroup -> osProp -> __ option **)

let leftEquivCancelative _ x = x.leftEquivCancelative

(** val leftEquivCancelative_comp :
    coq_OrderSemigroup -> osProp -> coq_LeftEquivCancelative_comp option **)

let leftEquivCancelative_comp _ x = x.leftEquivCancelative_comp

(** val rightEquivCancelative : coq_OrderSemigroup -> osProp -> __ option **)

let rightEquivCancelative _ x = x.rightEquivCancelative

(** val rightEquivCancelative_comp :
    coq_OrderSemigroup -> osProp -> coq_RightEquivCancelative_comp option **)

let rightEquivCancelative_comp _ x = x.rightEquivCancelative_comp

(** val leftEquivCondensed : coq_OrderSemigroup -> osProp -> __ option **)

let leftEquivCondensed _ x = x.leftEquivCondensed

(** val leftEquivCondensed_comp :
    coq_OrderSemigroup -> osProp -> coq_LeftEquivCondensed_comp option **)

let leftEquivCondensed_comp _ x = x.leftEquivCondensed_comp

(** val rightEquivCondensed : coq_OrderSemigroup -> osProp -> __ option **)

let rightEquivCondensed _ x = x.rightEquivCondensed

(** val rightEquivCondensed_comp :
    coq_OrderSemigroup -> osProp -> coq_RightEquivCondensed_comp option **)

let rightEquivCondensed_comp _ x = x.rightEquivCondensed_comp

(** val incompArrowUniqueSrc : coq_OrderSemigroup -> osProp -> __ option **)

let incompArrowUniqueSrc _ x = x.incompArrowUniqueSrc

(** val incompArrowUniqueSrc_comp :
    coq_OrderSemigroup -> osProp -> coq_IncompArrowUniqueSrc_comp option **)

let incompArrowUniqueSrc_comp _ x = x.incompArrowUniqueSrc_comp

(** val incompArrowFactor : coq_OrderSemigroup -> osProp -> __ option **)

let incompArrowFactor _ x = x.incompArrowFactor

(** val incompArrowFactor_comp :
    coq_OrderSemigroup -> osProp -> coq_IncompArrowFactor_comp option **)

let incompArrowFactor_comp _ x = x.incompArrowFactor_comp

(** val osPropIso :
    coq_OrderSemigroup -> coq_OrderSemigroup -> coq_OSmgIso -> osProp ->
    osProp **)

let osPropIso o o' i osp =
  { os_sgprop = (sgPropIso (semigroupOS o) (semigroupOS o') i osp.os_sgprop);
    os_poprop = (poPropIso (preorderOS o) (preorderOS o') i osp.os_poprop);
    leftMonotonic =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftMonotonic0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); leftMonotonic_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftMonotonic_comp0 with
       | Some x -> Some (coq_Iso_LeftMonotonic_comp o o' i x)
       | None -> None)); rightMonotonic =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightMonotonic0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); rightMonotonic_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightMonotonic_comp0 with
       | Some x -> Some (coq_Iso_RightMonotonic_comp o o' i x)
       | None -> None)); topIsAnnihilator =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match topIsAnnihilator0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); topIsAnnihilator_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match topIsAnnihilator_comp0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); topIsIdentity =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match topIsIdentity0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); topIsIdentity_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match topIsIdentity_comp0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); bottomIsAnnihilator =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match bottomIsAnnihilator0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); bottomIsAnnihilator_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match bottomIsAnnihilator_comp0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); bottomIsIdentity =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match bottomIsIdentity0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); bottomIsIdentity_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match bottomIsIdentity_comp0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); leftOpNonDecreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftOpNonDecreasing0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); leftOpNonDecreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftOpNonDecreasing_comp0 with
       | Some x -> Some (coq_Iso_LeftOpNonDecreasing_comp o o' i x)
       | None -> None)); rightOpNonDecreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightOpNonDecreasing0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); rightOpNonDecreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightOpNonDecreasing_comp0 with
       | Some x -> Some (coq_Iso_RightOpNonDecreasing_comp o o' i x)
       | None -> None)); selectiveOpNonDecreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match selectiveOpNonDecreasing0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); selectiveOpNonDecreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match selectiveOpNonDecreasing_comp0 with
       | Some x -> Some (fun _ _ ->
           coq_Iso_SelectiveOpNonDecreasing_comp o o' i x)
       | None -> None)); leftOpIncreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftOpIncreasing0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); leftOpIncreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftOpIncreasing_comp0 with
       | Some x -> Some (coq_Iso_LeftOpIncreasing_comp o o' i x)
       | None -> None)); rightOpIncreasing =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightOpIncreasing0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); rightOpIncreasing_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightOpIncreasing_comp0 with
       | Some x -> Some (coq_Iso_RightOpIncreasing_comp o o' i x)
       | None -> None)); leftEquivCancelative =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftEquivCancelative0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); leftEquivCancelative_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftEquivCancelative_comp0 with
       | Some x -> Some (coq_Iso_LeftEquivCancelative_comp o o' i x)
       | None -> None)); rightEquivCancelative =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightEquivCancelative0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); rightEquivCancelative_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightEquivCancelative_comp0 with
       | Some x -> Some (coq_Iso_RightEquivCancelative_comp o o' i x)
       | None -> None)); leftEquivCondensed =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftEquivCondensed0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); leftEquivCondensed_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match leftEquivCondensed_comp0 with
       | Some x -> Some (coq_Iso_LeftEquivCondensed_comp o o' i x)
       | None -> None)); rightEquivCondensed =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightEquivCondensed0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); rightEquivCondensed_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match rightEquivCondensed_comp0 with
       | Some x -> Some (coq_Iso_RightEquivCondensed_comp o o' i x)
       | None -> None)); incompArrowUniqueSrc =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match incompArrowUniqueSrc0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); incompArrowUniqueSrc_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match incompArrowUniqueSrc_comp0 with
       | Some x -> Some (fun _ _ _ _ ->
           coq_Iso_IncompArrowUniqueSrc_comp o o' i x)
       | None -> None)); incompArrowFactor =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match incompArrowFactor0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); incompArrowFactor_comp =
    (let { os_sgprop = os_sgprop0; os_poprop = os_poprop0; leftMonotonic =
       leftMonotonic0; leftMonotonic_comp = leftMonotonic_comp0;
       rightMonotonic = rightMonotonic0; rightMonotonic_comp =
       rightMonotonic_comp0; topIsAnnihilator = topIsAnnihilator0;
       topIsAnnihilator_comp = topIsAnnihilator_comp0; topIsIdentity =
       topIsIdentity0; topIsIdentity_comp = topIsIdentity_comp0;
       bottomIsAnnihilator = bottomIsAnnihilator0; bottomIsAnnihilator_comp =
       bottomIsAnnihilator_comp0; bottomIsIdentity = bottomIsIdentity0;
       bottomIsIdentity_comp = bottomIsIdentity_comp0; leftOpNonDecreasing =
       leftOpNonDecreasing0; leftOpNonDecreasing_comp =
       leftOpNonDecreasing_comp0; rightOpNonDecreasing =
       rightOpNonDecreasing0; rightOpNonDecreasing_comp =
       rightOpNonDecreasing_comp0; selectiveOpNonDecreasing =
       selectiveOpNonDecreasing0; selectiveOpNonDecreasing_comp =
       selectiveOpNonDecreasing_comp0; leftOpIncreasing = leftOpIncreasing0;
       leftOpIncreasing_comp = leftOpIncreasing_comp0; rightOpIncreasing =
       rightOpIncreasing0; rightOpIncreasing_comp = rightOpIncreasing_comp0;
       leftEquivCancelative = leftEquivCancelative0;
       leftEquivCancelative_comp = leftEquivCancelative_comp0;
       rightEquivCancelative = rightEquivCancelative0;
       rightEquivCancelative_comp = rightEquivCancelative_comp0;
       leftEquivCondensed = leftEquivCondensed0; leftEquivCondensed_comp =
       leftEquivCondensed_comp0; rightEquivCondensed = rightEquivCondensed0;
       rightEquivCondensed_comp = rightEquivCondensed_comp0;
       incompArrowUniqueSrc = incompArrowUniqueSrc0;
       incompArrowUniqueSrc_comp = incompArrowUniqueSrc_comp0;
       incompArrowFactor = incompArrowFactor0; incompArrowFactor_comp =
       incompArrowFactor_comp0 } = osp
     in
    (match incompArrowFactor_comp0 with
       | Some x -> Some (fun _ _ _ _ ->
           coq_Iso_IncompArrowFactor_comp o o' i x)
       | None -> None)) }

