open OrderSemigroup
open OrderSemigroupProperties
open PreorderPropRecord
open SemigroupPropRecord

type __ = Obj.t

type osProp = { os_sgprop : sgProp; os_poprop : poProp;
                leftMonotonic : __ option;
                leftMonotonic_comp : coq_LeftMonotonic_comp option;
                rightMonotonic : __ option;
                rightMonotonic_comp : coq_RightMonotonic_comp option;
                topIsAnnihilator : __ option;
                topIsAnnihilator_comp : __ option; topIsIdentity : 
                __ option; topIsIdentity_comp : __ option;
                bottomIsAnnihilator : __ option;
                bottomIsAnnihilator_comp : __ option;
                bottomIsIdentity : __ option;
                bottomIsIdentity_comp : __ option;
                leftOpNonDecreasing : __ option;
                leftOpNonDecreasing_comp : coq_LeftOpNonDecreasing_comp
                                           option;
                rightOpNonDecreasing : __ option;
                rightOpNonDecreasing_comp : coq_RightOpNonDecreasing_comp
                                            option;
                selectiveOpNonDecreasing : __ option;
                selectiveOpNonDecreasing_comp : coq_SelectiveOpNonDecreasing_comp
                                                option;
                leftOpIncreasing : __ option;
                leftOpIncreasing_comp : coq_LeftOpIncreasing_comp option;
                rightOpIncreasing : __ option;
                rightOpIncreasing_comp : coq_RightOpIncreasing_comp option;
                leftEquivCancelative : __ option;
                leftEquivCancelative_comp : coq_LeftEquivCancelative_comp
                                            option;
                rightEquivCancelative : __ option;
                rightEquivCancelative_comp : coq_RightEquivCancelative_comp
                                             option;
                leftEquivCondensed : __ option;
                leftEquivCondensed_comp : coq_LeftEquivCondensed_comp option;
                rightEquivCondensed : __ option;
                rightEquivCondensed_comp : coq_RightEquivCondensed_comp
                                           option;
                incompArrowUniqueSrc : __ option;
                incompArrowUniqueSrc_comp : coq_IncompArrowUniqueSrc_comp
                                            option;
                incompArrowFactor : __ option;
                incompArrowFactor_comp : coq_IncompArrowFactor_comp option }

val osProp_rect :
  coq_OrderSemigroup -> (sgProp -> poProp -> __ option ->
  coq_LeftMonotonic_comp option -> __ option -> coq_RightMonotonic_comp
  option -> __ option -> __ option -> __ option -> __ option -> __ option ->
  __ option -> __ option -> __ option -> __ option ->
  coq_LeftOpNonDecreasing_comp option -> __ option ->
  coq_RightOpNonDecreasing_comp option -> __ option ->
  coq_SelectiveOpNonDecreasing_comp option -> __ option ->
  coq_LeftOpIncreasing_comp option -> __ option -> coq_RightOpIncreasing_comp
  option -> __ option -> coq_LeftEquivCancelative_comp option -> __ option ->
  coq_RightEquivCancelative_comp option -> __ option ->
  coq_LeftEquivCondensed_comp option -> __ option ->
  coq_RightEquivCondensed_comp option -> __ option ->
  coq_IncompArrowUniqueSrc_comp option -> __ option ->
  coq_IncompArrowFactor_comp option -> 'a1) -> osProp -> 'a1

val osProp_rec :
  coq_OrderSemigroup -> (sgProp -> poProp -> __ option ->
  coq_LeftMonotonic_comp option -> __ option -> coq_RightMonotonic_comp
  option -> __ option -> __ option -> __ option -> __ option -> __ option ->
  __ option -> __ option -> __ option -> __ option ->
  coq_LeftOpNonDecreasing_comp option -> __ option ->
  coq_RightOpNonDecreasing_comp option -> __ option ->
  coq_SelectiveOpNonDecreasing_comp option -> __ option ->
  coq_LeftOpIncreasing_comp option -> __ option -> coq_RightOpIncreasing_comp
  option -> __ option -> coq_LeftEquivCancelative_comp option -> __ option ->
  coq_RightEquivCancelative_comp option -> __ option ->
  coq_LeftEquivCondensed_comp option -> __ option ->
  coq_RightEquivCondensed_comp option -> __ option ->
  coq_IncompArrowUniqueSrc_comp option -> __ option ->
  coq_IncompArrowFactor_comp option -> 'a1) -> osProp -> 'a1

val os_sgprop : coq_OrderSemigroup -> osProp -> sgProp

val os_poprop : coq_OrderSemigroup -> osProp -> poProp

val leftMonotonic : coq_OrderSemigroup -> osProp -> __ option

val leftMonotonic_comp :
  coq_OrderSemigroup -> osProp -> coq_LeftMonotonic_comp option

val rightMonotonic : coq_OrderSemigroup -> osProp -> __ option

val rightMonotonic_comp :
  coq_OrderSemigroup -> osProp -> coq_RightMonotonic_comp option

val topIsAnnihilator : coq_OrderSemigroup -> osProp -> __ option

val topIsAnnihilator_comp : coq_OrderSemigroup -> osProp -> __ option

val topIsIdentity : coq_OrderSemigroup -> osProp -> __ option

val topIsIdentity_comp : coq_OrderSemigroup -> osProp -> __ option

val bottomIsAnnihilator : coq_OrderSemigroup -> osProp -> __ option

val bottomIsAnnihilator_comp : coq_OrderSemigroup -> osProp -> __ option

val bottomIsIdentity : coq_OrderSemigroup -> osProp -> __ option

val bottomIsIdentity_comp : coq_OrderSemigroup -> osProp -> __ option

val leftOpNonDecreasing : coq_OrderSemigroup -> osProp -> __ option

val leftOpNonDecreasing_comp :
  coq_OrderSemigroup -> osProp -> coq_LeftOpNonDecreasing_comp option

val rightOpNonDecreasing : coq_OrderSemigroup -> osProp -> __ option

val rightOpNonDecreasing_comp :
  coq_OrderSemigroup -> osProp -> coq_RightOpNonDecreasing_comp option

val selectiveOpNonDecreasing : coq_OrderSemigroup -> osProp -> __ option

val selectiveOpNonDecreasing_comp :
  coq_OrderSemigroup -> osProp -> coq_SelectiveOpNonDecreasing_comp option

val leftOpIncreasing : coq_OrderSemigroup -> osProp -> __ option

val leftOpIncreasing_comp :
  coq_OrderSemigroup -> osProp -> coq_LeftOpIncreasing_comp option

val rightOpIncreasing : coq_OrderSemigroup -> osProp -> __ option

val rightOpIncreasing_comp :
  coq_OrderSemigroup -> osProp -> coq_RightOpIncreasing_comp option

val leftEquivCancelative : coq_OrderSemigroup -> osProp -> __ option

val leftEquivCancelative_comp :
  coq_OrderSemigroup -> osProp -> coq_LeftEquivCancelative_comp option

val rightEquivCancelative : coq_OrderSemigroup -> osProp -> __ option

val rightEquivCancelative_comp :
  coq_OrderSemigroup -> osProp -> coq_RightEquivCancelative_comp option

val leftEquivCondensed : coq_OrderSemigroup -> osProp -> __ option

val leftEquivCondensed_comp :
  coq_OrderSemigroup -> osProp -> coq_LeftEquivCondensed_comp option

val rightEquivCondensed : coq_OrderSemigroup -> osProp -> __ option

val rightEquivCondensed_comp :
  coq_OrderSemigroup -> osProp -> coq_RightEquivCondensed_comp option

val incompArrowUniqueSrc : coq_OrderSemigroup -> osProp -> __ option

val incompArrowUniqueSrc_comp :
  coq_OrderSemigroup -> osProp -> coq_IncompArrowUniqueSrc_comp option

val incompArrowFactor : coq_OrderSemigroup -> osProp -> __ option

val incompArrowFactor_comp :
  coq_OrderSemigroup -> osProp -> coq_IncompArrowFactor_comp option

val osPropIso :
  coq_OrderSemigroup -> coq_OrderSemigroup -> coq_OSmgIso -> osProp -> osProp

