open Bisemigroup
open BisemigroupGlue
open BisemigroupProperties
open Datatypes
open DecSetoid
open DecSetoidProperties
open List0
open Prefix
open Seq0
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val prefixSeqBisemigroup : coq_DecSetoid -> coq_Bisemigroup **)

let prefixSeqBisemigroup a =
  glueBSmg (prefixSemigroup a) (seqSemigroup a)

(** val same : coq_DecSetoid -> carrier -> nat -> carrier **)

let rec same a a0 = function
  | O -> Obj.magic []
  | S n' -> Obj.magic (a0 :: (Obj.magic (fun x x0 -> same a x x0) a0 n'))

(** val sg_ds_isoNatMinPlus :
    coq_DecSetoid -> coq_IsSingleton -> coq_DsIso **)

let sg_ds_isoNatMinPlus a sg =
  { phi = (Obj.magic (fun x -> length x)); phi' =
    (Obj.magic (same a a.choose)) }

(** val sg_isoNatMinPlus :
    coq_DecSetoid -> coq_IsSingleton -> coq_BSmgIso **)

let sg_isoNatMinPlus a sg =
  { phi = (Obj.magic (fun x -> length x)); phi' =
    (Obj.magic (same a a.choose)) }

(** val isRightDistributive_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> coq_IsRightDistributive_comp **)

let isRightDistributive_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic (a0 :: [])), __)))))

(** val isRightStrictStable_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isRightStrictStable_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic (a0 :: [])),
  (Coq_existT ((Obj.magic (b :: [])), __)))))

(** val leftDiscrete_comp :
    coq_DecSetoid -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let leftDiscrete_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic (a.choose :: [])),
    (Coq_existT ((Obj.magic []), __)))))

(** val rightDiscrete_comp :
    coq_DecSetoid -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let rightDiscrete_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic (a.choose :: [])),
    (Coq_existT ((Obj.magic []), __)))))

(** val leftComparable_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let leftComparable_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic []), __)))))

(** val rightComparable_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let rightComparable_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic []), __)))))

(** val isLeftCompCancel_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isLeftCompCancel_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic []), __)))))

(** val isRightCompCancel_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let isRightCompCancel_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), (Coq_existT ((Obj.magic []), __)))))

(** val leftIncreasing_comp :
    coq_DecSetoid -> coq_IsSingleton_comp -> (carrier, (carrier, __) sigT)
    sigT **)

let leftIncreasing_comp a sg =
  let a0 = a.choose in
  let Coq_existT (b, _) = sg a0 in
  Coq_existT ((Obj.magic (a0 :: [])), (Coq_existT (
  (Obj.magic (b :: [])), __)))

(** val leftStrictIncreasing_comp :
    coq_DecSetoid -> (carrier, (carrier, __) sigT) sigT **)

let leftStrictIncreasing_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

(** val rightStrictIncreasing_comp :
    coq_DecSetoid -> (carrier, (carrier, __) sigT) sigT **)

let rightStrictIncreasing_comp a =
  Coq_existT ((Obj.magic []), (Coq_existT ((Obj.magic []), __)))

