open DecSetoid
open Specif

type __ = Obj.t

type coq_Preorder = { setoid : coq_DecSetoid;
                      le : (carrier -> carrier -> bool) }

val coq_Preorder_rect :
  (coq_DecSetoid -> (carrier -> carrier -> bool) -> __ -> __ -> __ -> 'a1) ->
  coq_Preorder -> 'a1

val coq_Preorder_rec :
  (coq_DecSetoid -> (carrier -> carrier -> bool) -> __ -> __ -> __ -> 'a1) ->
  coq_Preorder -> 'a1

val setoid : coq_Preorder -> coq_DecSetoid

val le : coq_Preorder -> carrier -> carrier -> bool

val coq_IsProIso_rect :
  coq_Preorder -> coq_Preorder -> coq_DsIso -> (__ -> __ -> 'a1) -> 'a1

val coq_IsProIso_rec :
  coq_Preorder -> coq_Preorder -> coq_DsIso -> (__ -> __ -> 'a1) -> 'a1

type coq_ProIso =
  coq_DsIso
  (* singleton inductive, whose constructor was Build_ProIso *)

val coq_ProIso_rect :
  coq_Preorder -> coq_Preorder -> (coq_DsIso -> __ -> 'a1) -> coq_ProIso ->
  'a1

val coq_ProIso_rec :
  coq_Preorder -> coq_Preorder -> (coq_DsIso -> __ -> 'a1) -> coq_ProIso ->
  'a1

val dsIso : coq_Preorder -> coq_Preorder -> coq_ProIso -> coq_DsIso

val coq_ProIso_refl : coq_Preorder -> coq_ProIso

val coq_ProIso_sym : coq_Preorder -> coq_Preorder -> coq_ProIso -> coq_ProIso

val coq_ProIso_trans :
  coq_Preorder -> coq_Preorder -> coq_Preorder -> coq_ProIso -> coq_ProIso ->
  coq_ProIso

val liftProIso :
  coq_DecSetoid -> coq_Preorder -> coq_DsIso -> (coq_Preorder, coq_ProIso *
  __) sigT

