open DecSetoid
open DecSetoidPropRecord
open Preorder
open PreorderProperties
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type poProp = { pp_dsprop : dsProp; hasTop : coq_HasTop option;
                hasTop_comp : coq_HasTop_comp option;
                hasBottom : coq_HasBottom option;
                hasBottom_comp : coq_HasBottom_comp option;
                total : __ option; total_comp : coq_Total_comp option;
                antisym : __ option; antisym_comp : 
                coq_Antisym_comp option }

(** val poProp_rect :
    coq_Preorder -> (dsProp -> coq_HasTop option -> coq_HasTop_comp option ->
    coq_HasBottom option -> coq_HasBottom_comp option -> __ option ->
    coq_Total_comp option -> __ option -> coq_Antisym_comp option -> 'a1) ->
    poProp -> 'a1 **)

let poProp_rect p f p0 =
  let { pp_dsprop = x; hasTop = x0; hasTop_comp = x1; hasBottom = x2;
    hasBottom_comp = x3; total = x4; total_comp = x5; antisym = x6;
    antisym_comp = x7 } = p0
  in
  f x x0 x1 x2 x3 x4 x5 x6 x7

(** val poProp_rec :
    coq_Preorder -> (dsProp -> coq_HasTop option -> coq_HasTop_comp option ->
    coq_HasBottom option -> coq_HasBottom_comp option -> __ option ->
    coq_Total_comp option -> __ option -> coq_Antisym_comp option -> 'a1) ->
    poProp -> 'a1 **)

let poProp_rec p f p0 =
  let { pp_dsprop = x; hasTop = x0; hasTop_comp = x1; hasBottom = x2;
    hasBottom_comp = x3; total = x4; total_comp = x5; antisym = x6;
    antisym_comp = x7 } = p0
  in
  f x x0 x1 x2 x3 x4 x5 x6 x7

(** val pp_dsprop : coq_Preorder -> poProp -> dsProp **)

let pp_dsprop _ x = x.pp_dsprop

(** val hasTop : coq_Preorder -> poProp -> coq_HasTop option **)

let hasTop _ x = x.hasTop

(** val hasTop_comp : coq_Preorder -> poProp -> coq_HasTop_comp option **)

let hasTop_comp _ x = x.hasTop_comp

(** val hasBottom : coq_Preorder -> poProp -> coq_HasBottom option **)

let hasBottom _ x = x.hasBottom

(** val hasBottom_comp :
    coq_Preorder -> poProp -> coq_HasBottom_comp option **)

let hasBottom_comp _ x = x.hasBottom_comp

(** val total : coq_Preorder -> poProp -> __ option **)

let total _ x = x.total

(** val total_comp : coq_Preorder -> poProp -> coq_Total_comp option **)

let total_comp _ x = x.total_comp

(** val antisym : coq_Preorder -> poProp -> __ option **)

let antisym _ x = x.antisym

(** val antisym_comp : coq_Preorder -> poProp -> coq_Antisym_comp option **)

let antisym_comp _ x = x.antisym_comp

(** val poPropIso :
    coq_Preorder -> coq_Preorder -> coq_ProIso -> poProp -> poProp **)

let poPropIso p p' i pop =
  { pp_dsprop = (dsPropIso p.setoid p'.setoid i pop.pp_dsprop); hasTop =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = pop
     in
    (match hasTop0 with
       | Some x -> Some
           (let Coq_existT (x0, _) = x in Coq_existT ((i.phi x0), __))
       | None -> None)); hasTop_comp =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = pop
     in
    (match hasTop_comp0 with
       | Some x -> Some (coq_Iso_HasTop_comp p p' i x)
       | None -> None)); hasBottom =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = pop
     in
    (match hasBottom0 with
       | Some x -> Some
           (let Coq_existT (x0, _) = x in Coq_existT ((i.phi x0), __))
       | None -> None)); hasBottom_comp =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = pop
     in
    (match hasBottom_comp0 with
       | Some x -> Some (coq_Iso_HasBottom_comp p p' i x)
       | None -> None)); total =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = pop
     in
    (match total0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); total_comp =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = pop
     in
    (match total_comp0 with
       | Some x -> Some (coq_Iso_Total_comp p p' i x)
       | None -> None)); antisym =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = pop
     in
    (match antisym0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); antisym_comp =
    (let { pp_dsprop = pp_dsprop0; hasTop = hasTop0; hasTop_comp =
       hasTop_comp0; hasBottom = hasBottom0; hasBottom_comp =
       hasBottom_comp0; total = total0; total_comp = total_comp0; antisym =
       antisym0; antisym_comp = antisym_comp0 } = pop
     in
    (match antisym_comp0 with
       | Some x -> Some (coq_Iso_Antisym_comp p p' i x)
       | None -> None)) }

