open DecSetoid
open DecSetoidPropRecord
open Preorder
open PreorderProperties
open Specif

type __ = Obj.t

type poProp = { pp_dsprop : dsProp; hasTop : coq_HasTop option;
                hasTop_comp : coq_HasTop_comp option;
                hasBottom : coq_HasBottom option;
                hasBottom_comp : coq_HasBottom_comp option;
                total : __ option; total_comp : coq_Total_comp option;
                antisym : __ option; antisym_comp : 
                coq_Antisym_comp option }

val poProp_rect :
  coq_Preorder -> (dsProp -> coq_HasTop option -> coq_HasTop_comp option ->
  coq_HasBottom option -> coq_HasBottom_comp option -> __ option ->
  coq_Total_comp option -> __ option -> coq_Antisym_comp option -> 'a1) ->
  poProp -> 'a1

val poProp_rec :
  coq_Preorder -> (dsProp -> coq_HasTop option -> coq_HasTop_comp option ->
  coq_HasBottom option -> coq_HasBottom_comp option -> __ option ->
  coq_Total_comp option -> __ option -> coq_Antisym_comp option -> 'a1) ->
  poProp -> 'a1

val pp_dsprop : coq_Preorder -> poProp -> dsProp

val hasTop : coq_Preorder -> poProp -> coq_HasTop option

val hasTop_comp : coq_Preorder -> poProp -> coq_HasTop_comp option

val hasBottom : coq_Preorder -> poProp -> coq_HasBottom option

val hasBottom_comp : coq_Preorder -> poProp -> coq_HasBottom_comp option

val total : coq_Preorder -> poProp -> __ option

val total_comp : coq_Preorder -> poProp -> coq_Total_comp option

val antisym : coq_Preorder -> poProp -> __ option

val antisym_comp : coq_Preorder -> poProp -> coq_Antisym_comp option

val poPropIso :
  coq_Preorder -> coq_Preorder -> coq_ProIso -> poProp -> poProp

