open Datatypes
open DecSetoid
open DecSetoidPropRecord
open Product7
open Product0
open Semigroup
open SemigroupPropRecord
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val prodSemigroup_props :
    coq_Semigroup -> coq_Semigroup -> sgProp -> sgProp -> sgProp **)

let prodSemigroup_props a b ap bp =
  { sg_dsprop =
    (prodDecSetoid_props a.setoid b.setoid ap.sg_dsprop bp.sg_dsprop);
    hasIdentity =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match hasIdentity1 with
       | Some a0 ->
           (match hasIdentity0 with
              | Some b0 -> Some
                  (let Coq_existT (a1, _) = a0 in
                  let Coq_existT (b1, _) = b0 in
                  Coq_existT ((Obj.magic (a1 , b1)), __))
              | None -> None)
       | None -> None)); hasIdentity_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match hasIdentity_comp1 with
       | Some a0 -> Some (Product0.hasIdentity_comp a b (Coq_inl a0))
       | None ->
           (match hasIdentity_comp0 with
              | Some b0 -> Some (Product0.hasIdentity_comp a b (Coq_inr b0))
              | None -> None))); hasAnnihilator =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match hasAnnihilator1 with
       | Some a0 ->
           (match hasAnnihilator0 with
              | Some b0 -> Some
                  (let Coq_existT (a1, _) = a0 in
                  let Coq_existT (b1, _) = b0 in
                  Coq_existT ((Obj.magic (a1 , b1)), __))
              | None -> None)
       | None -> None)); hasAnnihilator_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match hasAnnihilator_comp1 with
       | Some a0 -> Some (Product0.hasAnnihilator_comp a b (Coq_inl a0))
       | None ->
           (match hasAnnihilator_comp0 with
              | Some b0 -> Some
                  (Product0.hasAnnihilator_comp a b (Coq_inr b0))
              | None -> None))); isSelective =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isLeft1 with
       | Some a0 ->
           (match isLeft0 with
              | Some b0 -> Some
                  (Obj.magic __ (Coq_inl (Coq_inl (Coq_inl (a0 , b0)))))
              | None ->
                  (match isRight1 with
                     | Some a1 ->
                         (match isRight0 with
                            | Some b0 -> Some
                                (Obj.magic __ (Coq_inl (Coq_inl (Coq_inr (a1
                                  , b0)))))
                            | None ->
                                (match isSelective1 with
                                   | Some a2 ->
                                       (match isSingleton0 with
                                          | Some b0 -> Some
                                              (Obj.magic __ (Coq_inl (Coq_inr
                                                (a2 , b0))))
                                          | None ->
                                              (match isSelective0 with
                                                 | 
                                               Some a3 ->
                                                 (match isSingleton1 with
                                                    | 
                                                  Some b0 -> Some
                                                  (Obj.magic __ (Coq_inr (a3
                                                  , b0)))
                                                    | 
                                                  None -> None)
                                                 | 
                                               None -> None))
                                   | None ->
                                       (match isSelective0 with
                                          | Some a2 ->
                                              (match isSingleton1 with
                                                 | 
                                               Some b0 -> Some
                                                 (Obj.magic __ (Coq_inr (a2 ,
                                                  b0)))
                                                 | 
                                               None -> None)
                                          | None -> None)))
                     | None ->
                         (match isSelective1 with
                            | Some a1 ->
                                (match isSingleton0 with
                                   | Some b0 -> Some
                                       (Obj.magic __ (Coq_inl (Coq_inr (a1 ,
                                         b0))))
                                   | None ->
                                       (match isSelective0 with
                                          | Some a2 ->
                                              (match isSingleton1 with
                                                 | 
                                               Some b0 -> Some
                                                 (Obj.magic __ (Coq_inr (a2 ,
                                                  b0)))
                                                 | 
                                               None -> None)
                                          | None -> None))
                            | None ->
                                (match isSelective0 with
                                   | Some a1 ->
                                       (match isSingleton1 with
                                          | Some b0 -> Some
                                              (Obj.magic __ (Coq_inr (a1 ,
                                                b0)))
                                          | None -> None)
                                   | None -> None))))
       | None ->
           (match isRight1 with
              | Some a0 ->
                  (match isRight0 with
                     | Some b0 -> Some
                         (Obj.magic __ (Coq_inl (Coq_inl (Coq_inr (a0 ,
                           b0)))))
                     | None ->
                         (match isSelective1 with
                            | Some a1 ->
                                (match isSingleton0 with
                                   | Some b0 -> Some
                                       (Obj.magic __ (Coq_inl (Coq_inr (a1 ,
                                         b0))))
                                   | None ->
                                       (match isSelective0 with
                                          | Some a2 ->
                                              (match isSingleton1 with
                                                 | 
                                               Some b0 -> Some
                                                 (Obj.magic __ (Coq_inr (a2 ,
                                                  b0)))
                                                 | 
                                               None -> None)
                                          | None -> None))
                            | None ->
                                (match isSelective0 with
                                   | Some a1 ->
                                       (match isSingleton1 with
                                          | Some b0 -> Some
                                              (Obj.magic __ (Coq_inr (a1 ,
                                                b0)))
                                          | None -> None)
                                   | None -> None)))
              | None ->
                  (match isSelective1 with
                     | Some a0 ->
                         (match isSingleton0 with
                            | Some b0 -> Some
                                (Obj.magic __ (Coq_inl (Coq_inr (a0 , b0))))
                            | None ->
                                (match isSelective0 with
                                   | Some a1 ->
                                       (match isSingleton1 with
                                          | Some b0 -> Some
                                              (Obj.magic __ (Coq_inr (a1 ,
                                                b0)))
                                          | None -> None)
                                   | None -> None))
                     | None ->
                         (match isSelective0 with
                            | Some a0 ->
                                (match isSingleton1 with
                                   | Some b0 -> Some
                                       (Obj.magic __ (Coq_inr (a0 , b0)))
                                   | None -> None)
                            | None -> None))))); isSelective_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isLeft_comp1 with
       | Some a0 ->
           (match isRight_comp1 with
              | Some a1 ->
                  (match isSelective_comp1 with
                     | Some a2 ->
                         (match isSelective_comp0 with
                            | Some a3 -> Some
                                (Product0.isSelective_comp a b ((((Coq_inl
                                  a0) , (Coq_inl a1)) , (Coq_inl a2)) ,
                                  (Coq_inl a3)))
                            | None ->
                                (match isSingleton_comp1 with
                                   | Some b0 -> Some
                                       (Product0.isSelective_comp a b
                                         ((((Coq_inl a0) , (Coq_inl a1)) ,
                                         (Coq_inl a2)) , (Coq_inr b0)))
                                   | None -> None))
                     | None ->
                         (match isSingleton_comp0 with
                            | Some b0 ->
                                (match isSelective_comp0 with
                                   | Some a2 -> Some
                                       (Product0.isSelective_comp a b
                                         ((((Coq_inl a0) , (Coq_inl a1)) ,
                                         (Coq_inr b0)) , (Coq_inl a2)))
                                   | None ->
                                       (match isSingleton_comp1 with
                                          | Some b1 -> Some
                                              (Product0.isSelective_comp a b
                                                ((((Coq_inl a0) , (Coq_inl
                                                a1)) , (Coq_inr b0)) ,
                                                (Coq_inr b1)))
                                          | None -> None))
                            | None -> None))
              | None ->
                  (match isRight_comp0 with
                     | Some b0 ->
                         (match isSelective_comp1 with
                            | Some a1 ->
                                (match isSelective_comp0 with
                                   | Some a2 -> Some
                                       (Product0.isSelective_comp a b
                                         ((((Coq_inl a0) , (Coq_inr b0)) ,
                                         (Coq_inl a1)) , (Coq_inl a2)))
                                   | None ->
                                       (match isSingleton_comp1 with
                                          | Some b1 -> Some
                                              (Product0.isSelective_comp a b
                                                ((((Coq_inl a0) , (Coq_inr
                                                b0)) , (Coq_inl a1)) ,
                                                (Coq_inr b1)))
                                          | None -> None))
                            | None ->
                                (match isSingleton_comp0 with
                                   | Some b1 ->
                                       (match isSelective_comp0 with
                                          | Some a1 -> Some
                                              (Product0.isSelective_comp a b
                                                ((((Coq_inl a0) , (Coq_inr
                                                b0)) , (Coq_inr b1)) ,
                                                (Coq_inl a1)))
                                          | None ->
                                              (match isSingleton_comp1 with
                                                 | 
                                               Some b2 -> Some
                                                 (Product0.isSelective_comp a
                                                  b ((((Coq_inl a0) ,
                                                  (Coq_inr b0)) , (Coq_inr
                                                  b1)) , (Coq_inr b2)))
                                                 | 
                                               None -> None))
                                   | None -> None))
                     | None -> None))
       | None ->
           (match isLeft_comp0 with
              | Some b0 ->
                  (match isRight_comp1 with
                     | Some a0 ->
                         (match isSelective_comp1 with
                            | Some a1 ->
                                (match isSelective_comp0 with
                                   | Some a2 -> Some
                                       (Product0.isSelective_comp a b
                                         ((((Coq_inr b0) , (Coq_inl a0)) ,
                                         (Coq_inl a1)) , (Coq_inl a2)))
                                   | None ->
                                       (match isSingleton_comp1 with
                                          | Some b1 -> Some
                                              (Product0.isSelective_comp a b
                                                ((((Coq_inr b0) , (Coq_inl
                                                a0)) , (Coq_inl a1)) ,
                                                (Coq_inr b1)))
                                          | None -> None))
                            | None ->
                                (match isSingleton_comp0 with
                                   | Some b1 ->
                                       (match isSelective_comp0 with
                                          | Some a1 -> Some
                                              (Product0.isSelective_comp a b
                                                ((((Coq_inr b0) , (Coq_inl
                                                a0)) , (Coq_inr b1)) ,
                                                (Coq_inl a1)))
                                          | None ->
                                              (match isSingleton_comp1 with
                                                 | 
                                               Some b2 -> Some
                                                 (Product0.isSelective_comp a
                                                  b ((((Coq_inr b0) ,
                                                  (Coq_inl a0)) , (Coq_inr
                                                  b1)) , (Coq_inr b2)))
                                                 | 
                                               None -> None))
                                   | None -> None))
                     | None ->
                         (match isRight_comp0 with
                            | Some b1 ->
                                (match isSelective_comp1 with
                                   | Some a0 ->
                                       (match isSelective_comp0 with
                                          | Some a1 -> Some
                                              (Product0.isSelective_comp a b
                                                ((((Coq_inr b0) , (Coq_inr
                                                b1)) , (Coq_inl a0)) ,
                                                (Coq_inl a1)))
                                          | None ->
                                              (match isSingleton_comp1 with
                                                 | 
                                               Some b2 -> Some
                                                 (Product0.isSelective_comp a
                                                  b ((((Coq_inr b0) ,
                                                  (Coq_inr b1)) , (Coq_inl
                                                  a0)) , (Coq_inr b2)))
                                                 | 
                                               None -> None))
                                   | None ->
                                       (match isSingleton_comp0 with
                                          | Some b2 ->
                                              (match isSelective_comp0 with
                                                 | 
                                               Some a0 -> Some
                                                 (Product0.isSelective_comp a
                                                  b ((((Coq_inr b0) ,
                                                  (Coq_inr b1)) , (Coq_inr
                                                  b2)) , (Coq_inl a0)))
                                                 | 
                                               None ->
                                                 (match isSingleton_comp1 with
                                                    | 
                                                  Some b3 -> Some
                                                  (Product0.isSelective_comp
                                                  a b ((((Coq_inr b0) ,
                                                  (Coq_inr b1)) , (Coq_inr
                                                  b2)) , (Coq_inr b3)))
                                                    | 
                                                  None -> None))
                                          | None -> None))
                            | None -> None))
              | None -> None))); isCommutative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isCommutative1 with
       | Some a0 ->
           (match isCommutative0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); isCommutative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isCommutative_comp1 with
       | Some a0 -> Some (Product0.isCommutative_comp a b (Coq_inl a0))
       | None ->
           (match isCommutative_comp0 with
              | Some b0 -> Some
                  (Product0.isCommutative_comp a b (Coq_inr b0))
              | None -> None))); isIdempotent =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isIdempotent1 with
       | Some a0 ->
           (match isIdempotent0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); isIdempotent_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isIdempotent_comp1 with
       | Some a0 -> Some
           (let Coq_existT (a1, _) = a0 in
           Coq_existT ((Obj.magic (a1 , b.setoid.choose)), __))
       | None ->
           (match isIdempotent_comp0 with
              | Some b0 -> Some
                  (let Coq_existT (b1, _) = b0 in
                  Coq_existT ((Obj.magic (a.setoid.choose , b1)), __))
              | None -> None))); isLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isLeft1 with
       | Some a0 ->
           (match isLeft0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); isLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isLeft_comp1 with
       | Some a0 -> Some (Product0.isLeft_comp a b (Coq_inl a0))
       | None ->
           (match isLeft_comp0 with
              | Some b0 -> Some (Product0.isLeft_comp a b (Coq_inr b0))
              | None -> None))); isRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isRight1 with
       | Some a0 ->
           (match isRight0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); isRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match isRight_comp1 with
       | Some a0 -> Some (Product0.isRight_comp a b (Coq_inl a0))
       | None ->
           (match isRight_comp0 with
              | Some b0 -> Some (Product0.isRight_comp a b (Coq_inr b0))
              | None -> None))); leftCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match leftCondensed1 with
       | Some a0 ->
           (match leftCondensed0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); leftCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match leftCondensed_comp1 with
       | Some a0 -> Some (Product0.leftCondensed_comp a b (Coq_inl a0))
       | None ->
           (match leftCondensed_comp0 with
              | Some b0 -> Some
                  (Product0.leftCondensed_comp a b (Coq_inr b0))
              | None -> None))); rightCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match rightCondensed1 with
       | Some a0 ->
           (match rightCondensed0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); rightCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match rightCondensed_comp1 with
       | Some a0 -> Some (Product0.rightCondensed_comp a b (Coq_inl a0))
       | None ->
           (match rightCondensed_comp0 with
              | Some b0 -> Some
                  (Product0.rightCondensed_comp a b (Coq_inr b0))
              | None -> None))); leftCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match leftCancelative1 with
       | Some a0 ->
           (match leftCancelative0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); leftCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match leftCancelative_comp1 with
       | Some a0 -> Some (Product0.leftCancelative_comp a b (Coq_inl a0))
       | None ->
           (match leftCancelative_comp0 with
              | Some b0 -> Some
                  (Product0.leftCancelative_comp a b (Coq_inr b0))
              | None -> None))); rightCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match rightCancelative1 with
       | Some a0 ->
           (match rightCancelative0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); rightCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match rightCancelative_comp1 with
       | Some a0 -> Some (Product0.rightCancelative_comp a b (Coq_inl a0))
       | None ->
           (match rightCancelative_comp0 with
              | Some b0 -> Some
                  (Product0.rightCancelative_comp a b (Coq_inr b0))
              | None -> None))); antiLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match antiLeft1 with
       | Some a0 -> Some (Obj.magic __ (Coq_inl a0))
       | None ->
           (match antiLeft0 with
              | Some b0 -> Some (Obj.magic __ (Coq_inr b0))
              | None -> None))); antiLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match antiLeft_comp1 with
       | Some a0 ->
           (match antiLeft_comp0 with
              | Some b0 -> Some
                  (let Coq_existT (x1, s) = a0 in
                  let Coq_existT (y1, _) = s in
                  let Coq_existT (x2, s0) = b0 in
                  let Coq_existT (y2, _) = s0 in
                  Coq_existT ((Obj.magic (x1 , x2)), (Coq_existT
                  ((Obj.magic (y1 , y2)), __))))
              | None -> None)
       | None -> None)); antiRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match antiRight1 with
       | Some a0 -> Some (Obj.magic __ (Coq_inl a0))
       | None ->
           (match antiRight0 with
              | Some b0 -> Some (Obj.magic __ (Coq_inr b0))
              | None -> None))); antiRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match antiRight_comp1 with
       | Some a0 ->
           (match antiRight_comp0 with
              | Some b0 -> Some
                  (let Coq_existT (x1, s) = a0 in
                  let Coq_existT (y1, _) = s in
                  let Coq_existT (x2, s0) = b0 in
                  let Coq_existT (y2, _) = s0 in
                  Coq_existT ((Obj.magic (x1 , x2)), (Coq_existT
                  ((Obj.magic (y1 , y2)), __))))
              | None -> None)
       | None -> None)); treeGlb =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match treeGlb1 with
       | Some a0 ->
           (match isSingleton0 with
              | Some b0 -> Some (Obj.magic __ (Coq_inl (a0 , b0)))
              | None ->
                  (match treeGlb0 with
                     | Some a1 ->
                         (match isSingleton1 with
                            | Some b0 -> Some
                                (Obj.magic __ (Coq_inr (a1 , b0)))
                            | None -> None)
                     | None -> None))
       | None ->
           (match treeGlb0 with
              | Some a0 ->
                  (match isSingleton1 with
                     | Some b0 -> Some (Obj.magic __ (Coq_inr (a0 , b0)))
                     | None -> None)
              | None -> None))); treeGlb_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      ap
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match treeGlb_comp1 with
       | Some a0 ->
           (match treeGlb_comp0 with
              | Some a1 -> Some (fun _ _ ->
                  Product0.treeGlb_comp a b ((Coq_inl a0) , (Coq_inl a1)))
              | None ->
                  (match isSingleton_comp1 with
                     | Some b0 -> Some (fun _ _ ->
                         Product0.treeGlb_comp a b ((Coq_inl a0) , (Coq_inr
                           b0)))
                     | None -> None))
       | None ->
           (match isSingleton_comp0 with
              | Some b0 ->
                  (match treeGlb_comp0 with
                     | Some a0 -> Some (fun _ _ ->
                         Product0.treeGlb_comp a b ((Coq_inr b0) , (Coq_inl
                           a0)))
                     | None ->
                         (match isSingleton_comp1 with
                            | Some b1 -> Some (fun _ _ ->
                                Product0.treeGlb_comp a b ((Coq_inr b0) ,
                                  (Coq_inr b1)))
                            | None -> None))
              | None -> None))) }

