open Bisemigroup
open BisemigroupGlue
open BisemigroupProperties
open DecSetoid
open RevOp
open SemigroupProperties
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val revTimesBisemigroup : coq_Bisemigroup -> coq_Bisemigroup **)

let revTimesBisemigroup a =
  glueBSmg (plusSmg a) (revOpSemigroup (timesSmg a))

(** val isLeftDistributive_comp :
    coq_Bisemigroup -> coq_IsRightDistributive_comp ->
    coq_IsLeftDistributive_comp **)

let isLeftDistributive_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, s0) = s in
      let Coq_existT (z, _) = s0 in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (z, __)))))

(** val isRightDistributive_comp :
    coq_Bisemigroup -> coq_IsLeftDistributive_comp ->
    coq_IsRightDistributive_comp **)

let isRightDistributive_comp a = function
  | Coq_existT (x0, s) ->
      let Coq_existT (y, s0) = s in
      let Coq_existT (z, _) = s0 in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (z, __)))))

(** val ann_back :
    coq_Bisemigroup -> coq_HasAnnihilator -> coq_HasAnnihilator **)

let ann_back a = function
  | Coq_existT (a0, _) -> Coq_existT (a0, __)

(** val id_back : coq_Bisemigroup -> coq_HasIdentity -> coq_HasIdentity **)

let id_back a = function
  | Coq_existT (a0, _) -> Coq_existT (a0, __)

(** val isRightStrictStable_comp :
    coq_Bisemigroup -> coq_IsLeftStrictStable_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isRightStrictStable_comp a lss =
  let Coq_existT (x, s) = lss __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val isLeftStrictStable_comp :
    coq_Bisemigroup -> coq_IsRightStrictStable_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isLeftStrictStable_comp a lss =
  let Coq_existT (x, s) = lss __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val leftDiscrete_comp :
    coq_Bisemigroup -> coq_RightDiscrete_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let leftDiscrete_comp a rd =
  let Coq_existT (x, s) = rd __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val rightDiscrete_comp :
    coq_Bisemigroup -> coq_LeftDiscrete_comp -> (carrier, (carrier, (carrier,
    __) sigT) sigT) sigT **)

let rightDiscrete_comp a rd =
  let Coq_existT (x, s) = rd __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val leftComparable_comp :
    coq_Bisemigroup -> coq_RightComparable_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let leftComparable_comp a rc =
  let Coq_existT (x, s) = rc __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val rightComparable_comp :
    coq_Bisemigroup -> coq_LeftComparable_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let rightComparable_comp a rc =
  let Coq_existT (x, s) = rc __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val isLeftCompEqCancel_comp :
    coq_Bisemigroup -> coq_IsRightCompEqCancel_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isLeftCompEqCancel_comp a p =
  let Coq_existT (x, s) = p __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val isRightCompEqCancel_comp :
    coq_Bisemigroup -> coq_IsLeftCompEqCancel_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isRightCompEqCancel_comp a p =
  let Coq_existT (x, s) = p __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val isLeftCompCancel_comp :
    coq_Bisemigroup -> coq_IsRightCompCancel_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isLeftCompCancel_comp a p =
  let Coq_existT (x, s) = p __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val isRightCompCancel_comp :
    coq_Bisemigroup -> coq_IsLeftCompCancel_comp -> (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT **)

let isRightCompCancel_comp a p =
  let Coq_existT (x, s) = p __ __ in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val leftIncreasing_comp :
    coq_Bisemigroup -> coq_RightIncreasing_comp -> (carrier, (carrier, __)
    sigT) sigT **)

let leftIncreasing_comp a p =
  let Coq_existT (x, s) = p __ __ in
  let Coq_existT (y, _) = s in Coq_existT (x, (Coq_existT (y, __)))

(** val rightIncreasing_comp :
    coq_Bisemigroup -> coq_LeftIncreasing_comp -> (carrier, (carrier, __)
    sigT) sigT **)

let rightIncreasing_comp a p =
  let Coq_existT (x, s) = p __ __ in
  let Coq_existT (y, _) = s in Coq_existT (x, (Coq_existT (y, __)))

(** val leftStrictIncreasing_comp :
    coq_Bisemigroup -> coq_RightStrictIncreasing_comp -> (carrier, (carrier,
    __) sigT) sigT **)

let leftStrictIncreasing_comp a p =
  let Coq_existT (x, s) = p __ __ in
  let Coq_existT (y, _) = s in Coq_existT (x, (Coq_existT (y, __)))

(** val rightStrictIncreasing_comp :
    coq_Bisemigroup -> coq_LeftStrictIncreasing_comp -> (carrier, (carrier,
    __) sigT) sigT **)

let rightStrictIncreasing_comp a p =
  let Coq_existT (x, s) = p __ __ in
  let Coq_existT (y, _) = s in Coq_existT (x, (Coq_existT (y, __)))

(** val isLeftTimesMapToIdConstantPlus_comp :
    coq_Bisemigroup -> coq_IsRightTimesMapToIdConstantPlus_comp ->
    coq_IsLeftTimesMapToIdConstantPlus_comp **)

let isLeftTimesMapToIdConstantPlus_comp a p hid =
  let Coq_existT (x, s) = p hid in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val isRightTimesMapToIdConstantPlus_comp :
    coq_Bisemigroup -> coq_IsLeftTimesMapToIdConstantPlus_comp ->
    coq_IsRightTimesMapToIdConstantPlus_comp **)

let isRightTimesMapToIdConstantPlus_comp a p hid =
  let Coq_existT (x, s) = p hid in
  let Coq_existT (y, s0) = s in
  let Coq_existT (z, _) = s0 in
  Coq_existT (x, (Coq_existT (y, (Coq_existT (z, __)))))

(** val plusIdentityIsTimesLeftAnnihilator_comp :
    coq_Bisemigroup -> coq_PlusIdentityIsTimesRightAnnihilator_comp ->
    coq_PlusIdentityIsTimesLeftAnnihilator_comp **)

let plusIdentityIsTimesLeftAnnihilator_comp a p hid =
  let Coq_existT (x, _) = p hid in Coq_existT (x, __)

(** val plusIdentityIsTimesRightAnnihilator_comp :
    coq_Bisemigroup -> coq_PlusIdentityIsTimesLeftAnnihilator_comp ->
    coq_PlusIdentityIsTimesRightAnnihilator_comp **)

let plusIdentityIsTimesRightAnnihilator_comp a p hid =
  let Coq_existT (x, _) = p hid in Coq_existT (x, __)

