open DecSetoid
open DecSetoidPropRecord
open Logic0
open Right
open SemigroupPropRecord
open Specif

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val rightSemigroup_props : coq_DecSetoid -> dsProp -> sgProp **)

let rightSemigroup_props a ap =
  { sg_dsprop = ap; hasIdentity =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (let Coq_existT (a1, _) = a0 in Coq_existT (a1, __))
       | None -> None)); hasIdentity_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun x ->
           let Coq_existT (b, _) = a0 x in Coq_existT (b, __))
       | None -> None)); hasAnnihilator =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (let Coq_existT (a1, _) = a0 in Coq_existT (a1, __))
       | None -> None)); hasAnnihilator_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (fun x ->
           let Coq_existT (b, _) = a0 x in Coq_existT (b, __))
       | None -> None)); isSelective =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isSelective_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isCommutative =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isCommutative_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (Right.isCommutative_comp a a0)
       | None -> None)); isIdempotent =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isIdempotent_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); isLeft =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isLeft_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (Right.isLeft_comp a a0)
       | None -> None)); isRight =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); isRight_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); leftCondensed =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); leftCondensed_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (Right.leftCondensed_comp a a0)
       | None -> None)); rightCondensed =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); rightCondensed_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); leftCancelative =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); leftCancelative_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); rightCancelative =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); rightCancelative_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    (match isSingleton_comp0 with
       | Some a0 -> Some (Right.rightCancelative_comp a a0)
       | None -> None)); antiLeft =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); antiLeft_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (Right.antiLeft_comp a)); antiRight =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None); antiRight_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit (Right.antiRight_comp a)); treeGlb =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    opInit __); treeGlb_comp =
    (let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
       twoElements = twoElements0; twoElements_comp = twoElements_comp0;
       finite = finite0; finite_comp = finite_comp0 } = ap
     in
    None) }

