open DecSetoidPropRecord
open Id
open Id1
open Logic0
open Right0
open Semigroup
open SemigroupPropRecord
open SemigroupTransform
open SemigroupTransformGlue
open SemigroupTransformPropRecord
open TransformPropRecord

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val rightSemigroupTransform_props : coq_Semigroup -> sgProp -> stProp **)

let rightSemigroupTransform_props a ap =
  let sgp =
    sgPropIso a
      (semigroupST (glueSTf_DsEq a (idTransform a.Semigroup.setoid)))
      (glueSTfSmg_DsEq a (idTransform a.Semigroup.setoid)) ap
  in
  let tfp =
    tfPropIso (idTransform a.Semigroup.setoid)
      (transformST (glueSTf_DsEq a (idTransform a.Semigroup.setoid)))
      (glueSTfTf_DsEq a (idTransform a.Semigroup.setoid))
      (idTransform_props a.Semigroup.setoid (ap.sg_dsprop))
  in
  { st_sgprop = sgp; st_tfprop = tfp; distributive =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = ap
  in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_dsprop0
  in
  opInit __); distributive_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = ap
  in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_dsprop0
  in
  None); inflationary =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = ap
  in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_dsprop0
  in
  opInit __); inflationary_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = ap
  in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_dsprop0
  in
  None); strictInflationary =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = ap
  in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_dsprop0
  in
  None); strictInflationary_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = ap
  in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_dsprop0
  in
  opInit (fun _ _ -> Right0.strictInflationary_comp a)); strict =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = ap
  in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_dsprop0
  in
  opInit __); strict_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = ap
  in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; cancelative_comp = cancelative_comp0; condensed =
    condensed0; condensed_comp = condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = tf_dsprop0
  in
  None) }

