open DecSetoid
open DecSetoidProperties
open Logic0
open OrderSemigroup
open OrderSemigroupGlue
open OrderSemigroupProperties
open RightNaturalOrder
open Semigroup
open SemigroupProperties
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val rightNaturalOrder : coq_Semigroup -> coq_OrderSemigroup **)

let rightNaturalOrder s =
  glueOSmg s (rightNaturalOrder s)

(** val leftOpIncreasing_comp :
    coq_Semigroup -> coq_LeftOpIncreasing_comp **)

let leftOpIncreasing_comp s =
  Coq_existT (s.setoid.choose, (Coq_existT (s.setoid.choose, __)))

(** val rightOpIncreasing_comp :
    coq_Semigroup -> coq_RightOpIncreasing_comp **)

let rightOpIncreasing_comp s =
  Coq_existT (s.setoid.choose, (Coq_existT (s.setoid.choose, __)))

(** val leftEquivCancelative_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> coq_LeftEquivCancelative_comp **)

let leftEquivCancelative_comp s sng =
  let Coq_existT (b, _) = sng s.setoid.choose in
  let Coq_existT (w, _) =
    copy_var (s.setoid.equal b (s.op s.setoid.choose b))
  in
  if w
  then Coq_existT (s.setoid.choose, (Coq_existT ((s.op s.setoid.choose b),
         (Coq_existT ((s.op s.setoid.choose b), __)))))
  else Coq_existT (b, (Coq_existT ((s.op s.setoid.choose b), (Coq_existT
         ((s.op s.setoid.choose b), __)))))

(** val rightEquivCancelative_comp :
    coq_Semigroup -> coq_IsSingleton_comp -> coq_RightEquivCancelative_comp **)

let rightEquivCancelative_comp s sng =
  let Coq_existT (b, _) = sng s.setoid.choose in
  let Coq_existT (w, _) =
    copy_var (s.setoid.equal b (s.op s.setoid.choose b))
  in
  if w
  then Coq_existT (s.setoid.choose, (Coq_existT ((s.op s.setoid.choose b),
         (Coq_existT ((s.op s.setoid.choose b), __)))))
  else Coq_existT (b, (Coq_existT ((s.op s.setoid.choose b), (Coq_existT
         ((s.op s.setoid.choose b), __)))))

(** val leftEquivCondensed_comp :
    coq_Semigroup -> coq_LeftCondensed_comp -> coq_LeftEquivCondensed_comp **)

let leftEquivCondensed_comp s = function
  | Coq_existT (a, s0) ->
      let Coq_existT (b, s1) = s0 in
      let Coq_existT (c, _) = s1 in
      Coq_existT (a, (Coq_existT (b, (Coq_existT (c, __)))))

(** val rightEquivCondensed_comp :
    coq_Semigroup -> coq_RightCondensed_comp -> coq_RightEquivCondensed_comp **)

let rightEquivCondensed_comp s = function
  | Coq_existT (a, s0) ->
      let Coq_existT (b, s1) = s0 in
      let Coq_existT (c, _) = s1 in
      Coq_existT (a, (Coq_existT (b, (Coq_existT (c, __)))))

(** val rightTotal_comp :
    coq_Semigroup -> coq_TreeGlb_comp -> coq_RightTotal_comp **)

let rightTotal_comp s x =
  let Coq_existT (x0, s0) = x __ __ in
  let Coq_existT (y, s1) = s0 in
  let Coq_existT (z, _) = s1 in
  Coq_existT (z, (Coq_existT (x0, (Coq_existT (y, __)))))

(** val leftTotal_comp :
    coq_Semigroup -> coq_TreeGlb_comp -> coq_LeftTotal_comp **)

let leftTotal_comp s x =
  let Coq_existT (x0, s0) = x __ __ in
  let Coq_existT (y, s1) = s0 in
  let Coq_existT (z, _) = s1 in
  Coq_existT (z, (Coq_existT (x0, (Coq_existT (y, __)))))

(** val rightMultChoiseComp_comp :
    coq_Semigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT) sigT **)

let rightMultChoiseComp_comp s = function
  | Coq_existT (x0, s0) ->
      let Coq_existT (y, _) = s0 in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (x0, (Coq_existT (y,
      __)))))))

(** val leftMultChoiseComp_comp :
    coq_Semigroup -> coq_IsSelective_comp -> (carrier, (carrier, (carrier,
    (carrier, __) sigT) sigT) sigT) sigT **)

let leftMultChoiseComp_comp s = function
  | Coq_existT (x0, s0) ->
      let Coq_existT (y, _) = s0 in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (x0, (Coq_existT (y,
      __)))))))

