open Bisemigroup
open BisemigroupGlue
open BisemigroupProperties
open Datatypes
open DecSetoid
open Logic0
open Product0
open SelLex
open SemigroupProperties
open Specif

type __ = Obj.t

val selLexBisemigroup : coq_Bisemigroup -> coq_Bisemigroup -> coq_Bisemigroup

val isRightDistributive_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> ((coq_IsRightDistributive_comp,
  coq_IsRightDistributive_comp) sum, coq_RightCancelative_comp *
  coq_RightCondensed_comp) sum -> coq_IsRightDistributive_comp

val isLeftDistributive_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> ((coq_IsLeftDistributive_comp,
  coq_IsLeftDistributive_comp) sum, coq_LeftCancelative_comp *
  coq_LeftCondensed_comp) sum -> coq_IsLeftDistributive_comp

val hasPlusId_back_a :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasIdentity -> coq_HasIdentity

val hasPlusId_back_b :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasIdentity -> coq_HasIdentity

val hasPlusAnn_back_a :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasAnnihilator ->
  coq_HasAnnihilator

val hasPlusAnn_back_b :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasAnnihilator ->
  coq_HasAnnihilator

val hasTimesId_back_a :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasIdentity -> coq_HasIdentity

val hasTimesId_back_b :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasIdentity -> coq_HasIdentity

val hasTimesAnn_back_a :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasAnnihilator ->
  coq_HasAnnihilator

val hasTimesAnn_back_b :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasAnnihilator ->
  coq_HasAnnihilator

val isLeftStrictStable_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_IsLeftStrictStable_comp,
  coq_IsLeftStrictStable_comp) sum -> (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT

val isRightStrictStable_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_IsRightStrictStable_comp,
  coq_IsRightStrictStable_comp) sum -> (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT

val isLeftCompEqCancel_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_IsLeftCompEqCancel_comp,
  coq_IsLeftCompEqCancel_comp) sum -> (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT

val isRightCompEqCancel_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_IsRightCompEqCancel_comp,
  coq_IsRightCompEqCancel_comp) sum -> (carrier, (carrier, (carrier, __)
  sigT) sigT) sigT

val isLeftCompCancel_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_IsLeftCompCancel_comp,
  coq_IsLeftCompCancel_comp) sum -> (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT

val isRightCompCancel_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_IsRightCompCancel_comp,
  coq_IsRightCompCancel_comp) sum -> (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT

val leftDiscrete_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_LeftDiscrete_comp,
  coq_LeftDiscrete_comp) sum -> (carrier, (carrier, (carrier, __) sigT) sigT)
  sigT

val rightDiscrete_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_RightDiscrete_comp,
  coq_RightDiscrete_comp) sum -> (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT

val leftComparable_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_LeftComparable_comp,
  coq_LeftComparable_comp) sum -> (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT

val rightComparable_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_RightComparable_comp,
  coq_RightComparable_comp) sum -> (carrier, (carrier, (carrier, __) sigT)
  sigT) sigT

val leftIncreasing_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_LeftStrictIncreasing_comp *
  (coq_LeftIncreasing_comp, coq_LeftIncreasing_comp) sum) -> (carrier,
  (carrier, __) sigT) sigT

val rightIncreasing_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_RightStrictIncreasing_comp *
  (coq_RightIncreasing_comp, coq_RightIncreasing_comp) sum) -> (carrier,
  (carrier, __) sigT) sigT

val leftStrictIncreasing_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_LeftStrictIncreasing_comp *
  (coq_LeftIncreasing_comp, coq_LeftStrictIncreasing_comp) sum) -> (carrier,
  (carrier, __) sigT) sigT

val rightStrictIncreasing_comp :
  coq_Bisemigroup -> coq_Bisemigroup -> (coq_RightStrictIncreasing_comp *
  (coq_RightIncreasing_comp, coq_RightStrictIncreasing_comp) sum) ->
  (carrier, (carrier, __) sigT) sigT

val hasId_back_a :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasIdentity -> coq_HasIdentity

val hasId_back_b :
  coq_Bisemigroup -> coq_Bisemigroup -> coq_HasIdentity -> coq_HasIdentity

val isRightTimesMapToIdConstantPlus_comp :
  coq_Bisemigroup -> coq_Bisemigroup ->
  ((coq_IsRightTimesMapToIdConstantPlus_comp,
  coq_IsRightTimesMapToIdConstantPlus_comp) sum, coq_RightDiscrete_comp *
  coq_RightCondensed_comp) sum -> coq_IsRightTimesMapToIdConstantPlus_comp

val isLeftTimesMapToIdConstantPlus_comp :
  coq_Bisemigroup -> coq_Bisemigroup ->
  ((coq_IsLeftTimesMapToIdConstantPlus_comp,
  coq_IsLeftTimesMapToIdConstantPlus_comp) sum, coq_LeftDiscrete_comp *
  coq_LeftCondensed_comp) sum -> coq_IsLeftTimesMapToIdConstantPlus_comp

val plusIdentityIsTimesLeftAnnihilator_comp :
  coq_Bisemigroup -> coq_Bisemigroup ->
  (coq_PlusIdentityIsTimesLeftAnnihilator_comp,
  coq_PlusIdentityIsTimesLeftAnnihilator_comp) sum ->
  coq_PlusIdentityIsTimesLeftAnnihilator_comp

val plusIdentityIsTimesRightAnnihilator_comp :
  coq_Bisemigroup -> coq_Bisemigroup ->
  (coq_PlusIdentityIsTimesRightAnnihilator_comp,
  coq_PlusIdentityIsTimesRightAnnihilator_comp) sum ->
  coq_PlusIdentityIsTimesRightAnnihilator_comp

