open DecSetoid
open DecSetoidPropRecord
open Semigroup
open SemigroupProperties
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type sgProp = { sg_dsprop : dsProp; hasIdentity : coq_HasIdentity option;
                hasIdentity_comp : coq_HasIdentity_comp option;
                hasAnnihilator : coq_HasAnnihilator option;
                hasAnnihilator_comp : coq_HasAnnihilator_comp option;
                isSelective : __ option;
                isSelective_comp : coq_IsSelective_comp option;
                isCommutative : __ option;
                isCommutative_comp : coq_IsCommutative_comp option;
                isIdempotent : __ option;
                isIdempotent_comp : coq_IsIdempotent_comp option;
                isLeft : __ option; isLeft_comp : coq_IsLeft_comp option;
                isRight : __ option; isRight_comp : 
                coq_IsRight_comp option; leftCondensed : 
                __ option;
                leftCondensed_comp : coq_LeftCondensed_comp option;
                rightCondensed : __ option;
                rightCondensed_comp : coq_RightCondensed_comp option;
                leftCancelative : __ option;
                leftCancelative_comp : coq_LeftCancelative_comp option;
                rightCancelative : __ option;
                rightCancelative_comp : coq_RightCancelative_comp option;
                antiLeft : __ option;
                antiLeft_comp : coq_AntiLeft_comp option;
                antiRight : __ option;
                antiRight_comp : coq_AntiRight_comp option;
                treeGlb : __ option; treeGlb_comp : 
                coq_TreeGlb_comp option }

(** val sgProp_rect :
    coq_Semigroup -> (dsProp -> coq_HasIdentity option ->
    coq_HasIdentity_comp option -> coq_HasAnnihilator option ->
    coq_HasAnnihilator_comp option -> __ option -> coq_IsSelective_comp
    option -> __ option -> coq_IsCommutative_comp option -> __ option ->
    coq_IsIdempotent_comp option -> __ option -> coq_IsLeft_comp option -> __
    option -> coq_IsRight_comp option -> __ option -> coq_LeftCondensed_comp
    option -> __ option -> coq_RightCondensed_comp option -> __ option ->
    coq_LeftCancelative_comp option -> __ option -> coq_RightCancelative_comp
    option -> __ option -> coq_AntiLeft_comp option -> __ option ->
    coq_AntiRight_comp option -> __ option -> coq_TreeGlb_comp option -> 'a1)
    -> sgProp -> 'a1 **)

let sgProp_rect s f s0 =
  let { sg_dsprop = x; hasIdentity = x0; hasIdentity_comp = x1;
    hasAnnihilator = x2; hasAnnihilator_comp = x3; isSelective = x4;
    isSelective_comp = x5; isCommutative = x6; isCommutative_comp = x7;
    isIdempotent = x8; isIdempotent_comp = x9; isLeft = x10; isLeft_comp =
    x11; isRight = x12; isRight_comp = x13; leftCondensed = x14;
    leftCondensed_comp = x15; rightCondensed = x16; rightCondensed_comp =
    x17; leftCancelative = x18; leftCancelative_comp = x19;
    rightCancelative = x20; rightCancelative_comp = x21; antiLeft = x22;
    antiLeft_comp = x23; antiRight = x24; antiRight_comp = x25; treeGlb =
    x26; treeGlb_comp = x27 } = s0
  in
  f x x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 x19
    x20 x21 x22 x23 x24 x25 x26 x27

(** val sgProp_rec :
    coq_Semigroup -> (dsProp -> coq_HasIdentity option ->
    coq_HasIdentity_comp option -> coq_HasAnnihilator option ->
    coq_HasAnnihilator_comp option -> __ option -> coq_IsSelective_comp
    option -> __ option -> coq_IsCommutative_comp option -> __ option ->
    coq_IsIdempotent_comp option -> __ option -> coq_IsLeft_comp option -> __
    option -> coq_IsRight_comp option -> __ option -> coq_LeftCondensed_comp
    option -> __ option -> coq_RightCondensed_comp option -> __ option ->
    coq_LeftCancelative_comp option -> __ option -> coq_RightCancelative_comp
    option -> __ option -> coq_AntiLeft_comp option -> __ option ->
    coq_AntiRight_comp option -> __ option -> coq_TreeGlb_comp option -> 'a1)
    -> sgProp -> 'a1 **)

let sgProp_rec s f s0 =
  let { sg_dsprop = x; hasIdentity = x0; hasIdentity_comp = x1;
    hasAnnihilator = x2; hasAnnihilator_comp = x3; isSelective = x4;
    isSelective_comp = x5; isCommutative = x6; isCommutative_comp = x7;
    isIdempotent = x8; isIdempotent_comp = x9; isLeft = x10; isLeft_comp =
    x11; isRight = x12; isRight_comp = x13; leftCondensed = x14;
    leftCondensed_comp = x15; rightCondensed = x16; rightCondensed_comp =
    x17; leftCancelative = x18; leftCancelative_comp = x19;
    rightCancelative = x20; rightCancelative_comp = x21; antiLeft = x22;
    antiLeft_comp = x23; antiRight = x24; antiRight_comp = x25; treeGlb =
    x26; treeGlb_comp = x27 } = s0
  in
  f x x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 x19
    x20 x21 x22 x23 x24 x25 x26 x27

(** val sg_dsprop : coq_Semigroup -> sgProp -> dsProp **)

let sg_dsprop _ x = x.sg_dsprop

(** val hasIdentity : coq_Semigroup -> sgProp -> coq_HasIdentity option **)

let hasIdentity _ x = x.hasIdentity

(** val hasIdentity_comp :
    coq_Semigroup -> sgProp -> coq_HasIdentity_comp option **)

let hasIdentity_comp _ x = x.hasIdentity_comp

(** val hasAnnihilator :
    coq_Semigroup -> sgProp -> coq_HasAnnihilator option **)

let hasAnnihilator _ x = x.hasAnnihilator

(** val hasAnnihilator_comp :
    coq_Semigroup -> sgProp -> coq_HasAnnihilator_comp option **)

let hasAnnihilator_comp _ x = x.hasAnnihilator_comp

(** val isSelective : coq_Semigroup -> sgProp -> __ option **)

let isSelective _ x = x.isSelective

(** val isSelective_comp :
    coq_Semigroup -> sgProp -> coq_IsSelective_comp option **)

let isSelective_comp _ x = x.isSelective_comp

(** val isCommutative : coq_Semigroup -> sgProp -> __ option **)

let isCommutative _ x = x.isCommutative

(** val isCommutative_comp :
    coq_Semigroup -> sgProp -> coq_IsCommutative_comp option **)

let isCommutative_comp _ x = x.isCommutative_comp

(** val isIdempotent : coq_Semigroup -> sgProp -> __ option **)

let isIdempotent _ x = x.isIdempotent

(** val isIdempotent_comp :
    coq_Semigroup -> sgProp -> coq_IsIdempotent_comp option **)

let isIdempotent_comp _ x = x.isIdempotent_comp

(** val isLeft : coq_Semigroup -> sgProp -> __ option **)

let isLeft _ x = x.isLeft

(** val isLeft_comp : coq_Semigroup -> sgProp -> coq_IsLeft_comp option **)

let isLeft_comp _ x = x.isLeft_comp

(** val isRight : coq_Semigroup -> sgProp -> __ option **)

let isRight _ x = x.isRight

(** val isRight_comp : coq_Semigroup -> sgProp -> coq_IsRight_comp option **)

let isRight_comp _ x = x.isRight_comp

(** val leftCondensed : coq_Semigroup -> sgProp -> __ option **)

let leftCondensed _ x = x.leftCondensed

(** val leftCondensed_comp :
    coq_Semigroup -> sgProp -> coq_LeftCondensed_comp option **)

let leftCondensed_comp _ x = x.leftCondensed_comp

(** val rightCondensed : coq_Semigroup -> sgProp -> __ option **)

let rightCondensed _ x = x.rightCondensed

(** val rightCondensed_comp :
    coq_Semigroup -> sgProp -> coq_RightCondensed_comp option **)

let rightCondensed_comp _ x = x.rightCondensed_comp

(** val leftCancelative : coq_Semigroup -> sgProp -> __ option **)

let leftCancelative _ x = x.leftCancelative

(** val leftCancelative_comp :
    coq_Semigroup -> sgProp -> coq_LeftCancelative_comp option **)

let leftCancelative_comp _ x = x.leftCancelative_comp

(** val rightCancelative : coq_Semigroup -> sgProp -> __ option **)

let rightCancelative _ x = x.rightCancelative

(** val rightCancelative_comp :
    coq_Semigroup -> sgProp -> coq_RightCancelative_comp option **)

let rightCancelative_comp _ x = x.rightCancelative_comp

(** val antiLeft : coq_Semigroup -> sgProp -> __ option **)

let antiLeft _ x = x.antiLeft

(** val antiLeft_comp :
    coq_Semigroup -> sgProp -> coq_AntiLeft_comp option **)

let antiLeft_comp _ x = x.antiLeft_comp

(** val antiRight : coq_Semigroup -> sgProp -> __ option **)

let antiRight _ x = x.antiRight

(** val antiRight_comp :
    coq_Semigroup -> sgProp -> coq_AntiRight_comp option **)

let antiRight_comp _ x = x.antiRight_comp

(** val treeGlb : coq_Semigroup -> sgProp -> __ option **)

let treeGlb _ x = x.treeGlb

(** val treeGlb_comp : coq_Semigroup -> sgProp -> coq_TreeGlb_comp option **)

let treeGlb_comp _ x = x.treeGlb_comp

(** val sgPropIso :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> sgProp -> sgProp **)

let sgPropIso s s' i sgp =
  { sg_dsprop = (dsPropIso s.setoid s'.setoid i sgp.sg_dsprop); hasIdentity =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match hasIdentity0 with
       | Some x -> Some
           (let Coq_existT (x0, _) = x in Coq_existT ((i.phi x0), __))
       | None -> None)); hasIdentity_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match hasIdentity_comp0 with
       | Some x -> Some (coq_Iso_HasIdentity_comp s s' i x)
       | None -> None)); hasAnnihilator =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match hasAnnihilator0 with
       | Some x -> Some
           (let Coq_existT (x0, _) = x in Coq_existT ((i.phi x0), __))
       | None -> None)); hasAnnihilator_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match hasAnnihilator_comp0 with
       | Some x -> Some (coq_Iso_HasAnnihilator_comp s s' i x)
       | None -> None)); isSelective =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isSelective0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); isSelective_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isSelective_comp0 with
       | Some x -> Some (coq_Iso_IsSelective_comp s s' i x)
       | None -> None)); isCommutative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isCommutative0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); isCommutative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isCommutative_comp0 with
       | Some x -> Some (coq_Iso_IsCommutative_comp s s' i x)
       | None -> None)); isIdempotent =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isIdempotent0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); isIdempotent_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isIdempotent_comp0 with
       | Some x -> Some
           (let Coq_existT (x0, _) = x in Coq_existT ((i.phi x0), __))
       | None -> None)); isLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isLeft0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); isLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isLeft_comp0 with
       | Some x -> Some (coq_Iso_IsLeft_comp s s' i x)
       | None -> None)); isRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isRight0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); isRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match isRight_comp0 with
       | Some x -> Some (coq_Iso_IsRight_comp s s' i x)
       | None -> None)); leftCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match leftCondensed0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); leftCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match leftCondensed_comp0 with
       | Some x -> Some (coq_Iso_LeftCondensed_comp s s' i x)
       | None -> None)); rightCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match rightCondensed0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); rightCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match rightCondensed_comp0 with
       | Some x -> Some (coq_Iso_RightCondensed_comp s s' i x)
       | None -> None)); leftCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match leftCancelative0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); leftCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match leftCancelative_comp0 with
       | Some x -> Some (coq_Iso_LeftCancelative_comp s s' i x)
       | None -> None)); rightCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match rightCancelative0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); rightCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match rightCancelative_comp0 with
       | Some x -> Some (coq_Iso_RightCancelative_comp s s' i x)
       | None -> None)); antiLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match antiLeft0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); antiLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match antiLeft_comp0 with
       | Some x -> Some (coq_Iso_AntiLeft_comp s s' i x)
       | None -> None)); antiRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match antiRight0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); antiRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match antiRight_comp0 with
       | Some x -> Some (coq_Iso_AntiRight_comp s s' i x)
       | None -> None)); treeGlb =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match treeGlb0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); treeGlb_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       hasIdentity_comp = hasIdentity_comp0; hasAnnihilator =
       hasAnnihilator0; hasAnnihilator_comp = hasAnnihilator_comp0;
       isSelective = isSelective0; isSelective_comp = isSelective_comp0;
       isCommutative = isCommutative0; isCommutative_comp =
       isCommutative_comp0; isIdempotent = isIdempotent0; isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0; isLeft_comp = isLeft_comp0;
       isRight = isRight0; isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; leftCondensed_comp = leftCondensed_comp0;
       rightCondensed = rightCondensed0; rightCondensed_comp =
       rightCondensed_comp0; leftCancelative = leftCancelative0;
       leftCancelative_comp = leftCancelative_comp0; rightCancelative =
       rightCancelative0; rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; antiLeft_comp = antiLeft_comp0; antiRight =
       antiRight0; antiRight_comp = antiRight_comp0; treeGlb = treeGlb0;
       treeGlb_comp = treeGlb_comp0 } = sgp
     in
    (match treeGlb_comp0 with
       | Some x -> Some (fun _ _ -> coq_Iso_TreeGlb_comp s s' i x)
       | None -> None)) }

