open DecSetoid
open DecSetoidPropRecord
open Semigroup
open SemigroupProperties
open Specif

type __ = Obj.t

type sgProp = { sg_dsprop : dsProp; hasIdentity : coq_HasIdentity option;
                hasIdentity_comp : coq_HasIdentity_comp option;
                hasAnnihilator : coq_HasAnnihilator option;
                hasAnnihilator_comp : coq_HasAnnihilator_comp option;
                isSelective : __ option;
                isSelective_comp : coq_IsSelective_comp option;
                isCommutative : __ option;
                isCommutative_comp : coq_IsCommutative_comp option;
                isIdempotent : __ option;
                isIdempotent_comp : coq_IsIdempotent_comp option;
                isLeft : __ option; isLeft_comp : coq_IsLeft_comp option;
                isRight : __ option; isRight_comp : 
                coq_IsRight_comp option; leftCondensed : 
                __ option;
                leftCondensed_comp : coq_LeftCondensed_comp option;
                rightCondensed : __ option;
                rightCondensed_comp : coq_RightCondensed_comp option;
                leftCancelative : __ option;
                leftCancelative_comp : coq_LeftCancelative_comp option;
                rightCancelative : __ option;
                rightCancelative_comp : coq_RightCancelative_comp option;
                antiLeft : __ option;
                antiLeft_comp : coq_AntiLeft_comp option;
                antiRight : __ option;
                antiRight_comp : coq_AntiRight_comp option;
                treeGlb : __ option; treeGlb_comp : 
                coq_TreeGlb_comp option }

val sgProp_rect :
  coq_Semigroup -> (dsProp -> coq_HasIdentity option -> coq_HasIdentity_comp
  option -> coq_HasAnnihilator option -> coq_HasAnnihilator_comp option -> __
  option -> coq_IsSelective_comp option -> __ option ->
  coq_IsCommutative_comp option -> __ option -> coq_IsIdempotent_comp option
  -> __ option -> coq_IsLeft_comp option -> __ option -> coq_IsRight_comp
  option -> __ option -> coq_LeftCondensed_comp option -> __ option ->
  coq_RightCondensed_comp option -> __ option -> coq_LeftCancelative_comp
  option -> __ option -> coq_RightCancelative_comp option -> __ option ->
  coq_AntiLeft_comp option -> __ option -> coq_AntiRight_comp option -> __
  option -> coq_TreeGlb_comp option -> 'a1) -> sgProp -> 'a1

val sgProp_rec :
  coq_Semigroup -> (dsProp -> coq_HasIdentity option -> coq_HasIdentity_comp
  option -> coq_HasAnnihilator option -> coq_HasAnnihilator_comp option -> __
  option -> coq_IsSelective_comp option -> __ option ->
  coq_IsCommutative_comp option -> __ option -> coq_IsIdempotent_comp option
  -> __ option -> coq_IsLeft_comp option -> __ option -> coq_IsRight_comp
  option -> __ option -> coq_LeftCondensed_comp option -> __ option ->
  coq_RightCondensed_comp option -> __ option -> coq_LeftCancelative_comp
  option -> __ option -> coq_RightCancelative_comp option -> __ option ->
  coq_AntiLeft_comp option -> __ option -> coq_AntiRight_comp option -> __
  option -> coq_TreeGlb_comp option -> 'a1) -> sgProp -> 'a1

val sg_dsprop : coq_Semigroup -> sgProp -> dsProp

val hasIdentity : coq_Semigroup -> sgProp -> coq_HasIdentity option

val hasIdentity_comp : coq_Semigroup -> sgProp -> coq_HasIdentity_comp option

val hasAnnihilator : coq_Semigroup -> sgProp -> coq_HasAnnihilator option

val hasAnnihilator_comp :
  coq_Semigroup -> sgProp -> coq_HasAnnihilator_comp option

val isSelective : coq_Semigroup -> sgProp -> __ option

val isSelective_comp : coq_Semigroup -> sgProp -> coq_IsSelective_comp option

val isCommutative : coq_Semigroup -> sgProp -> __ option

val isCommutative_comp :
  coq_Semigroup -> sgProp -> coq_IsCommutative_comp option

val isIdempotent : coq_Semigroup -> sgProp -> __ option

val isIdempotent_comp :
  coq_Semigroup -> sgProp -> coq_IsIdempotent_comp option

val isLeft : coq_Semigroup -> sgProp -> __ option

val isLeft_comp : coq_Semigroup -> sgProp -> coq_IsLeft_comp option

val isRight : coq_Semigroup -> sgProp -> __ option

val isRight_comp : coq_Semigroup -> sgProp -> coq_IsRight_comp option

val leftCondensed : coq_Semigroup -> sgProp -> __ option

val leftCondensed_comp :
  coq_Semigroup -> sgProp -> coq_LeftCondensed_comp option

val rightCondensed : coq_Semigroup -> sgProp -> __ option

val rightCondensed_comp :
  coq_Semigroup -> sgProp -> coq_RightCondensed_comp option

val leftCancelative : coq_Semigroup -> sgProp -> __ option

val leftCancelative_comp :
  coq_Semigroup -> sgProp -> coq_LeftCancelative_comp option

val rightCancelative : coq_Semigroup -> sgProp -> __ option

val rightCancelative_comp :
  coq_Semigroup -> sgProp -> coq_RightCancelative_comp option

val antiLeft : coq_Semigroup -> sgProp -> __ option

val antiLeft_comp : coq_Semigroup -> sgProp -> coq_AntiLeft_comp option

val antiRight : coq_Semigroup -> sgProp -> __ option

val antiRight_comp : coq_Semigroup -> sgProp -> coq_AntiRight_comp option

val treeGlb : coq_Semigroup -> sgProp -> __ option

val treeGlb_comp : coq_Semigroup -> sgProp -> coq_TreeGlb_comp option

val sgPropIso :
  coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> sgProp -> sgProp

