open DecSetoid
open Semigroup
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type coq_HasIdentity = (carrier, __) sigT

type coq_HasIdentity_comp = carrier -> (carrier, __) sigT

type coq_HasAnnihilator = (carrier, __) sigT

type coq_HasAnnihilator_comp = carrier -> (carrier, __) sigT

type coq_IsSelective_comp = (carrier, (carrier, __) sigT) sigT

type coq_IsCommutative_comp = (carrier, (carrier, __) sigT) sigT

type coq_IsIdempotent_comp = (carrier, __) sigT

type coq_IsLeft_comp = (carrier, (carrier, __) sigT) sigT

type coq_IsRight_comp = (carrier, (carrier, __) sigT) sigT

type coq_LeftCondensed_comp =
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

type coq_RightCondensed_comp =
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

type coq_LeftCancelative_comp =
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

type coq_RightCancelative_comp =
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

type coq_AntiLeft_comp = (carrier, (carrier, __) sigT) sigT

type coq_AntiRight_comp = (carrier, (carrier, __) sigT) sigT

type coq_TreeGlb_comp =
  __ -> __ -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT

(** val coq_Iso_HasIdentity :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_HasIdentity ->
    coq_HasIdentity **)

let coq_Iso_HasIdentity s s' i = function
  | Coq_existT (x, _) -> Coq_existT ((i.phi x), __)

(** val coq_Iso_HasIdentity_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_HasIdentity_comp ->
    coq_HasIdentity_comp **)

let coq_Iso_HasIdentity_comp s s' i h x =
  let Coq_existT (x0, _) = h (i.phi' x) in Coq_existT ((i.phi x0), __)

(** val coq_Iso_HasAnnihilator :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_HasAnnihilator ->
    coq_HasAnnihilator **)

let coq_Iso_HasAnnihilator s s' i = function
  | Coq_existT (x, _) -> Coq_existT ((i.phi x), __)

(** val coq_Iso_HasAnnihilator_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_HasAnnihilator_comp
    -> coq_HasAnnihilator_comp **)

let coq_Iso_HasAnnihilator_comp s s' i h x =
  let Coq_existT (x0, _) = h (i.phi' x) in Coq_existT ((i.phi x0), __)

(** val coq_Iso_IsSelective_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_IsSelective_comp ->
    coq_IsSelective_comp **)

let coq_Iso_IsSelective_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, _) = h0 in Coq_existT ((i.phi x0), __)))

(** val coq_Iso_IsCommutative_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_IsCommutative_comp ->
    coq_IsCommutative_comp **)

let coq_Iso_IsCommutative_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, _) = h0 in Coq_existT ((i.phi x0), __)))

(** val coq_Iso_IsIdempotent_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_IsIdempotent_comp ->
    coq_IsIdempotent_comp **)

let coq_Iso_IsIdempotent_comp s s' i = function
  | Coq_existT (x, _) -> Coq_existT ((i.phi x), __)

(** val coq_Iso_IsLeft_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_IsLeft_comp ->
    coq_IsLeft_comp **)

let coq_Iso_IsLeft_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, _) = h0 in Coq_existT ((i.phi x0), __)))

(** val coq_Iso_IsRight_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_IsRight_comp ->
    coq_IsRight_comp **)

let coq_Iso_IsRight_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, _) = h0 in Coq_existT ((i.phi x0), __)))

(** val coq_Iso_LeftCondensed_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_LeftCondensed_comp ->
    coq_LeftCondensed_comp **)

let coq_Iso_LeftCondensed_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, h1) = h0 in
      Coq_existT ((i.phi x0),
      (let Coq_existT (x1, _) = h1 in Coq_existT ((i.phi x1), __)))))

(** val coq_Iso_RightCondensed_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_RightCondensed_comp
    -> coq_RightCondensed_comp **)

let coq_Iso_RightCondensed_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, h1) = h0 in
      Coq_existT ((i.phi x0),
      (let Coq_existT (x1, _) = h1 in Coq_existT ((i.phi x1), __)))))

(** val coq_Iso_LeftCancelative_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_LeftCancelative_comp
    -> coq_LeftCancelative_comp **)

let coq_Iso_LeftCancelative_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, h1) = h0 in
      Coq_existT ((i.phi x0),
      (let Coq_existT (x1, _) = h1 in Coq_existT ((i.phi x1), __)))))

(** val coq_Iso_RightCancelative_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_RightCancelative_comp
    -> coq_RightCancelative_comp **)

let coq_Iso_RightCancelative_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, h1) = h0 in
      Coq_existT ((i.phi x0),
      (let Coq_existT (x1, _) = h1 in Coq_existT ((i.phi x1), __)))))

(** val coq_Iso_AntiLeft_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_AntiLeft_comp ->
    coq_AntiLeft_comp **)

let coq_Iso_AntiLeft_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, _) = h0 in Coq_existT ((i.phi x0), __)))

(** val coq_Iso_AntiRight_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_AntiRight_comp ->
    coq_AntiRight_comp **)

let coq_Iso_AntiRight_comp s s' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.phi x),
      (let Coq_existT (x0, _) = h0 in Coq_existT ((i.phi x0), __)))

(** val coq_Iso_TreeGlb_comp :
    coq_Semigroup -> coq_Semigroup -> coq_SmgIso -> coq_TreeGlb_comp ->
    (carrier, (carrier, (carrier, __) sigT) sigT) sigT **)

let coq_Iso_TreeGlb_comp s s' i h =
  let Coq_existT (x, h0) = h __ __ in
  Coq_existT ((i.phi x),
  (let Coq_existT (x0, h1) = h0 in
  Coq_existT ((i.phi x0),
  (let Coq_existT (x1, _) = h1 in Coq_existT ((i.phi x1), __)))))

