open DecSetoid
open Semigroup
open Specif
open Transform

type __ = Obj.t

type coq_SemigroupTransform = { setoid : coq_DecSetoid;
                                op : (carrier -> carrier -> carrier);
                                fn : coq_DecSetoid;
                                app : (carrier -> carrier -> carrier) }

val coq_SemigroupTransform_rect :
  (coq_DecSetoid -> (carrier -> carrier -> carrier) -> __ -> __ ->
  coq_DecSetoid -> (carrier -> carrier -> carrier) -> __ -> 'a1) ->
  coq_SemigroupTransform -> 'a1

val coq_SemigroupTransform_rec :
  (coq_DecSetoid -> (carrier -> carrier -> carrier) -> __ -> __ ->
  coq_DecSetoid -> (carrier -> carrier -> carrier) -> __ -> 'a1) ->
  coq_SemigroupTransform -> 'a1

val setoid : coq_SemigroupTransform -> coq_DecSetoid

val op : coq_SemigroupTransform -> carrier -> carrier -> carrier

val fn : coq_SemigroupTransform -> coq_DecSetoid

val app : coq_SemigroupTransform -> carrier -> carrier -> carrier

val semigroupST : coq_SemigroupTransform -> coq_Semigroup

val transformST : coq_SemigroupTransform -> coq_Transform

val coq_IsSTfIso_rect :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_DsIso -> coq_DsIso
  -> (__ -> __ -> __ -> __ -> 'a1) -> 'a1

val coq_IsSTfIso_rec :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_DsIso -> coq_DsIso
  -> (__ -> __ -> __ -> __ -> 'a1) -> 'a1

type coq_STfIso = { dsIso : coq_DsIso; fnIso : coq_DsIso }

val coq_STfIso_rect :
  coq_SemigroupTransform -> coq_SemigroupTransform -> (coq_DsIso -> coq_DsIso
  -> __ -> 'a1) -> coq_STfIso -> 'a1

val coq_STfIso_rec :
  coq_SemigroupTransform -> coq_SemigroupTransform -> (coq_DsIso -> coq_DsIso
  -> __ -> 'a1) -> coq_STfIso -> 'a1

val dsIso :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso -> coq_DsIso

val fnIso :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso -> coq_DsIso

val coq_SmgSTfIso :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso ->
  coq_SmgIso

val coq_TfStfIso :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso -> coq_TfIso

val coq_STfIso_refl : coq_SemigroupTransform -> coq_STfIso

val coq_STfIso_sym :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso ->
  coq_STfIso

val coq_STfIso_trans :
  coq_SemigroupTransform -> coq_SemigroupTransform -> coq_SemigroupTransform
  -> coq_STfIso -> coq_STfIso -> coq_STfIso

val liftSTfIso :
  coq_DecSetoid -> coq_SemigroupTransform -> coq_DsIso ->
  (coq_SemigroupTransform, coq_STfIso * __) sigT

