open SemigroupPropRecord
open SemigroupTransform
open SemigroupTransformProperties
open Transform
open TransformPropRecord

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type stProp = { st_sgprop : sgProp; st_tfprop : tfProp;
                distributive : __ option;
                distributive_comp : coq_Distributive_comp option;
                inflationary : __ option;
                inflationary_comp : coq_Inflationary_comp option;
                strictInflationary : __ option;
                strictInflationary_comp : coq_StrictInflationary_comp option;
                strict : __ option; strict_comp : coq_Strict_comp option }

(** val stProp_rect :
    coq_SemigroupTransform -> (sgProp -> tfProp -> __ option ->
    coq_Distributive_comp option -> __ option -> coq_Inflationary_comp option
    -> __ option -> coq_StrictInflationary_comp option -> __ option ->
    coq_Strict_comp option -> 'a1) -> stProp -> 'a1 **)

let stProp_rect sT f s =
  let { st_sgprop = x; st_tfprop = x0; distributive = x1; distributive_comp =
    x2; inflationary = x3; inflationary_comp = x4; strictInflationary = x5;
    strictInflationary_comp = x6; strict = x7; strict_comp = x8 } = s
  in
  f x x0 x1 x2 x3 x4 x5 x6 x7 x8

(** val stProp_rec :
    coq_SemigroupTransform -> (sgProp -> tfProp -> __ option ->
    coq_Distributive_comp option -> __ option -> coq_Inflationary_comp option
    -> __ option -> coq_StrictInflationary_comp option -> __ option ->
    coq_Strict_comp option -> 'a1) -> stProp -> 'a1 **)

let stProp_rec sT f s =
  let { st_sgprop = x; st_tfprop = x0; distributive = x1; distributive_comp =
    x2; inflationary = x3; inflationary_comp = x4; strictInflationary = x5;
    strictInflationary_comp = x6; strict = x7; strict_comp = x8 } = s
  in
  f x x0 x1 x2 x3 x4 x5 x6 x7 x8

(** val st_sgprop : coq_SemigroupTransform -> stProp -> sgProp **)

let st_sgprop _ x = x.st_sgprop

(** val st_tfprop : coq_SemigroupTransform -> stProp -> tfProp **)

let st_tfprop _ x = x.st_tfprop

(** val distributive : coq_SemigroupTransform -> stProp -> __ option **)

let distributive _ x = x.distributive

(** val distributive_comp :
    coq_SemigroupTransform -> stProp -> coq_Distributive_comp option **)

let distributive_comp _ x = x.distributive_comp

(** val inflationary : coq_SemigroupTransform -> stProp -> __ option **)

let inflationary _ x = x.inflationary

(** val inflationary_comp :
    coq_SemigroupTransform -> stProp -> coq_Inflationary_comp option **)

let inflationary_comp _ x = x.inflationary_comp

(** val strictInflationary :
    coq_SemigroupTransform -> stProp -> __ option **)

let strictInflationary _ x = x.strictInflationary

(** val strictInflationary_comp :
    coq_SemigroupTransform -> stProp -> coq_StrictInflationary_comp option **)

let strictInflationary_comp _ x = x.strictInflationary_comp

(** val strict : coq_SemigroupTransform -> stProp -> __ option **)

let strict _ x = x.strict

(** val strict_comp :
    coq_SemigroupTransform -> stProp -> coq_Strict_comp option **)

let strict_comp _ x = x.strict_comp

(** val stPropIso :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso -> stProp
    -> stProp **)

let stPropIso s s' i stp =
  { st_sgprop =
    (sgPropIso (semigroupST s) (semigroupST s') i.SemigroupTransform.dsIso
      stp.st_sgprop); st_tfprop =
    (tfPropIso (transformST s) (transformST s') { dsIso =
      i.SemigroupTransform.dsIso; fnIso = i.SemigroupTransform.fnIso }
      stp.st_tfprop); distributive =
    (let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
       distributive0; distributive_comp = distributive_comp0; inflationary =
       inflationary0; inflationary_comp = inflationary_comp0;
       strictInflationary = strictInflationary0; strictInflationary_comp =
       strictInflationary_comp0; strict = strict0; strict_comp =
       strict_comp0 } = stp
     in
    (match distributive0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); distributive_comp =
    (let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
       distributive0; distributive_comp = distributive_comp0; inflationary =
       inflationary0; inflationary_comp = inflationary_comp0;
       strictInflationary = strictInflationary0; strictInflationary_comp =
       strictInflationary_comp0; strict = strict0; strict_comp =
       strict_comp0 } = stp
     in
    (match distributive_comp0 with
       | Some x -> Some (coq_Iso_Distributive_comp s s' i x)
       | None -> None)); inflationary =
    (let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
       distributive0; distributive_comp = distributive_comp0; inflationary =
       inflationary0; inflationary_comp = inflationary_comp0;
       strictInflationary = strictInflationary0; strictInflationary_comp =
       strictInflationary_comp0; strict = strict0; strict_comp =
       strict_comp0 } = stp
     in
    (match inflationary0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); inflationary_comp =
    (let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
       distributive0; distributive_comp = distributive_comp0; inflationary =
       inflationary0; inflationary_comp = inflationary_comp0;
       strictInflationary = strictInflationary0; strictInflationary_comp =
       strictInflationary_comp0; strict = strict0; strict_comp =
       strict_comp0 } = stp
     in
    (match inflationary_comp0 with
       | Some x -> Some (fun _ _ -> coq_Iso_Inflationary_comp s s' i x)
       | None -> None)); strictInflationary =
    (let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
       distributive0; distributive_comp = distributive_comp0; inflationary =
       inflationary0; inflationary_comp = inflationary_comp0;
       strictInflationary = strictInflationary0; strictInflationary_comp =
       strictInflationary_comp0; strict = strict0; strict_comp =
       strict_comp0 } = stp
     in
    (match strictInflationary0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); strictInflationary_comp =
    (let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
       distributive0; distributive_comp = distributive_comp0; inflationary =
       inflationary0; inflationary_comp = inflationary_comp0;
       strictInflationary = strictInflationary0; strictInflationary_comp =
       strictInflationary_comp0; strict = strict0; strict_comp =
       strict_comp0 } = stp
     in
    (match strictInflationary_comp0 with
       | Some x -> Some (fun _ _ -> coq_Iso_StrictInflationary_comp s s' i x)
       | None -> None)); strict =
    (let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
       distributive0; distributive_comp = distributive_comp0; inflationary =
       inflationary0; inflationary_comp = inflationary_comp0;
       strictInflationary = strictInflationary0; strictInflationary_comp =
       strictInflationary_comp0; strict = strict0; strict_comp =
       strict_comp0 } = stp
     in
    (match strict0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); strict_comp =
    (let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
       distributive0; distributive_comp = distributive_comp0; inflationary =
       inflationary0; inflationary_comp = inflationary_comp0;
       strictInflationary = strictInflationary0; strictInflationary_comp =
       strictInflationary_comp0; strict = strict0; strict_comp =
       strict_comp0 } = stp
     in
    (match strict_comp0 with
       | Some x -> Some (coq_Iso_Strict_comp s s' i x)
       | None -> None)) }

