open DecSetoid
open SemigroupProperties
open SemigroupTransform
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type coq_Distributive_comp =
  (carrier, (carrier, (carrier, __) sigT) sigT) sigT

type coq_Inflationary_comp = __ -> __ -> (carrier, (carrier, __) sigT) sigT

type coq_Deflationary_comp = __ -> __ -> (carrier, (carrier, __) sigT) sigT

type coq_StrictInflationary_comp =
  __ -> __ -> (carrier, (carrier, __) sigT) sigT

type coq_StrictDeflationary_comp =
  __ -> __ -> (carrier, (carrier, __) sigT) sigT

type coq_Strict_comp = coq_HasIdentity -> (carrier, __) sigT

(** val coq_Iso_Distributive_comp :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso ->
    coq_Distributive_comp -> coq_Distributive_comp **)

let coq_Iso_Distributive_comp sT sT' i = function
  | Coq_existT (x, h0) -> Coq_existT ((i.dsIso.phi x),
      (let Coq_existT (x0, h1) = h0 in
      Coq_existT ((i.dsIso.phi x0),
      (let Coq_existT (x1, _) = h1 in Coq_existT ((i.fnIso.phi x1), __)))))

(** val coq_Iso_Inflationary_comp :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso ->
    coq_Inflationary_comp -> (carrier, (carrier, __) sigT) sigT **)

let coq_Iso_Inflationary_comp sT sT' i h =
  let Coq_existT (x, h0) = h __ __ in
  Coq_existT ((i.dsIso.phi x),
  (let Coq_existT (x0, _) = h0 in Coq_existT ((i.fnIso.phi x0), __)))

(** val coq_Iso_Deflationary_comp :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso ->
    coq_Deflationary_comp -> (carrier, (carrier, __) sigT) sigT **)

let coq_Iso_Deflationary_comp sT sT' i h =
  let Coq_existT (x, h0) = h __ __ in
  Coq_existT ((i.dsIso.phi x),
  (let Coq_existT (x0, _) = h0 in Coq_existT ((i.fnIso.phi x0), __)))

(** val coq_Iso_StrictInflationary_comp :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso ->
    coq_StrictInflationary_comp -> (carrier, (carrier, __) sigT) sigT **)

let coq_Iso_StrictInflationary_comp sT sT' i h =
  let Coq_existT (x, h0) = h __ __ in
  Coq_existT ((i.dsIso.phi x),
  (let Coq_existT (x0, _) = h0 in Coq_existT ((i.fnIso.phi x0), __)))

(** val coq_Iso_StrictDeflationary_comp :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso ->
    coq_StrictDeflationary_comp -> (carrier, (carrier, __) sigT) sigT **)

let coq_Iso_StrictDeflationary_comp sT sT' i h =
  let Coq_existT (x, h0) = h __ __ in
  Coq_existT ((i.dsIso.phi x),
  (let Coq_existT (x0, _) = h0 in Coq_existT ((i.fnIso.phi x0), __)))

(** val coq_Iso_Strict_comp :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_STfIso ->
    coq_Strict_comp -> coq_Strict_comp **)

let coq_Iso_Strict_comp sT sT' i h hasId0 =
  let Coq_existT (x, _) =
    h (let Coq_existT (x, _) = hasId0 in Coq_existT ((i.dsIso.phi' x), __))
  in
  Coq_existT ((i.fnIso.phi x), __)

