open Datatypes
open DecSetoid
open Semigroup
open SemigroupProperties
open Specif
open Union
open Unit

type __ = Obj.t

val top_union_setoid : coq_Semigroup -> coq_Semigroup -> coq_DecSetoid

val top_el : coq_Semigroup -> coq_Semigroup -> carrier

val coq_A_el : coq_Semigroup -> coq_Semigroup -> carrier -> carrier

val coq_B_el : coq_Semigroup -> coq_Semigroup -> carrier -> carrier

val top_union_op :
  coq_Semigroup -> coq_Semigroup -> carrier -> carrier -> carrier

val topUnionSemigroup : coq_Semigroup -> coq_Semigroup -> coq_Semigroup

val isIdempotent_comp :
  coq_Semigroup -> coq_Semigroup -> (coq_IsIdempotent_comp,
  coq_IsIdempotent_comp) sum -> coq_IsIdempotent_comp

val isSelective_comp : coq_Semigroup -> coq_Semigroup -> coq_IsSelective_comp

val isCommutative_comp :
  coq_Semigroup -> coq_Semigroup -> (coq_IsCommutative_comp,
  coq_IsCommutative_comp) sum -> coq_IsCommutative_comp

val hasIdentity_comp : coq_Semigroup -> coq_Semigroup -> coq_HasIdentity_comp

val hasAnnihilator : coq_Semigroup -> coq_Semigroup -> coq_HasAnnihilator

val isLeft_comp : coq_Semigroup -> coq_Semigroup -> coq_IsLeft_comp

val isRight_comp : coq_Semigroup -> coq_Semigroup -> coq_IsRight_comp

val leftCondensed_comp :
  coq_Semigroup -> coq_Semigroup -> coq_LeftCondensed_comp

val rightCondensed_comp :
  coq_Semigroup -> coq_Semigroup -> coq_RightCondensed_comp

val leftCancelative_comp :
  coq_Semigroup -> coq_Semigroup -> coq_LeftCancelative_comp

val rightCancelative_comp :
  coq_Semigroup -> coq_Semigroup -> coq_RightCancelative_comp

val antiLeft_comp : coq_Semigroup -> coq_Semigroup -> coq_AntiLeft_comp

val antiRight_comp : coq_Semigroup -> coq_Semigroup -> coq_AntiRight_comp

val treeGlb_comp :
  coq_Semigroup -> coq_Semigroup -> (coq_TreeGlb_comp, coq_TreeGlb_comp) sum
  -> (carrier, (carrier, (carrier, __) sigT) sigT) sigT

