open Datatypes
open DecSetoid
open DecSetoidPropRecord
open Logic0
open Semigroup
open SemigroupPropRecord
open Specif
open TopUnion
open Union
open Union7
open Unit
open Unit2

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val topUnionSemigroup_props :
    coq_Semigroup -> coq_Semigroup -> sgProp -> sgProp -> sgProp **)

let topUnionSemigroup_props a b ap bp =
  { sg_dsprop =
    (unionDecSetoid_props (unionDecSetoid a.setoid b.setoid) unitDecSetoid
      (unionDecSetoid_props a.setoid b.setoid ap.sg_dsprop bp.sg_dsprop)
      unitDecSetoid_props); hasIdentity =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.hasIdentity_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (hasIdentity_comp a b)); SemigroupPropRecord.hasAnnihilator =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (Coq_existT ((Obj.magic (Coq_inr ())), __)));
    hasAnnihilator_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); isSelective =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.isSelective_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (isSelective_comp a b)); isCommutative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    (match isCommutative1 with
       | Some a0 ->
           (match isCommutative0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); SemigroupPropRecord.isCommutative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    (match isCommutative_comp1 with
       | Some a0 -> Some
           (let Coq_existT (a1, s) = a0 in
           let Coq_existT (a', _) = s in
           Coq_existT ((Obj.magic (Coq_inl (Coq_inl a1))), (Coq_existT
           ((Obj.magic (Coq_inl (Coq_inl a'))), __))))
       | None ->
           (match isCommutative_comp0 with
              | Some b0 -> Some
                  (let Coq_existT (b1, s) = b0 in
                  let Coq_existT (b', _) = s in
                  Coq_existT ((Obj.magic (Coq_inl (Coq_inr b1))), (Coq_existT
                  ((Obj.magic (Coq_inl (Coq_inr b'))), __))))
              | None -> None))); isIdempotent =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    (match isIdempotent1 with
       | Some a0 ->
           (match isIdempotent0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); SemigroupPropRecord.isIdempotent_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    (match isIdempotent_comp1 with
       | Some a0 -> Some
           (let Coq_existT (a1, _) = a0 in
           Coq_existT ((Obj.magic (Coq_inl (Coq_inl a1))), __))
       | None ->
           (match isIdempotent_comp0 with
              | Some b0 -> Some
                  (let Coq_existT (b1, _) = b0 in
                  Coq_existT ((Obj.magic (Coq_inl (Coq_inr b1))), __))
              | None -> None))); isLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.isLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (Coq_existT ((Obj.magic (Coq_inl (Coq_inl a.setoid.choose))),
      (Coq_existT ((Obj.magic (Coq_inr ())), __))))); isRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.isRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (Coq_existT ((Obj.magic (Coq_inr ())), (Coq_existT
      ((Obj.magic (Coq_inl (Coq_inl a.setoid.choose))), __)))));
    leftCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.leftCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (Coq_existT ((Obj.magic (Coq_inl (Coq_inl a.setoid.choose))),
      (Coq_existT ((Obj.magic (Coq_inr ())), (Coq_existT
      ((Obj.magic (Coq_inl (Coq_inl a.setoid.choose))), __)))))));
    rightCondensed =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.rightCondensed_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (Coq_existT ((Obj.magic (Coq_inl (Coq_inl a.setoid.choose))),
      (Coq_existT ((Obj.magic (Coq_inr ())), (Coq_existT
      ((Obj.magic (Coq_inl (Coq_inl a.setoid.choose))), __)))))));
    leftCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.leftCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (leftCancelative_comp a b)); rightCancelative =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.rightCancelative_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (rightCancelative_comp a b)); antiLeft =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.antiLeft_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (Coq_existT ((Obj.magic (Coq_inr ())), (Coq_existT
      ((Obj.magic (Coq_inl (Coq_inl a.setoid.choose))), __))))); antiRight =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    None); SemigroupPropRecord.antiRight_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    opInit (Coq_existT ((Obj.magic (Coq_inl (Coq_inl a.setoid.choose))),
      (Coq_existT ((Obj.magic (Coq_inr ())), __))))); treeGlb =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    (match treeGlb1 with
       | Some a0 ->
           (match treeGlb0 with
              | Some b0 -> Some (Obj.magic __ (a0 , b0))
              | None -> None)
       | None -> None)); SemigroupPropRecord.treeGlb_comp =
    (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
       SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp0;
       SemigroupPropRecord.hasAnnihilator = hasAnnihilator0;
       hasAnnihilator_comp = hasAnnihilator_comp0; isSelective =
       isSelective0; SemigroupPropRecord.isSelective_comp =
       isSelective_comp0; isCommutative = isCommutative0;
       SemigroupPropRecord.isCommutative_comp = isCommutative_comp0;
       isIdempotent = isIdempotent0; SemigroupPropRecord.isIdempotent_comp =
       isIdempotent_comp0; isLeft = isLeft0;
       SemigroupPropRecord.isLeft_comp = isLeft_comp0; isRight = isRight0;
       SemigroupPropRecord.isRight_comp = isRight_comp0; leftCondensed =
       leftCondensed0; SemigroupPropRecord.leftCondensed_comp =
       leftCondensed_comp0; rightCondensed = rightCondensed0;
       SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp0;
       leftCancelative = leftCancelative0;
       SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp0;
       rightCancelative = rightCancelative0;
       SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp0;
       antiLeft = antiLeft0; SemigroupPropRecord.antiLeft_comp =
       antiLeft_comp0; antiRight = antiRight0;
       SemigroupPropRecord.antiRight_comp = antiRight_comp0; treeGlb =
       treeGlb0; SemigroupPropRecord.treeGlb_comp = treeGlb_comp0 } = bp
     in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      SemigroupPropRecord.hasIdentity_comp = hasIdentity_comp1;
      SemigroupPropRecord.hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      SemigroupPropRecord.isSelective_comp = isSelective_comp1;
      isCommutative = isCommutative1;
      SemigroupPropRecord.isCommutative_comp = isCommutative_comp1;
      isIdempotent = isIdempotent1; SemigroupPropRecord.isIdempotent_comp =
      isIdempotent_comp1; isLeft = isLeft1; SemigroupPropRecord.isLeft_comp =
      isLeft_comp1; isRight = isRight1; SemigroupPropRecord.isRight_comp =
      isRight_comp1; leftCondensed = leftCondensed1;
      SemigroupPropRecord.leftCondensed_comp = leftCondensed_comp1;
      rightCondensed = rightCondensed1;
      SemigroupPropRecord.rightCondensed_comp = rightCondensed_comp1;
      leftCancelative = leftCancelative1;
      SemigroupPropRecord.leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1;
      SemigroupPropRecord.rightCancelative_comp = rightCancelative_comp1;
      antiLeft = antiLeft1; SemigroupPropRecord.antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1;
      SemigroupPropRecord.antiRight_comp = antiRight_comp1; treeGlb =
      treeGlb1; SemigroupPropRecord.treeGlb_comp = treeGlb_comp1 } = ap
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton0;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp0;
      DecSetoidPropRecord.twoElements = twoElements0;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp0;
      DecSetoidPropRecord.finite = finite0; DecSetoidPropRecord.finite_comp =
      finite_comp0 } = sg_dsprop0
    in
    let { DecSetoidPropRecord.isSingleton = isSingleton1;
      DecSetoidPropRecord.isSingleton_comp = isSingleton_comp1;
      DecSetoidPropRecord.twoElements = twoElements1;
      DecSetoidPropRecord.twoElements_comp = twoElements_comp1;
      DecSetoidPropRecord.finite = finite1; DecSetoidPropRecord.finite_comp =
      finite_comp1 } = sg_dsprop1
    in
    (match treeGlb_comp1 with
       | Some a0 -> Some (fun _ _ -> treeGlb_comp a b (Coq_inl a0))
       | None ->
           (match treeGlb_comp0 with
              | Some b0 -> Some (fun _ _ -> treeGlb_comp a b (Coq_inr b0))
              | None -> None))) }

