open DecSetoidPropRecord
open Transform
open TransformProperties

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type tfProp = { tf_dsprop : dsProp; tf_fndsprop : dsProp;
                cancelative : __ option;
                cancelative_comp : coq_Cancelative_comp option;
                condensed : __ option;
                condensed_comp : coq_Condensed_comp option }

(** val tfProp_rect :
    coq_Transform -> (dsProp -> dsProp -> __ option -> coq_Cancelative_comp
    option -> __ option -> coq_Condensed_comp option -> 'a1) -> tfProp -> 'a1 **)

let tfProp_rect t f t0 =
  let { tf_dsprop = x; tf_fndsprop = x0; cancelative = x1; cancelative_comp =
    x2; condensed = x3; condensed_comp = x4 } = t0
  in
  f x x0 x1 x2 x3 x4

(** val tfProp_rec :
    coq_Transform -> (dsProp -> dsProp -> __ option -> coq_Cancelative_comp
    option -> __ option -> coq_Condensed_comp option -> 'a1) -> tfProp -> 'a1 **)

let tfProp_rec t f t0 =
  let { tf_dsprop = x; tf_fndsprop = x0; cancelative = x1; cancelative_comp =
    x2; condensed = x3; condensed_comp = x4 } = t0
  in
  f x x0 x1 x2 x3 x4

(** val tf_dsprop : coq_Transform -> tfProp -> dsProp **)

let tf_dsprop _ x = x.tf_dsprop

(** val tf_fndsprop : coq_Transform -> tfProp -> dsProp **)

let tf_fndsprop _ x = x.tf_fndsprop

(** val cancelative : coq_Transform -> tfProp -> __ option **)

let cancelative _ x = x.cancelative

(** val cancelative_comp :
    coq_Transform -> tfProp -> coq_Cancelative_comp option **)

let cancelative_comp _ x = x.cancelative_comp

(** val condensed : coq_Transform -> tfProp -> __ option **)

let condensed _ x = x.condensed

(** val condensed_comp :
    coq_Transform -> tfProp -> coq_Condensed_comp option **)

let condensed_comp _ x = x.condensed_comp

(** val tfPropIso :
    coq_Transform -> coq_Transform -> coq_TfIso -> tfProp -> tfProp **)

let tfPropIso t t' i tfp =
  { tf_dsprop = (dsPropIso t.setoid t'.setoid i.dsIso tfp.tf_dsprop);
    tf_fndsprop = (dsPropIso t.fn t'.fn i.fnIso tfp.tf_fndsprop);
    cancelative =
    (let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
       cancelative0; cancelative_comp = cancelative_comp0; condensed =
       condensed0; condensed_comp = condensed_comp0 } = tfp
     in
    (match cancelative0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); cancelative_comp =
    (let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
       cancelative0; cancelative_comp = cancelative_comp0; condensed =
       condensed0; condensed_comp = condensed_comp0 } = tfp
     in
    (match cancelative_comp0 with
       | Some x -> Some (coq_Iso_Cancelative_comp t t' i x)
       | None -> None)); condensed =
    (let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
       cancelative0; cancelative_comp = cancelative_comp0; condensed =
       condensed0; condensed_comp = condensed_comp0 } = tfp
     in
    (match condensed0 with
       | Some x -> Some (Obj.magic __ x)
       | None -> None)); condensed_comp =
    (let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
       cancelative0; cancelative_comp = cancelative_comp0; condensed =
       condensed0; condensed_comp = condensed_comp0 } = tfp
     in
    (match condensed_comp0 with
       | Some x -> Some (coq_Iso_Condensed_comp t t' i x)
       | None -> None)) }

