open Datatypes
open DecSetoid
open DecSetoidPropRecord
open IdArrow
open Semigroup
open SemigroupPropRecord
open SemigroupTransform
open SemigroupTransformGlue
open SemigroupTransformPropRecord
open TransformPropRecord
open Union2
open Union1
open Union9

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val unionSemigroupTransform_SgEq_props :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) -> stProp -> stProp -> stProp **)

let unionSemigroupTransform_SgEq_props s f g aF aG ap pb =
  let sgp =
    sgPropIso s
      (semigroupST
        (glueSTf_DsEq s (unionTransform_DsEq s.Semigroup.setoid f g aF aG)))
      (glueSTfSmg_DsEq s (unionTransform_DsEq s.Semigroup.setoid f g aF aG))
      (let { Semigroup.setoid = setoid0; Semigroup.op = op0 } = s in
      ap.st_sgprop)
  in
  let tfp =
    tfPropIso (unionTransform_DsEq s.Semigroup.setoid f g aF aG)
      (transformST
        (glueSTf_DsEq s (unionTransform_DsEq s.Semigroup.setoid f g aF aG)))
      (glueSTfTf_DsEq s (unionTransform_DsEq s.Semigroup.setoid f g aF aG))
      (unionTransform_DsEq_props s.Semigroup.setoid f g aF aG (ap.st_tfprop)
        (pb.st_tfprop))
  in
  { st_sgprop = sgp; st_tfprop = tfp; distributive =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; TransformPropRecord.cancelative_comp = cancelative_comp0;
    condensed = condensed0; TransformPropRecord.condensed_comp =
    condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_dsprop0
  in
  let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
    distributive0; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp0; inflationary = inflationary0;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp0;
    strictInflationary = strictInflationary0;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp0; strict = strict0;
    SemigroupTransformPropRecord.strict_comp = strict_comp0 } = pb
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = st_sgprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop1; tf_fndsprop = tf_fndsprop1; cancelative =
    cancelative1; TransformPropRecord.cancelative_comp = cancelative_comp1;
    condensed = condensed1; TransformPropRecord.condensed_comp =
    condensed_comp1 } = st_tfprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_fndsprop1
  in
  let { isSingleton = isSingleton5; isSingleton_comp = isSingleton_comp5;
    twoElements = twoElements5; twoElements_comp = twoElements_comp5;
    finite = finite5; finite_comp = finite_comp5 } = tf_dsprop1
  in
  let { st_sgprop = st_sgprop1; st_tfprop = st_tfprop1; distributive =
    distributive1; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp1; inflationary = inflationary1;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp1;
    strictInflationary = strictInflationary1;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp1; strict = strict1;
    SemigroupTransformPropRecord.strict_comp = strict_comp1 } = ap
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = st_sgprop1
  in
  let { isSingleton = isSingleton6; isSingleton_comp = isSingleton_comp6;
    twoElements = twoElements6; twoElements_comp = twoElements_comp6;
    finite = finite6; finite_comp = finite_comp6 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop2; tf_fndsprop = tf_fndsprop2; cancelative =
    cancelative2; TransformPropRecord.cancelative_comp = cancelative_comp2;
    condensed = condensed2; TransformPropRecord.condensed_comp =
    condensed_comp2 } = st_tfprop1
  in
  let { isSingleton = isSingleton7; isSingleton_comp = isSingleton_comp7;
    twoElements = twoElements7; twoElements_comp = twoElements_comp7;
    finite = finite7; finite_comp = finite_comp7 } = tf_fndsprop2
  in
  let { isSingleton = isSingleton8; isSingleton_comp = isSingleton_comp8;
    twoElements = twoElements8; twoElements_comp = twoElements_comp8;
    finite = finite8; finite_comp = finite_comp8 } = tf_dsprop2
  in
  (match distributive1 with
     | Some a ->
         (match distributive0 with
            | Some b -> Some (Obj.magic __ (a , b))
            | None -> None)
     | None -> None)); SemigroupTransformPropRecord.distributive_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; TransformPropRecord.cancelative_comp = cancelative_comp0;
    condensed = condensed0; TransformPropRecord.condensed_comp =
    condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_dsprop0
  in
  let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
    distributive0; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp0; inflationary = inflationary0;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp0;
    strictInflationary = strictInflationary0;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp0; strict = strict0;
    SemigroupTransformPropRecord.strict_comp = strict_comp0 } = pb
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = st_sgprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop1; tf_fndsprop = tf_fndsprop1; cancelative =
    cancelative1; TransformPropRecord.cancelative_comp = cancelative_comp1;
    condensed = condensed1; TransformPropRecord.condensed_comp =
    condensed_comp1 } = st_tfprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_fndsprop1
  in
  let { isSingleton = isSingleton5; isSingleton_comp = isSingleton_comp5;
    twoElements = twoElements5; twoElements_comp = twoElements_comp5;
    finite = finite5; finite_comp = finite_comp5 } = tf_dsprop1
  in
  let { st_sgprop = st_sgprop1; st_tfprop = st_tfprop1; distributive =
    distributive1; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp1; inflationary = inflationary1;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp1;
    strictInflationary = strictInflationary1;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp1; strict = strict1;
    SemigroupTransformPropRecord.strict_comp = strict_comp1 } = ap
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = st_sgprop1
  in
  let { isSingleton = isSingleton6; isSingleton_comp = isSingleton_comp6;
    twoElements = twoElements6; twoElements_comp = twoElements_comp6;
    finite = finite6; finite_comp = finite_comp6 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop2; tf_fndsprop = tf_fndsprop2; cancelative =
    cancelative2; TransformPropRecord.cancelative_comp = cancelative_comp2;
    condensed = condensed2; TransformPropRecord.condensed_comp =
    condensed_comp2 } = st_tfprop1
  in
  let { isSingleton = isSingleton7; isSingleton_comp = isSingleton_comp7;
    twoElements = twoElements7; twoElements_comp = twoElements_comp7;
    finite = finite7; finite_comp = finite_comp7 } = tf_fndsprop2
  in
  let { isSingleton = isSingleton8; isSingleton_comp = isSingleton_comp8;
    twoElements = twoElements8; twoElements_comp = twoElements_comp8;
    finite = finite8; finite_comp = finite_comp8 } = tf_dsprop2
  in
  (match distributive_comp1 with
     | Some a -> Some (distributive_comp s f g aF aG (Coq_inl a))
     | None ->
         (match distributive_comp0 with
            | Some b -> Some (distributive_comp s f g aF aG (Coq_inr b))
            | None -> None))); inflationary =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; TransformPropRecord.cancelative_comp = cancelative_comp0;
    condensed = condensed0; TransformPropRecord.condensed_comp =
    condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_dsprop0
  in
  let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
    distributive0; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp0; inflationary = inflationary0;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp0;
    strictInflationary = strictInflationary0;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp0; strict = strict0;
    SemigroupTransformPropRecord.strict_comp = strict_comp0 } = pb
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = st_sgprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop1; tf_fndsprop = tf_fndsprop1; cancelative =
    cancelative1; TransformPropRecord.cancelative_comp = cancelative_comp1;
    condensed = condensed1; TransformPropRecord.condensed_comp =
    condensed_comp1 } = st_tfprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_fndsprop1
  in
  let { isSingleton = isSingleton5; isSingleton_comp = isSingleton_comp5;
    twoElements = twoElements5; twoElements_comp = twoElements_comp5;
    finite = finite5; finite_comp = finite_comp5 } = tf_dsprop1
  in
  let { st_sgprop = st_sgprop1; st_tfprop = st_tfprop1; distributive =
    distributive1; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp1; inflationary = inflationary1;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp1;
    strictInflationary = strictInflationary1;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp1; strict = strict1;
    SemigroupTransformPropRecord.strict_comp = strict_comp1 } = ap
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = st_sgprop1
  in
  let { isSingleton = isSingleton6; isSingleton_comp = isSingleton_comp6;
    twoElements = twoElements6; twoElements_comp = twoElements_comp6;
    finite = finite6; finite_comp = finite_comp6 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop2; tf_fndsprop = tf_fndsprop2; cancelative =
    cancelative2; TransformPropRecord.cancelative_comp = cancelative_comp2;
    condensed = condensed2; TransformPropRecord.condensed_comp =
    condensed_comp2 } = st_tfprop1
  in
  let { isSingleton = isSingleton7; isSingleton_comp = isSingleton_comp7;
    twoElements = twoElements7; twoElements_comp = twoElements_comp7;
    finite = finite7; finite_comp = finite_comp7 } = tf_fndsprop2
  in
  let { isSingleton = isSingleton8; isSingleton_comp = isSingleton_comp8;
    twoElements = twoElements8; twoElements_comp = twoElements_comp8;
    finite = finite8; finite_comp = finite_comp8 } = tf_dsprop2
  in
  (match inflationary1 with
     | Some a ->
         (match inflationary0 with
            | Some b -> Some (Obj.magic __ (a , b))
            | None -> None)
     | None -> None)); SemigroupTransformPropRecord.inflationary_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; TransformPropRecord.cancelative_comp = cancelative_comp0;
    condensed = condensed0; TransformPropRecord.condensed_comp =
    condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_dsprop0
  in
  let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
    distributive0; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp0; inflationary = inflationary0;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp0;
    strictInflationary = strictInflationary0;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp0; strict = strict0;
    SemigroupTransformPropRecord.strict_comp = strict_comp0 } = pb
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = st_sgprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop1; tf_fndsprop = tf_fndsprop1; cancelative =
    cancelative1; TransformPropRecord.cancelative_comp = cancelative_comp1;
    condensed = condensed1; TransformPropRecord.condensed_comp =
    condensed_comp1 } = st_tfprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_fndsprop1
  in
  let { isSingleton = isSingleton5; isSingleton_comp = isSingleton_comp5;
    twoElements = twoElements5; twoElements_comp = twoElements_comp5;
    finite = finite5; finite_comp = finite_comp5 } = tf_dsprop1
  in
  let { st_sgprop = st_sgprop1; st_tfprop = st_tfprop1; distributive =
    distributive1; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp1; inflationary = inflationary1;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp1;
    strictInflationary = strictInflationary1;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp1; strict = strict1;
    SemigroupTransformPropRecord.strict_comp = strict_comp1 } = ap
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = st_sgprop1
  in
  let { isSingleton = isSingleton6; isSingleton_comp = isSingleton_comp6;
    twoElements = twoElements6; twoElements_comp = twoElements_comp6;
    finite = finite6; finite_comp = finite_comp6 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop2; tf_fndsprop = tf_fndsprop2; cancelative =
    cancelative2; TransformPropRecord.cancelative_comp = cancelative_comp2;
    condensed = condensed2; TransformPropRecord.condensed_comp =
    condensed_comp2 } = st_tfprop1
  in
  let { isSingleton = isSingleton7; isSingleton_comp = isSingleton_comp7;
    twoElements = twoElements7; twoElements_comp = twoElements_comp7;
    finite = finite7; finite_comp = finite_comp7 } = tf_fndsprop2
  in
  let { isSingleton = isSingleton8; isSingleton_comp = isSingleton_comp8;
    twoElements = twoElements8; twoElements_comp = twoElements_comp8;
    finite = finite8; finite_comp = finite_comp8 } = tf_dsprop2
  in
  (match inflationary_comp1 with
     | Some a -> Some (fun _ _ -> inflationary_comp s f g aF aG (Coq_inl a))
     | None ->
         (match inflationary_comp0 with
            | Some b -> Some (fun _ _ ->
                inflationary_comp s f g aF aG (Coq_inr b))
            | None -> None))); strictInflationary =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; TransformPropRecord.cancelative_comp = cancelative_comp0;
    condensed = condensed0; TransformPropRecord.condensed_comp =
    condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_dsprop0
  in
  let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
    distributive0; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp0; inflationary = inflationary0;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp0;
    strictInflationary = strictInflationary0;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp0; strict = strict0;
    SemigroupTransformPropRecord.strict_comp = strict_comp0 } = pb
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = st_sgprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop1; tf_fndsprop = tf_fndsprop1; cancelative =
    cancelative1; TransformPropRecord.cancelative_comp = cancelative_comp1;
    condensed = condensed1; TransformPropRecord.condensed_comp =
    condensed_comp1 } = st_tfprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_fndsprop1
  in
  let { isSingleton = isSingleton5; isSingleton_comp = isSingleton_comp5;
    twoElements = twoElements5; twoElements_comp = twoElements_comp5;
    finite = finite5; finite_comp = finite_comp5 } = tf_dsprop1
  in
  let { st_sgprop = st_sgprop1; st_tfprop = st_tfprop1; distributive =
    distributive1; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp1; inflationary = inflationary1;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp1;
    strictInflationary = strictInflationary1;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp1; strict = strict1;
    SemigroupTransformPropRecord.strict_comp = strict_comp1 } = ap
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = st_sgprop1
  in
  let { isSingleton = isSingleton6; isSingleton_comp = isSingleton_comp6;
    twoElements = twoElements6; twoElements_comp = twoElements_comp6;
    finite = finite6; finite_comp = finite_comp6 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop2; tf_fndsprop = tf_fndsprop2; cancelative =
    cancelative2; TransformPropRecord.cancelative_comp = cancelative_comp2;
    condensed = condensed2; TransformPropRecord.condensed_comp =
    condensed_comp2 } = st_tfprop1
  in
  let { isSingleton = isSingleton7; isSingleton_comp = isSingleton_comp7;
    twoElements = twoElements7; twoElements_comp = twoElements_comp7;
    finite = finite7; finite_comp = finite_comp7 } = tf_fndsprop2
  in
  let { isSingleton = isSingleton8; isSingleton_comp = isSingleton_comp8;
    twoElements = twoElements8; twoElements_comp = twoElements_comp8;
    finite = finite8; finite_comp = finite_comp8 } = tf_dsprop2
  in
  (match strictInflationary1 with
     | Some a ->
         (match strictInflationary0 with
            | Some b -> Some (Obj.magic __ (a , b))
            | None -> None)
     | None -> None)); SemigroupTransformPropRecord.strictInflationary_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; TransformPropRecord.cancelative_comp = cancelative_comp0;
    condensed = condensed0; TransformPropRecord.condensed_comp =
    condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_dsprop0
  in
  let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
    distributive0; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp0; inflationary = inflationary0;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp0;
    strictInflationary = strictInflationary0;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp0; strict = strict0;
    SemigroupTransformPropRecord.strict_comp = strict_comp0 } = pb
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = st_sgprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop1; tf_fndsprop = tf_fndsprop1; cancelative =
    cancelative1; TransformPropRecord.cancelative_comp = cancelative_comp1;
    condensed = condensed1; TransformPropRecord.condensed_comp =
    condensed_comp1 } = st_tfprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_fndsprop1
  in
  let { isSingleton = isSingleton5; isSingleton_comp = isSingleton_comp5;
    twoElements = twoElements5; twoElements_comp = twoElements_comp5;
    finite = finite5; finite_comp = finite_comp5 } = tf_dsprop1
  in
  let { st_sgprop = st_sgprop1; st_tfprop = st_tfprop1; distributive =
    distributive1; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp1; inflationary = inflationary1;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp1;
    strictInflationary = strictInflationary1;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp1; strict = strict1;
    SemigroupTransformPropRecord.strict_comp = strict_comp1 } = ap
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = st_sgprop1
  in
  let { isSingleton = isSingleton6; isSingleton_comp = isSingleton_comp6;
    twoElements = twoElements6; twoElements_comp = twoElements_comp6;
    finite = finite6; finite_comp = finite_comp6 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop2; tf_fndsprop = tf_fndsprop2; cancelative =
    cancelative2; TransformPropRecord.cancelative_comp = cancelative_comp2;
    condensed = condensed2; TransformPropRecord.condensed_comp =
    condensed_comp2 } = st_tfprop1
  in
  let { isSingleton = isSingleton7; isSingleton_comp = isSingleton_comp7;
    twoElements = twoElements7; twoElements_comp = twoElements_comp7;
    finite = finite7; finite_comp = finite_comp7 } = tf_fndsprop2
  in
  let { isSingleton = isSingleton8; isSingleton_comp = isSingleton_comp8;
    twoElements = twoElements8; twoElements_comp = twoElements_comp8;
    finite = finite8; finite_comp = finite_comp8 } = tf_dsprop2
  in
  (match strictInflationary_comp1 with
     | Some a -> Some (fun _ _ ->
         strictInflationary_comp s f g aF aG (Coq_inl a))
     | None ->
         (match strictInflationary_comp0 with
            | Some b -> Some (fun _ _ ->
                strictInflationary_comp s f g aF aG (Coq_inr b))
            | None -> None))); strict =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; TransformPropRecord.cancelative_comp = cancelative_comp0;
    condensed = condensed0; TransformPropRecord.condensed_comp =
    condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_dsprop0
  in
  let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
    distributive0; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp0; inflationary = inflationary0;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp0;
    strictInflationary = strictInflationary0;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp0; strict = strict0;
    SemigroupTransformPropRecord.strict_comp = strict_comp0 } = pb
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = st_sgprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop1; tf_fndsprop = tf_fndsprop1; cancelative =
    cancelative1; TransformPropRecord.cancelative_comp = cancelative_comp1;
    condensed = condensed1; TransformPropRecord.condensed_comp =
    condensed_comp1 } = st_tfprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_fndsprop1
  in
  let { isSingleton = isSingleton5; isSingleton_comp = isSingleton_comp5;
    twoElements = twoElements5; twoElements_comp = twoElements_comp5;
    finite = finite5; finite_comp = finite_comp5 } = tf_dsprop1
  in
  let { st_sgprop = st_sgprop1; st_tfprop = st_tfprop1; distributive =
    distributive1; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp1; inflationary = inflationary1;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp1;
    strictInflationary = strictInflationary1;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp1; strict = strict1;
    SemigroupTransformPropRecord.strict_comp = strict_comp1 } = ap
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = st_sgprop1
  in
  let { isSingleton = isSingleton6; isSingleton_comp = isSingleton_comp6;
    twoElements = twoElements6; twoElements_comp = twoElements_comp6;
    finite = finite6; finite_comp = finite_comp6 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop2; tf_fndsprop = tf_fndsprop2; cancelative =
    cancelative2; TransformPropRecord.cancelative_comp = cancelative_comp2;
    condensed = condensed2; TransformPropRecord.condensed_comp =
    condensed_comp2 } = st_tfprop1
  in
  let { isSingleton = isSingleton7; isSingleton_comp = isSingleton_comp7;
    twoElements = twoElements7; twoElements_comp = twoElements_comp7;
    finite = finite7; finite_comp = finite_comp7 } = tf_fndsprop2
  in
  let { isSingleton = isSingleton8; isSingleton_comp = isSingleton_comp8;
    twoElements = twoElements8; twoElements_comp = twoElements_comp8;
    finite = finite8; finite_comp = finite_comp8 } = tf_dsprop2
  in
  (match strict1 with
     | Some a ->
         (match strict0 with
            | Some b -> Some (Obj.magic __ (a , b))
            | None -> None)
     | None -> None)); SemigroupTransformPropRecord.strict_comp =
  (let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
     hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
     hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
     isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
     isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
     isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
     isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
     leftCondensed = leftCondensed0; leftCondensed_comp =
     leftCondensed_comp0; rightCondensed = rightCondensed0;
     rightCondensed_comp = rightCondensed_comp0; leftCancelative =
     leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
     rightCancelative = rightCancelative0; rightCancelative_comp =
     rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
     antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
     antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
     sgp
   in
  let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
    twoElements = twoElements0; twoElements_comp = twoElements_comp0;
    finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
  in
  let { tf_dsprop = tf_dsprop0; tf_fndsprop = tf_fndsprop0; cancelative =
    cancelative0; TransformPropRecord.cancelative_comp = cancelative_comp0;
    condensed = condensed0; TransformPropRecord.condensed_comp =
    condensed_comp0 } = tfp
  in
  let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
    twoElements = twoElements1; twoElements_comp = twoElements_comp1;
    finite = finite1; finite_comp = finite_comp1 } = tf_fndsprop0
  in
  let { isSingleton = isSingleton2; isSingleton_comp = isSingleton_comp2;
    twoElements = twoElements2; twoElements_comp = twoElements_comp2;
    finite = finite2; finite_comp = finite_comp2 } = tf_dsprop0
  in
  let { st_sgprop = st_sgprop0; st_tfprop = st_tfprop0; distributive =
    distributive0; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp0; inflationary = inflationary0;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp0;
    strictInflationary = strictInflationary0;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp0; strict = strict0;
    SemigroupTransformPropRecord.strict_comp = strict_comp0 } = pb
  in
  let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
    hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
    hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
    isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
    isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
    isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
    isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
    leftCondensed = leftCondensed1; leftCondensed_comp = leftCondensed_comp1;
    rightCondensed = rightCondensed1; rightCondensed_comp =
    rightCondensed_comp1; leftCancelative = leftCancelative1;
    leftCancelative_comp = leftCancelative_comp1; rightCancelative =
    rightCancelative1; rightCancelative_comp = rightCancelative_comp1;
    antiLeft = antiLeft1; antiLeft_comp = antiLeft_comp1; antiRight =
    antiRight1; antiRight_comp = antiRight_comp1; treeGlb = treeGlb1;
    treeGlb_comp = treeGlb_comp1 } = st_sgprop0
  in
  let { isSingleton = isSingleton3; isSingleton_comp = isSingleton_comp3;
    twoElements = twoElements3; twoElements_comp = twoElements_comp3;
    finite = finite3; finite_comp = finite_comp3 } = sg_dsprop1
  in
  let { tf_dsprop = tf_dsprop1; tf_fndsprop = tf_fndsprop1; cancelative =
    cancelative1; TransformPropRecord.cancelative_comp = cancelative_comp1;
    condensed = condensed1; TransformPropRecord.condensed_comp =
    condensed_comp1 } = st_tfprop0
  in
  let { isSingleton = isSingleton4; isSingleton_comp = isSingleton_comp4;
    twoElements = twoElements4; twoElements_comp = twoElements_comp4;
    finite = finite4; finite_comp = finite_comp4 } = tf_fndsprop1
  in
  let { isSingleton = isSingleton5; isSingleton_comp = isSingleton_comp5;
    twoElements = twoElements5; twoElements_comp = twoElements_comp5;
    finite = finite5; finite_comp = finite_comp5 } = tf_dsprop1
  in
  let { st_sgprop = st_sgprop1; st_tfprop = st_tfprop1; distributive =
    distributive1; SemigroupTransformPropRecord.distributive_comp =
    distributive_comp1; inflationary = inflationary1;
    SemigroupTransformPropRecord.inflationary_comp = inflationary_comp1;
    strictInflationary = strictInflationary1;
    SemigroupTransformPropRecord.strictInflationary_comp =
    strictInflationary_comp1; strict = strict1;
    SemigroupTransformPropRecord.strict_comp = strict_comp1 } = ap
  in
  let { sg_dsprop = sg_dsprop2; hasIdentity = hasIdentity2;
    hasIdentity_comp = hasIdentity_comp2; hasAnnihilator = hasAnnihilator2;
    hasAnnihilator_comp = hasAnnihilator_comp2; isSelective = isSelective2;
    isSelective_comp = isSelective_comp2; isCommutative = isCommutative2;
    isCommutative_comp = isCommutative_comp2; isIdempotent = isIdempotent2;
    isIdempotent_comp = isIdempotent_comp2; isLeft = isLeft2; isLeft_comp =
    isLeft_comp2; isRight = isRight2; isRight_comp = isRight_comp2;
    leftCondensed = leftCondensed2; leftCondensed_comp = leftCondensed_comp2;
    rightCondensed = rightCondensed2; rightCondensed_comp =
    rightCondensed_comp2; leftCancelative = leftCancelative2;
    leftCancelative_comp = leftCancelative_comp2; rightCancelative =
    rightCancelative2; rightCancelative_comp = rightCancelative_comp2;
    antiLeft = antiLeft2; antiLeft_comp = antiLeft_comp2; antiRight =
    antiRight2; antiRight_comp = antiRight_comp2; treeGlb = treeGlb2;
    treeGlb_comp = treeGlb_comp2 } = st_sgprop1
  in
  let { isSingleton = isSingleton6; isSingleton_comp = isSingleton_comp6;
    twoElements = twoElements6; twoElements_comp = twoElements_comp6;
    finite = finite6; finite_comp = finite_comp6 } = sg_dsprop2
  in
  let { tf_dsprop = tf_dsprop2; tf_fndsprop = tf_fndsprop2; cancelative =
    cancelative2; TransformPropRecord.cancelative_comp = cancelative_comp2;
    condensed = condensed2; TransformPropRecord.condensed_comp =
    condensed_comp2 } = st_tfprop1
  in
  let { isSingleton = isSingleton7; isSingleton_comp = isSingleton_comp7;
    twoElements = twoElements7; twoElements_comp = twoElements_comp7;
    finite = finite7; finite_comp = finite_comp7 } = tf_fndsprop2
  in
  let { isSingleton = isSingleton8; isSingleton_comp = isSingleton_comp8;
    twoElements = twoElements8; twoElements_comp = twoElements_comp8;
    finite = finite8; finite_comp = finite_comp8 } = tf_dsprop2
  in
  (match strict_comp1 with
     | Some a -> Some (fun x -> strict_comp s f g aF aG (Coq_inl a) x)
     | None ->
         (match strict_comp0 with
            | Some b -> Some (fun x -> strict_comp s f g aF aG (Coq_inr b) x)
            | None -> None))) }

(** val unionSemigroupTransform_props :
    coq_SemigroupTransform -> coq_SemigroupTransform -> stProp -> stProp ->
    coq_IdSmgIso -> stProp **)

let unionSemigroupTransform_props a b ap bp iso =
  let { setoid = setoid0; op = op0; fn = fn0; app = app0 } = a in
  let { choose = choose0; equal = equal0 } = setoid0 in
  let { setoid = setoid1; op = op1; fn = fn1; app = app1 } = b in
  let { choose = choose1; equal = equal1 } = setoid1 in
  unionSemigroupTransform_SgEq_props
    (semigroupST { setoid = { choose = choose0; equal = equal0 }; op = op0;
      fn = fn0; app = app0 }) fn0 fn1 app0 (fun l x ->
    iso.phi' (app1 l (iso.phi x)))
    (stPropIso { setoid = { choose = choose0; equal = equal0 }; op = op0;
      fn = fn0; app = app0 } { setoid =
      (semigroupST { setoid = { choose = choose0; equal = equal0 }; op = op0;
        fn = fn0; app = app0 }).Semigroup.setoid; op =
      (semigroupST { setoid = { choose = choose0; equal = equal0 }; op = op0;
        fn = fn0; app = app0 }).Semigroup.op; fn = fn0; app = app0 }
      { dsIso = { phi = (fun x -> x); phi' = (fun x -> x) }; fnIso = { phi =
      (fun x -> x); phi' = (fun x -> x) } } ap)
    (stPropIso { setoid = { choose = choose1; equal = equal1 }; op = op1;
      fn = fn1; app = app1 } { setoid =
      (semigroupST { setoid = { choose = choose0; equal = equal0 }; op = op0;
        fn = fn0; app = app0 }).Semigroup.setoid; op =
      (semigroupST { setoid = { choose = choose0; equal = equal0 }; op = op0;
        fn = fn0; app = app0 }).Semigroup.op; fn = fn1; app = (fun l x ->
      iso.phi' (app1 l (iso.phi x))) } { dsIso = { phi = iso.phi'; phi' =
      iso.phi }; fnIso = { phi = (fun x -> x); phi' = (fun x -> x) } } bp)

