open Datatypes
open DecSetoid
open IdArrow
open Semigroup
open SemigroupProperties
open SemigroupTransform
open SemigroupTransformGlue
open SemigroupTransformProperties
open Specif
open Transform
open Union1

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val unionSemigroupTransform_SgEq :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) -> coq_SemigroupTransform **)

let unionSemigroupTransform_SgEq s f g app_f app_g =
  glueSTf_DsEq s (unionTransform_DsEq s.Semigroup.setoid f g app_f app_g)

(** val distributive_comp :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) -> (coq_Distributive_comp,
    coq_Distributive_comp) sum -> coq_Distributive_comp **)

let distributive_comp s f g app_f app_g = function
  | Coq_inl d ->
      let Coq_existT (x0, s0) = d in
      let Coq_existT (y, s1) = s0 in
      let Coq_existT (f0, _) = s1 in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (
      (Obj.magic (Coq_inl f0)), __)))))
  | Coq_inr d ->
      let Coq_existT (x0, s0) = d in
      let Coq_existT (y, s1) = s0 in
      let Coq_existT (f0, _) = s1 in
      Coq_existT (x0, (Coq_existT (y, (Coq_existT (
      (Obj.magic (Coq_inr f0)), __)))))

(** val inflationary_comp :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) -> (coq_Inflationary_comp,
    coq_Inflationary_comp) sum -> (carrier, (carrier, __) sigT) sigT **)

let inflationary_comp s f g app_f app_g = function
  | Coq_inl ia ->
      let Coq_existT (x0, s0) = ia __ __ in
      let Coq_existT (f0, _) = s0 in
      Coq_existT (x0, (Coq_existT ((Obj.magic (Coq_inl f0)), __)))
  | Coq_inr ib ->
      let Coq_existT (x0, s0) = ib __ __ in
      let Coq_existT (f0, _) = s0 in
      Coq_existT (x0, (Coq_existT ((Obj.magic (Coq_inr f0)), __)))

(** val deflationary_comp :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) -> (coq_Deflationary_comp,
    coq_Deflationary_comp) sum -> (carrier, (carrier, __) sigT) sigT **)

let deflationary_comp s f g app_f app_g = function
  | Coq_inl ia ->
      let Coq_existT (x0, s0) = ia __ __ in
      let Coq_existT (f0, _) = s0 in
      Coq_existT (x0, (Coq_existT ((Obj.magic (Coq_inl f0)), __)))
  | Coq_inr ib ->
      let Coq_existT (x0, s0) = ib __ __ in
      let Coq_existT (f0, _) = s0 in
      Coq_existT (x0, (Coq_existT ((Obj.magic (Coq_inr f0)), __)))

(** val strictInflationary_comp :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) ->
    (coq_StrictInflationary_comp, coq_StrictInflationary_comp) sum ->
    (carrier, (carrier, __) sigT) sigT **)

let strictInflationary_comp s f g app_f app_g = function
  | Coq_inl sia ->
      let Coq_existT (x0, s0) = sia __ __ in
      let Coq_existT (f0, _) = s0 in
      Coq_existT (x0, (Coq_existT ((Obj.magic (Coq_inl f0)), __)))
  | Coq_inr sib ->
      let Coq_existT (x0, s0) = sib __ __ in
      let Coq_existT (f0, _) = s0 in
      Coq_existT (x0, (Coq_existT ((Obj.magic (Coq_inr f0)), __)))

(** val strictDeflationary_comp :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) ->
    (coq_StrictDeflationary_comp, coq_StrictDeflationary_comp) sum ->
    (carrier, (carrier, __) sigT) sigT **)

let strictDeflationary_comp s f g app_f app_g = function
  | Coq_inl sia ->
      let Coq_existT (x0, s0) = sia __ __ in
      let Coq_existT (f0, _) = s0 in
      Coq_existT (x0, (Coq_existT ((Obj.magic (Coq_inl f0)), __)))
  | Coq_inr sib ->
      let Coq_existT (x0, s0) = sib __ __ in
      let Coq_existT (f0, _) = s0 in
      Coq_existT (x0, (Coq_existT ((Obj.magic (Coq_inr f0)), __)))

(** val hasId_back_a :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) -> coq_HasIdentity ->
    coq_HasIdentity **)

let hasId_back_a s f g app_f app_g x =
  x

(** val hasId_back_b :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) -> coq_HasIdentity ->
    coq_HasIdentity **)

let hasId_back_b s f g app_f app_g x =
  x

(** val strict_comp :
    coq_Semigroup -> coq_DecSetoid -> coq_DecSetoid -> (carrier -> carrier ->
    carrier) -> (carrier -> carrier -> carrier) -> (coq_Strict_comp,
    coq_Strict_comp) sum -> coq_Strict_comp **)

let strict_comp s f g app_f app_g x hasId =
  match x with
    | Coq_inl sa ->
        let Coq_existT (f0, _) = sa hasId in
        Coq_existT ((Obj.magic (Coq_inl f0)), __)
    | Coq_inr sb ->
        let Coq_existT (f0, _) = sb hasId in
        Coq_existT ((Obj.magic (Coq_inr f0)), __)

(** val unionSemigroupTransform :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_IdSmgIso ->
    coq_SemigroupTransform **)

let unionSemigroupTransform a b f =
  let { SemigroupTransform.setoid = setoid0; op = x; SemigroupTransform.fn =
    x0; SemigroupTransform.app = x1 } = a
  in
  let { choose = chooseA; equal = equalA } = setoid0 in
  let { SemigroupTransform.setoid = setoid1; op = x2; SemigroupTransform.fn =
    x3; SemigroupTransform.app = x4 } = b
  in
  let { choose = chooseB; equal = equalB } = setoid1 in
  unionSemigroupTransform_SgEq
    (semigroupST { SemigroupTransform.setoid = { choose = chooseA; equal =
      equalA }; op = x; SemigroupTransform.fn = x0; SemigroupTransform.app =
      x1 }) x0 x3 x1 (fun l x5 -> f.phi' (x4 l (f.phi x5)))

(** val unionSTf_proj1 :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_IdSmgIso ->
    coq_IdSmgIso **)

let unionSTf_proj1 a b f =
  let { SemigroupTransform.setoid = setoid0; op = op0;
    SemigroupTransform.fn = fn0; SemigroupTransform.app = app0 } = a
  in
  let { choose = choose0; equal = equal0 } = setoid0 in
  let { SemigroupTransform.setoid = setoid1; op = op1;
    SemigroupTransform.fn = fn1; SemigroupTransform.app = app1 } = b
  in
  let { choose = choose1; equal = equal1 } = setoid1 in
  { phi = (fun x -> x); phi' = (fun x -> x) }

(** val unionSTf_proj2 :
    coq_SemigroupTransform -> coq_SemigroupTransform -> coq_IdSmgIso ->
    coq_IdTfIso **)

let unionSTf_proj2 a b f =
  let { SemigroupTransform.setoid = setoid0; op = op0;
    SemigroupTransform.fn = fn0; SemigroupTransform.app = app0 } = a
  in
  let { choose = choose0; equal = equal0 } = setoid0 in
  let { SemigroupTransform.setoid = setoid1; op = op1;
    SemigroupTransform.fn = fn1; SemigroupTransform.app = app1 } = b
  in
  let { choose = choose1; equal = equal1 } = setoid1 in
  { dsIso = { phi = (fun x -> x); phi' = (fun x -> x) }; fnIso = { phi =
  (fun x -> x); phi' = (fun x -> x) } }

