open DecSetoid
open DecSetoidProperties
open Semigroup
open SemigroupProperties
open Specif
open Unit

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val unit_op : carrier -> carrier -> carrier **)

let unit_op x y =
  Obj.magic ()

(** val unitSemigroup : coq_Semigroup **)

let unitSemigroup =
  { setoid = unitDecSetoid; op = (fun x y -> Obj.magic ()) }

(** val unitSmgIso : coq_Semigroup -> coq_IsSingleton -> coq_SmgIso **)

let unitSmgIso a sg =
  { phi = (fun x -> Obj.magic ()); phi' = (fun x -> projT1 sg) }

(** val hasIdentity : coq_HasIdentity **)

let hasIdentity =
  Coq_existT ((Obj.magic ()), __)

(** val hasAnnihilator : coq_HasAnnihilator **)

let hasAnnihilator =
  Coq_existT ((Obj.magic ()), __)

(** val antiLeft_comp : coq_AntiLeft_comp **)

let antiLeft_comp =
  Coq_existT ((Obj.magic ()), (Coq_existT ((Obj.magic ()), __)))

(** val antiRight_comp : coq_AntiRight_comp **)

let antiRight_comp =
  Coq_existT ((Obj.magic ()), (Coq_existT ((Obj.magic ()), __)))

