open Bisemigroup
open BisemigroupGlue
open BisemigroupPropRecord
open DecSetoidPropRecord
open SemigroupPropRecord

let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val swapBisemigroup_props : coq_Bisemigroup -> bsProp -> bsProp **)

let swapBisemigroup_props a ap =
  { bs_plus_sgprop =
    (projPlusBSmgIso (timesSmg a) (plusSmg a) ap.bs_times_sgprop);
    bs_times_sgprop =
    (projTimesBSmgIso (timesSmg a) (plusSmg a) ap.bs_plus_sgprop);
    isLeftDistributive =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isLeftDistributive_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isRightDistributive =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isRightDistributive_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); plusIdentityIsTimesAnnihilator =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match plusAnnihilatorIsTimesIdentity0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); plusIdentityIsTimesAnnihilator_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match plusAnnihilatorIsTimesIdentity_comp0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); plusAnnihilatorIsTimesIdentity =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match plusIdentityIsTimesAnnihilator0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); plusAnnihilatorIsTimesIdentity_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    (match plusIdentityIsTimesAnnihilator_comp0 with
       | Some a0 -> Some (Obj.magic __ a0)
       | None -> None)); isRightStrictStable =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isRightStrictStable_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isLeftStrictStable =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isLeftStrictStable_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isRightCompEqCancel =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isRightCompEqCancel_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isLeftCompEqCancel =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isLeftCompEqCancel_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isRightCompCancel =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isRightCompCancel_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isLeftCompCancel =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isLeftCompCancel_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); leftDiscrete =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); leftDiscrete_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); rightDiscrete =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); rightDiscrete_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); leftComparable =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); leftComparable_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); rightComparable =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); rightComparable_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); leftIncreasing =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); leftIncreasing_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); rightIncreasing =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); rightIncreasing_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); leftStrictIncreasing =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); leftStrictIncreasing_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); rightStrictIncreasing =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); rightStrictIncreasing_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isRightTimesMapToIdConstantPlus =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isRightTimesMapToIdConstantPlus_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isLeftTimesMapToIdConstantPlus =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); isLeftTimesMapToIdConstantPlus_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); plusIdentityIsTimesLeftAnnihilator =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); plusIdentityIsTimesLeftAnnihilator_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); plusIdentityIsTimesRightAnnihilator =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None); plusIdentityIsTimesRightAnnihilator_comp =
    (let { bs_plus_sgprop = bs_plus_sgprop0; bs_times_sgprop =
       bs_times_sgprop0; isLeftDistributive = isLeftDistributive0;
       isLeftDistributive_comp = isLeftDistributive_comp0;
       isRightDistributive = isRightDistributive0; isRightDistributive_comp =
       isRightDistributive_comp0; plusIdentityIsTimesAnnihilator =
       plusIdentityIsTimesAnnihilator0; plusIdentityIsTimesAnnihilator_comp =
       plusIdentityIsTimesAnnihilator_comp0; plusAnnihilatorIsTimesIdentity =
       plusAnnihilatorIsTimesIdentity0; plusAnnihilatorIsTimesIdentity_comp =
       plusAnnihilatorIsTimesIdentity_comp0; isRightStrictStable =
       isRightStrictStable0; isRightStrictStable_comp =
       isRightStrictStable_comp0; isLeftStrictStable = isLeftStrictStable0;
       isLeftStrictStable_comp = isLeftStrictStable_comp0;
       isRightCompEqCancel = isRightCompEqCancel0; isRightCompEqCancel_comp =
       isRightCompEqCancel_comp0; isLeftCompEqCancel = isLeftCompEqCancel0;
       isLeftCompEqCancel_comp = isLeftCompEqCancel_comp0;
       isRightCompCancel = isRightCompCancel0; isRightCompCancel_comp =
       isRightCompCancel_comp0; isLeftCompCancel = isLeftCompCancel0;
       isLeftCompCancel_comp = isLeftCompCancel_comp0; leftDiscrete =
       leftDiscrete0; leftDiscrete_comp = leftDiscrete_comp0; rightDiscrete =
       rightDiscrete0; rightDiscrete_comp = rightDiscrete_comp0;
       leftComparable = leftComparable0; leftComparable_comp =
       leftComparable_comp0; rightComparable = rightComparable0;
       rightComparable_comp = rightComparable_comp0; leftIncreasing =
       leftIncreasing0; leftIncreasing_comp = leftIncreasing_comp0;
       rightIncreasing = rightIncreasing0; rightIncreasing_comp =
       rightIncreasing_comp0; leftStrictIncreasing = leftStrictIncreasing0;
       leftStrictIncreasing_comp = leftStrictIncreasing_comp0;
       rightStrictIncreasing = rightStrictIncreasing0;
       rightStrictIncreasing_comp = rightStrictIncreasing_comp0;
       isRightTimesMapToIdConstantPlus = isRightTimesMapToIdConstantPlus0;
       isRightTimesMapToIdConstantPlus_comp =
       isRightTimesMapToIdConstantPlus_comp0;
       isLeftTimesMapToIdConstantPlus = isLeftTimesMapToIdConstantPlus0;
       isLeftTimesMapToIdConstantPlus_comp =
       isLeftTimesMapToIdConstantPlus_comp0;
       plusIdentityIsTimesLeftAnnihilator =
       plusIdentityIsTimesLeftAnnihilator0;
       plusIdentityIsTimesLeftAnnihilator_comp =
       plusIdentityIsTimesLeftAnnihilator_comp0;
       plusIdentityIsTimesRightAnnihilator =
       plusIdentityIsTimesRightAnnihilator0;
       plusIdentityIsTimesRightAnnihilator_comp =
       plusIdentityIsTimesRightAnnihilator_comp0 } = ap
     in
    let { sg_dsprop = sg_dsprop0; hasIdentity = hasIdentity0;
      hasIdentity_comp = hasIdentity_comp0; hasAnnihilator = hasAnnihilator0;
      hasAnnihilator_comp = hasAnnihilator_comp0; isSelective = isSelective0;
      isSelective_comp = isSelective_comp0; isCommutative = isCommutative0;
      isCommutative_comp = isCommutative_comp0; isIdempotent = isIdempotent0;
      isIdempotent_comp = isIdempotent_comp0; isLeft = isLeft0; isLeft_comp =
      isLeft_comp0; isRight = isRight0; isRight_comp = isRight_comp0;
      leftCondensed = leftCondensed0; leftCondensed_comp =
      leftCondensed_comp0; rightCondensed = rightCondensed0;
      rightCondensed_comp = rightCondensed_comp0; leftCancelative =
      leftCancelative0; leftCancelative_comp = leftCancelative_comp0;
      rightCancelative = rightCancelative0; rightCancelative_comp =
      rightCancelative_comp0; antiLeft = antiLeft0; antiLeft_comp =
      antiLeft_comp0; antiRight = antiRight0; antiRight_comp =
      antiRight_comp0; treeGlb = treeGlb0; treeGlb_comp = treeGlb_comp0 } =
      bs_times_sgprop0
    in
    let { sg_dsprop = sg_dsprop1; hasIdentity = hasIdentity1;
      hasIdentity_comp = hasIdentity_comp1; hasAnnihilator = hasAnnihilator1;
      hasAnnihilator_comp = hasAnnihilator_comp1; isSelective = isSelective1;
      isSelective_comp = isSelective_comp1; isCommutative = isCommutative1;
      isCommutative_comp = isCommutative_comp1; isIdempotent = isIdempotent1;
      isIdempotent_comp = isIdempotent_comp1; isLeft = isLeft1; isLeft_comp =
      isLeft_comp1; isRight = isRight1; isRight_comp = isRight_comp1;
      leftCondensed = leftCondensed1; leftCondensed_comp =
      leftCondensed_comp1; rightCondensed = rightCondensed1;
      rightCondensed_comp = rightCondensed_comp1; leftCancelative =
      leftCancelative1; leftCancelative_comp = leftCancelative_comp1;
      rightCancelative = rightCancelative1; rightCancelative_comp =
      rightCancelative_comp1; antiLeft = antiLeft1; antiLeft_comp =
      antiLeft_comp1; antiRight = antiRight1; antiRight_comp =
      antiRight_comp1; treeGlb = treeGlb1; treeGlb_comp = treeGlb_comp1 } =
      bs_plus_sgprop0
    in
    let { isSingleton = isSingleton0; isSingleton_comp = isSingleton_comp0;
      twoElements = twoElements0; twoElements_comp = twoElements_comp0;
      finite = finite0; finite_comp = finite_comp0 } = sg_dsprop0
    in
    let { isSingleton = isSingleton1; isSingleton_comp = isSingleton_comp1;
      twoElements = twoElements1; twoElements_comp = twoElements_comp1;
      finite = finite1; finite_comp = finite_comp1 } = sg_dsprop1
    in
    None) }

